// @(#)$Id: method_spec_between.java,v 1.2 2003/10/17 02:41:21 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.bugs;

public abstract class method_spec_between {

    //@ public model int val;
    protected int _val; //@ in val;
    //@ protected represents val <- _val;

    public void inc()
    /*@ public normal_behavior
      @   requires val >= 0;
      @   ensures val == \old(val) + 1;
      @*/
    {
        _val++;
    }

    public abstract int getVal()
    /*@  public normal_behavior
      @     ensures \result == val;
      @*/
      ;

    /**
     * <pre><jml>
     *   requires val <= 0;
     *   ensures  val == \old(val) - 1;
     * </jml></pre>
     */
    public void dec()
    /*@ also
      @   public normal_behavior
      @     requires val >= 0;
      @     ensures val == \old(val) - 1;
      @*/
    {
        _val--;
    }
}
