// @(#)$Id: CharacterPlay2.java,v 1.2 2002/10/28 12:18:38 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

import java.lang.Character;

// A little class to experiment with the Java character class
//
// AUTHOR: Curtis Clifton

public class CharacterPlay2 {
    static final String blank = new String();

    public static void main(String[] args) {
        int i;
        String s1, s2;
        s2 = "";
        for (i = 0x0000; i < 0x10000;) {
            do {
                s1 = myOut(i) + s2;
                s2 = s1;
                i++;
            } while (s1.equals(blank));

            System.out.println(s1);
        }
    }
    
    private static String myOut(int i) {
        String s1;
        if (i > 0xFFFF) {
            s1 = new String("-");
        } else {
            if (Character.isDefined((char) i) && 
                Character.getNumericValue((char) i) != -1) {
                char c = (char) i;
                s1 = new String ("int " + i + ", char " + c 
                                 + ", val " 
                                 + Character.getNumericValue(c)
                                 + ", type " + Character.getType(c));
            } else {
                s1 = new String();
            }
        }

        return s1;
    }
}
