// @(#)$Id: InitializedArray.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public class InitializedArray  {

    static class X {};

    static X x = new X();

    static int PLUS = 0;

    static double[] vecok = { 1.0, 2.0, 3.0};

    static int[] vec = { 1, PLUS, 3};

    // 2.4 does not like this
    static int[][] array =
        {{ PLUS,1},
            {2,3}
        };

    static X[] xx = { x, x};

    static X[][] xxx = { { x,x}, {x,x,x}};

}
