// @(#)$Id: KeywordParsingE.java,v 1.5 2005/05/30 18:40:55 leavens Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

public class KeywordParsingE { 

    //@ private pure model method helper f() { return null; }
    //@ public model class T0 extends helper { /* ... */ }
   
    //@ model field int x0;
    //@ model field Object ensures;
    //@ ghost field helper.T x1;
    //@ model method helper.T m1();
    //@ model method int model();
    //@ model class T1 extends helper { /* ... */ }

    class f {
        //@ private pure model helper constructor f(int x) {}
        //@ private pure model helper f() {}   // parsed as a constructor for f
    }

    //@ public model class T2 extends helper { /* ... */ }
   
    //@ model int x3;
    //@ ghost field helper.T x4;
    //@ model method helper.T m2();
    //@ model method int monitored(int y);
    //@ model class T extends helper { /* ... */ }
 
    //@ represents x0 <- x5;
    //@ represents ensures <- x4;
    //@ represents x3 <- x5;

    int x5;
} 

class helper {
    class TSuper {}
    class T {}
}
