// @(#)$Id: TestSetComprehension.java,v 1.3 2004/07/22 16:19:00 kui_dai Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

import org.jmlspecs.models.*;

public class TestSetComprehension
{
  protected int size = 0;
  protected JMLValueSet theSet ;// = new JMLValueSet ();

  /*@ protected normal_behavior
    @   assignable size, theSet;
    @   ensures theSet.equals(new JMLValueSet {JMLInteger i | 
    @                              JMLModelValueSet.JMLIntegers().has(i)
    @                              && lo <= i.theInt
    @                              && i.theInt <= hi })
    @            && size == theSet.int_size();
    @*/
  public  TestSetComprehension(int lo, int hi)
  {
  }

  /*@ protected normal_behavior
    @   assignable size, theSet;
    @   ensures theSet.equals(new JMLValueSet {JMLInteger i | 
    @                              JMLModelValueSet.JMLIntegers().has(i)
    @                              && lo <= i.theInt
    @                              && i.theInt <= hi })
    @            && size == theSet.int_size();
    @*/
  public void newIntSet(int lo, int hi)
  {
  }

  /*@ protected normal_behavior
    @   assignable size, theSet;
    @   ensures theSet.equals(new JMLValueSet {JMLInteger k | 
    @                              JMLModelValueSet.JMLIntegers().has(k)
    @                              && 0 <= k.theInt
    @                              && k.theInt <= hi })
    @            && size == theSet.int_size();
    @*/
  public void firstN_IntSet(int hi)
  {
  }

}
