// @(#)$Id: arrayofint.java,v 1.2 2003/09/10 04:02:09 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public class arrayofint {
    public int [] a;

    /*@   assignable a, a[0], a[1], a[2];
      @ also
      @   assignable a[0], a[1], a[2];
      @   ensures a[0] == 1 && a[1] == 2;
      @*/
    public arrayofint(int i)
    {
	a = new int[i];
	for (int k = 0; k < i; k++) { a[k] = 0; }
    }

    /*@   assignable a, a[0 .. 2];
      @ also
      @   assignable a[*];
      @   ensures a[0] == 1 && a[1] == 2;
      @*/
    public arrayofint()
    {
	int [] b = { 1, 2 , 3 };
	a = b;
    }

}
