// @(#)$Id: call_to_inherited_overloaded.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

interface mySuperSuperInterface
{
    public int foo(Object x);
}

abstract class mySuperSuper implements mySuperSuperInterface
{
    public int foo(Object x) { return -1; }
}

abstract class mySuper extends mySuperSuper implements mySuperSuperInterface
{
    public int foo(Object x) { return 0; }
    public synchronized int foo(Object x, int y) { return 1; }
}

public abstract class call_to_inherited_overloaded extends mySuper
{
    public int doit(Object o) {
        int i = foo(o);

        if (i >= 0) {
            return i;
        }
        return -1;
    }
}
