// @(#)$Id: conditional_store_ref.java,v 1.10 2005/09/07 19:42:14 cruby Exp $

// Copyright (C) 2002-3 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public /*@spec_bigint_math@*/ class conditional_store_ref
{
    /*@ spec_public @*/ int x;
    /*@ spec_public @*/ int y;

  /*@ public normal_behavior
    @   assignable x;
    @ also
    @ code behavior assignable x;
    @   accessible x;
    @*/
  public void set_x (int t)

    {
    }  

  /*@ public normal_behavior
    @   assignable y, x;
    @   assignable_redundantly y;
    @   working_space x + \space(this) if false;
    @   duration x if false;
    @   
    @ also
    @ code behavior assignable x;
    @      accessible x;
    @      measured_by x if false;
    @*/
  public void set_y (int t)
    {
    }  

}
 
