// @(#)$Id: Inner.java,v 1.4 2003/10/12 05:24:49 cruby Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.jmldoc;

public class Inner
{
    /*@
      @  public behavior
      @       ensures false;
      @       assignable \nothing;
      @       signals (Exception e) e != null;
    */
    public void foo()
    {
	foo(0);
    }

    //@    assignable \nothing;
    private int foo(int i)
    {	
	return 0;
    }


    public class Within
    {
        public Within()
        { Hello();
        }

        private void Hello()
        {
        }
        int i;

        /*@
          @ public normal_behavior
          @  ensures true;
          @  assignable \nothing;
        */
        public int foo()
        { return 342; }
    }
}
