// @(#)$Id: let_var_decls.java,v 1.5 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public /*@spec_bigint_math@*/ class let_var_decls {

    //@ public model int val;
    protected int _val;
    //@              in val;
    //@ protected represents val <- val;

    /*@ public normal_behavior
      @   forall int i;
      @   old int two = 2, three = 3;
      @   old int one = 1;
      @   requires j == i;
      @   assignable val;
      @   ensures val == i + one + two + (three - three);
      @*/
    public let_var_decls(int j) { _val = j + 3; }

    /*@ public normal_behavior
      @   forall int I; forall boolean B;
      @   requires val == I;
      @   assignable val;
      @   ensures val == I + 1 && B == B;
      @*/
    public void inc() { _val++; }
}
