// @(#)$Id: refining.java,v 1.1 2007/04/22 21:03:33 smshaner Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;

public class refining {

    public void m(int x) {
	/*@ refining normal_behavior
	  @   requires x > 0;
	  @   ensures x < 5;
	  @*/
	x = 5 - x;

	int y = x + 1;
	/*@ refining behavior
	  @   requires x <= 5;
	  @   requires y > x;
	  @   assignable x, y;
	  @   ensures y <= x;
	  @   ensures x == 5;
	  @*/
	{
	    y -= x;
	    x = 5;
	}
    }
}
