// @(#)$Id: Point.java,v 1.3 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker.BoundedColorPoint;

public /*@spec_bigint_math@*/ class Point {			      
					      
    protected int x;			      
    protected int y;			      
    //@ protected invariant x * y < Integer.MAX_VALUE;

    /*@  protected normal_behavior	      
      @     requires _x >= 0 && _y >= 0 ;     
      @     assignable x, y;
      @     ensures x == _x && y == _y;      
      @*/				      
    protected void setPoint (int _x, int _y)  
    {					      
        x = _x;				      
        y = _y;				      
    }					      
}					      
