// @(#)$Id: Inherit.java,v 1.2 2002/10/28 12:18:38 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

// Check multiple requires and precondition inheritance
// Expected output: __jml = __jml3 && __jml4;
//                  __jml2 = __jml5 && __jml6;
//                  __jml0 = __jml1 || __jml2;

class PosMax {

    /*@
      @ requires x >= 0;
      @ requires y >= 0;
      @*/
    int max(int x, int y) {
	if (x > y)
	    return x;
	else
	    return y;
    }
}

class Inherit extends PosMax {

    /*@ also
      @ requires x > 0;
      @ requires y > 0;
      @*/
    int max(int x, int y) {
	if (x > y)
	    return x;
	else
	    return y;
    }
}
