// @(#)$Id: blank_final_and_locals.java,v 1.2 2004/07/09 15:56:30 f_rioux Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

/*@spec_bigint_math@*/ class blank_final_and_locals {

    final int x;
    final int y;
    final int z;

    //@ ensures this.x == x && y == 10 && z == x + 10;
    blank_final_and_locals(int x) // shadow this.x
    {
	int y = 10; // shadow this.y
	this.x = x;
	this.y = y;
	z = this.x + this.y;
	
	//class inner {
	//    inner() {}
	//    int doIt() {
	//	int x; // shadow this.x
	//	x = 0;
	//	return x;
	//    }
	//}
    }
}
