// @(#)$Id: final_var_in_constructor.java,v 1.1 2002/06/25 03:38:49 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

// no try-finally for constructor with final variables.
// coz can produce "vars may not be initialized errors."

class final_var_in_constructor {
    public final int i;

    //@ requires i > 0;
    //@ ensures this.i > 0;
    public final_var_in_constructor(int i) {
	this.i = i;
    }
}
