// @(#)$Id: gen_type_extent.java,v 1.1 2002/06/25 03:38:49 leavens Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

interface gen_type_exent_inf {
    // should generate no type extent for interface
}

class gen_type_extent_no_default_constructor {

    final int val;

    gen_type_extent_no_default_constructor()
    {
	val = 100;
    }
}

class gen_type_extent {

    int val;
    gen_type_extent(int x) {
	val = x;
    }

    // no extent add code for constructor with this call
    gen_type_extent() {
	this(0);
    }

    // no type extent for innerclass
    class innerclass {
	public innerclass() {}
    }

    // no type extent for anonymous class
    Object use_of_anonymous() {
	return new Object() {
		boolean eval(int x) {
		    return x > 0;
		}
	    };
    }
}
