// @(#)$Id: nested_quanti.java,v 1.3 2004/07/09 15:56:30 f_rioux Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

/*@spec_bigint_math@*/ class nested_quanti {

    class nested_quanti_inner {
    }

    int v1;
    int v2;

    public nested_quanti(int x, int y) {
	v1 = x; v2 = y; 
    }

    /*@ 
      @ ensures (\forall nested_quanti q1; q1.v1 > 0;
      @   (\forall nested_quanti q2; q2.v1 > 0; q1.v2 + q2.v2 > x));
      @*/
    void doIt(int x, int y) {}

    public static void main(String args[]) {
	nested_quanti q1 = new nested_quanti(1,10);
	nested_quanti q2 = new nested_quanti(1,30);
	nested_quanti q3 = new nested_quanti(-1,-40);

	int x = 15;
	final int y = -10;
	q1.doIt(x,y);
        q2.doIt(x,y);
        q3.doIt(x,y);
    }
}
