// @(#)$Id: spec_public.java,v 1.2 2002/10/28 12:18:38 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

class spec_public {

    class T {
    }

    private /*@ spec_public @*/ int x, y[];
    private /*@ spec_protected @*/ int[] z, z1[];
    private /*@ spec_protected @*/ T t1, t2[], t3;

    //@ requires y != null && z != null && t2 != null;
    //@ requires x2 > y[0] && y[1] > z[0] && t1 != t2[0];
    protected void fun(int x2) {
        if (x2 == 0) x = 1 + x;
        if (z1 == null) z1 = new int[3][4];
        if (t3 == null) t3 = new T();
    }
}
