// @(#)$Id: spec_visibility.java,v 1.3 2003/01/11 04:46:47 davidcok Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

class super_super_spec1 {

    //@ requires x > 10;
    //@ ensures x > 11;
    public void foo(int x) {
    }
}

class super_spec1 extends super_super_spec1 {

    //@ also requires y > 100; ensures y > 100;
    //@ also public behavior requires y > 200; modifies \nothing;
    public void foo(int y) {
    }
}

class spec_visibility extends super_spec1 {

    /*@ also
      @   requires z > 3000;
      @   ensures z > 4000;
      @*/
    public void foo(int z) {
    }
}
