// @(#)$Id: unparsethis.java,v 1.4 2005/03/27 17:48:40 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public abstract class unparsethis {

    //@ ghost int x;
    int fluff;
    int[] ma = new int[7];
    int[][] maa = new int[2][3];

    public /*@ pure @*/ String stringliterals () {
        return "\\" + "\n\r\b\f\r\"\'\u0001";
    }

    public /*@ pure @*/ boolean precedencetest() {
        boolean x = ((3 + (4 * 7 * 9) - (8 % 2) >> 1) == 17 && 5 + 4 != 20) || (3 + 5 == 9);
        x = !x;
        return 3 + 4 * 7 * 9 - 8 % 2 >> 1 == 17 && 5 + 4 != 20 || 3 + 5 == 9;
    }

    public int test2 () {
        int a = 3 + 4 * 7;
        boolean b = 3.14159  < 7.5 == 1.4 < 3.9;
        char c = 'c' >> 2;
        int d = 0112 ^ 0101 & 01010 | 0001;
        if (b && c == d) { return a * a + 7; } else { return a; }
    }

    public void assigntest() {
        this.fluff = 5 + 7 + 3;
        this.ma[2] = 3;
        this.maa[0][0] = 4;
    }

    /*@   public normal_behavior
      @     requires o instanceof unparsethis ;
      @     ensures \result <==> true;
      @ also
      @   public normal_behavior
      @     requires !(o instanceof unparsethis);
      @     ensures \result == false;
      @ also
      @   public exceptional_behavior
      @     requires false;
      @     signals_only Exception;
      @     signals (Exception e);
      @ public model pure boolean is_it_like_me(Object o);
      @*/

    abstract class nestedupt {
        int q;
        /*@ public pure model int bar1(int r) { return 3; } @*/
    }

}

/*@
  @ model class mcls {
  @   public mcls() {}
  @   model int x;
  @   abstract class nestedupt2 {
  @       model int y;
  @       public model int bar(int r) { return 1; }
  @   }
  @   ghost int y;
  @   public pure model int foo(int z) {
  @      return z;
  @   }
  @   represents x <- foo(y);
  @ }
  @*/
