// Visibility check for accessible clauses

public class AccessiblePrivacy {
    
    // variables
    public int xpub;
    protected int xpro;
    private int xpri;
    int xpkg;

    //@ public behavior assignable xpub;
    //@   accessible xpub;
    //@   accessible xpro; // ERROR
    //@   accessible xpkg; // ERROR
    //@   accessible xpri; // ERROR
    public void m1() {}

    //@ protected behavior assignable xpub;
    //@   accessible xpub;
    //@   accessible xpro;
    //@   accessible xpkg; // ERROR
    //@   accessible xpri; // ERROR
    protected void m2() {}

    //@  behavior assignable xpub;
    //@   accessible xpub;
    //@   accessible xpro;
    //@   accessible xpkg;
    //@   accessible xpri; // ERROR
    void m3() {}

    //@ private behavior assignable xpub;
    //@   accessible xpub;
    //@   accessible xpro;
    //@   accessible xpkg;
    //@   accessible xpri;
    private void m4() {}
}

// @(#)$Id: AccessiblePrivacy.java,v 1.3 2005/09/07 19:42:14 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
