
package org.jmlspecs.checker.testcase.typecheck;

//@ refine "AlsoErrClass.jml-refined";

public class AlsoErrClass {
    protected int val_;
    //@              in val;

    //@ protected represents val <- val_;

    /*@ 
      @   protected normal_behavior
      @     assignable val;
      @     ensures val_ == newVal;
      @*/
    public AlsoErrClass(int newVal) {
	val_ = newVal;
    }

    /*@ 
      @   protected normal_behavior
      @     ensures \result == val_;
      @*/
    public /*@ pure @*/ int get( ) {
	return val_;
    }
}
