
package org.jmlspecs.checker.testcase.typecheck;

//@ refine "AlsoErrSubClass.jml-refined";

public class AlsoErrSubClass extends AlsoErrClass implements AlsoErrInterface {

    /*@ 
      @   public normal_behavior
      @     assignable val;
      @     ensures val == newVal;
      @*/
    public AlsoErrSubClass(int newVal);

    /*@
      @   protected normal_behavior
      @     assignable val_;
      @     ensures val_ == newVal;
      @*/
    public void put(int newVal) {
	val_ = newVal;
    }

    /*@ 
      @   protected normal_behavior
      @     assignable val_;
      @     ensures val_ == newVal && \result == \pre(val_);
      @*/
    public int putGet( int newVal ) {
	int oldVal = val_;
	val_ = newVal;
	return oldVal;
    }

    //@ protected represents xVal <- val_;
}
