class Callable2 {

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable m(), this.m(int), m(byte), m(short), m(int), m(long);
      @*/
    public void foo() {}

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable m(float), m(double), m(char), m(boolean), m(String);
      @*/
    public void foo1() {}

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable m(Object), super.clone(), this.equals(Object);
      @*/
    public void foo3() {}

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable Callable2.foo(), m(int[]);
      @     callable foo6, m;  // foo6 OK (not overloaded), but m is an Error
      @     callable Callable2.foo6, Callable2.m;  // foo6 OK, but m is Error
      @     callable equals; // OK since inherited from Object & not overloaded
      @*/
    public void foo4() {}

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable m(int,int), m(Integer), m(Integer[]); // 3 Errors
      @*/
    public void foo5() {}

    public void foo6(int x) {}

    /*@ spec_public @*/ void m() {}
    /*@ spec_public @*/ void m(byte x) {}
    /*@ spec_public @*/ void m(short x) {}
    /*@ spec_public @*/ void m(int x) {}
    /*@ spec_public @*/ void m(long x) {}
    /*@ spec_public @*/ void m(float x) {}
    /*@ spec_public @*/ void m(double x) {}
    /*@ spec_public @*/ void m(char x) {}
    /*@ spec_public @*/ void m(boolean x) {}
    /*@ spec_public @*/ void m(String x) {}
    /*@ spec_public @*/ void m(Object x) {}
    /*@ spec_public @*/ void m(Object[] x) {}
    /*@ spec_public @*/ void m(int[] x) {}
}

// @(#)$Id: Callable2.java,v 1.6 2005/10/07 07:31:23 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
