
abstract class SuperDataGroup {
    //@ public model Object obj;

    //@ public model JMLDataGroup grp1, grp3;
}

public class DataGroup extends SuperDataGroup {

    //@ public model JMLDataGroup grp1, grp2, grp3;
    //@                           in super.grp1, super.grp3;

    protected /*@ spec_public @*/ int it1;
    /*@             in obj, grp3;
      @	            in it1;  // OK (although redundant)
      @*/

    //@ public model Object obj;
    //@                     in super.obj;
    //@ protected represents obj <- (it1 < 0)? null : makeInteger(it1);

    // the following represents clause is needed because it's 
    // not a JMLDataGroup
    //@ public represents super.obj <- obj;

    protected Object x, y;
    /*@                in obj, this.grp3, super.grp3;
      @	               maps x.owner \into grp1;
      @	               maps y.owner \into this.grp2;
      @	               maps y.objectState \into this.grp3;
      @	               maps x.objectState \into super.grp3;
      @	               maps x.* \into grp3;
      @*/

    protected Object v[], w[];
    /*@                in obj, grp3, it1;
      @	               maps w[*].* \into grp2, it1;
      @	               maps v[*].owner \into this.grp1, it1;
      @	               maps w[*].owner \into super.grp1;
      @*/

    protected int z[];

    public /*@ pure @*/ Object makeInteger(int i) {
	return new Integer(i);
    }
}
