public class MethodPureness2 extends MethodPureness2Super {

    //@ requires val1() > x; // OK
    public void m1(int x) {}

    //@ requires val2() > x; // OK
    public void m2(int x) {}

    //@ requires val3() > x; // ERROR
    public void m3(int x) {}

    // overriding inherited val2, but no pure annotation.
    public int val2() { return 0; }

    /*@ spec_public @*/ static private int val3() {
        return 0;
    }
}

class MethodPureness2Super {
    public /*@ pure @*/ int val1() { return 10; }

    public /*@ pure @*/ int val2() { return 10; }

    /*@ spec_public @*/ static private int val3() {
        return 0;
    }
}

// @(#)$Id: MethodPureness2.java,v 1.1 2002/10/29 03:40:04 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
