// @(#)$Id: NondetChoiceTest3.java,v 1.1 2005/08/04 05:32:26 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// from Steve Shaner

package org.jmlspecs.checker.testcase.typecheck;

import java.util.*;

public abstract class NondetChoiceTest3 {

    private /*@ spec_public @*/ int lastValue;

    /*@ public model_program
      @ {
      @   int x = 3;
      @   choose { x = 0; }
      @     or { x = 1; }
      @     or { x = 2; }
      @   return x;
      @ }
      @*/
    public int shortRandomJump() {
	Random r = new Random();
	return r.nextInt(3);
    }
}
