// Also see non_null1.java

import org.jmlspecs.models.*;

public class Nullable1 {

    void m1(/*@ nullable @*/ Object x) {}

    void m2(/*@ nullable @*/ int[] x) {}

    void m3(/*@ nullable @*/ boolean x) {}

    void m4(/*@ nullable @*/ byte x) {}

    void m5(/*@ nullable @*/ char x) {}

    void m6(/*@ nullable @*/ short x) {}

    void m7(/*@ nullable @*/ int x) {}

    void m8(/*@ nullable @*/ long x) {}

    void m9(/*@ nullable @*/ float x) {}

    void m10(/*@ nullable @*/ double x) {}
}

class nullable {} // nullable is not a reserved word hence this is legal.

class Nullable11 {
    //@ invariant (\exists nullable nullable n; true);	// legal
    //@ invariant (\exists non_null nullable n; true);	// legal
}

// @(#)$Id: Nullable1.java,v 1.3 2006/02/11 03:06:42 chalin Exp $
//
// Copyright (C) 2006 Iowa State University
//
// This file is part of JML.
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
