public class PureAndAssignable {
    int x;

    // ERROR
    //@ assignable x; 
    /*@ pure @*/ int m1() { return 0; }

    // OK
    //@ assignable x; 
    /*@ pure @*/ PureAndAssignable() {}

    // OK
    //@ assignable \nothing;
    /*@ pure @*/ int m2() { return 0; }

    // OK
    //@ assignable \not_specified;
    /*@ pure @*/ int m3() { return 0; }

    // OK
    //@ assignable x;
    int m4() { return 0; }

    // OK
    //@ assignable \nothing;
    int m5() { return 0; }

    // OK
    //@ assignable \not_specified;
    int m6() { return 0; }
}

// @(#)$Id: PureAndAssignable1.java,v 1.1 2003/02/01 17:49:18 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
