// This file should be tested at least with warning level 3, i.e.,
// command-line option -w3.

public class PureAndSynchronized2 extends PureAndSynchronized2Super {

    // OK
    /*@ pure @*/ void m1() {}

    // ERROR
    /*@ pure @*/ synchronized void m2() {}

    // SB_ERROR as m3 inheriting pure from superclass?
    synchronized void m3() {}
}

class PureAndSynchronized2Super {
    synchronized void m1() {}
    synchronized void m2() {}
    /*@ pure @*/ void m3() {}
}

// @(#)$Id: PureAndSynchronized2.java,v 1.1 2003/03/25 03:22:48 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
