
public class PureCallTest {
    private Value store = new Value();
    private boolean value;

    /*@ private behavior 
      @     requires check(store);
      @     assignable \nothing;
      @*/
    public boolean isOK () {
        check(store);
        return store.isOK();
    }
    public static /*@ pure @*/ boolean check (Value b) {
        b.makeOK();
	b.value = true;
        return b.isOK();
    }

    class Value {
        boolean value = false;

	//@ assignable \nothing;
	boolean isOK () {
	    makeOK ();
	    return value;
	}
	//@ assignable value;
        void makeOK () {
            value = true;
        }
    }

    public static void main (String[] args) {
        PureCallTest a = new PureCallTest();
        System.out.println(a.isOK());
    }
}
