public class QualifiedNameVisibility {
    static class Cpkg {
        /*@ spec_public @*/ static class CPub {
        }
        private static class CPri {
        }
        int ypkg;
    }
    
    //@ requires new Cpkg.CPub() != null; // OK
    //@ requires new Cpkg.CPri() != null; // OK
    private void m1() {}

    //@ requires new Cpkg.CPub() != null; // OK
    //@ requires new Cpkg.CPri() != null; // ERROR
    void m2() {}

    //@ requires new Cpkg.CPub() != null; // ERROR
    //@ requires new Cpkg.CPri() != null; // ERROR
    protected void m3() {}

    //@ requires new Cpkg.CPub() != null; // ERROR
    //@ requires new Cpkg.CPri() != null; // ERROR
    public void m4() {}

    Cpkg xpkg;

    //@ requires xpkg.ypkg > 0; // ERROR
    public void m5() {}

    //@ requires xpkg.ypkg > 0; // ERROR
    protected void m6() {}

    //@ requires xpkg.ypkg > 0; // OK
    void m7() {}

    //@ requires xpkg.ypkg > 0; // OK
    private void m8() {}
}

// @(#)$Id: QualifiedNameVisibility.java,v 1.1 2002/09/13 00:53:12 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
