
package org.jmlspecs.checker.testcase.typecheck;

//@ refine "RefineErrClass.jml-refined";

public class RefineErrClass {
    protected int val1_ = 0;
    //@             in val1;
    protected int val2_ = 0;
    //@             in val2;

   //@ protected represents val1 <- val1_;
   //@ protected represents val2 <- val2_;

    /*@  also
      @   protected normal_behavior
      @     assignable val1_, val2_;
      @     ensures newV1 == val1_ && newV2 == val2_;
      @*/
    public RefineErrClass(int newV1, int newV2 ) {
	val1_ = newV1;
	val2_ = newV2;
    }

    /*@  also
      @   protected normal_behavior
      @     assignable val1_, val2_;
      @     ensures newV1 == val1_ && newV2 == val2_;
      @*/
    public void put( int newV1, int newV2 ) {
	val1_ = newV1;
	val2_ = newV2;
    }
}
