// Visibility check for represents clauses

public class RepresentsPrivacy {
    
    // model variables
    //@ model public int mpub;
    //@ model protected int mpro;
    //@ model private int mpri;
    //@ model int mpkg;

    // concrete variables
    public int xpub;
    protected int xpro;
    private int xpri;
    int xpkg;

    // variables
    public RepresentsPrivacy fpub;
    protected RepresentsPrivacy fpro;
    private RepresentsPrivacy fpri;
    RepresentsPrivacy fpkg;

    //@ public represents mpub <- xpub;
    //@ public represents mpro <- xpub; // ERROR
    //@ public represents mpri <- xpub; // ERROR
    //@ public represents mpkg <- xpub; // ERROR

    //@ protected represents mpub <- xpub;
    //@ protected represents mpro <- xpub; 
    //@ protected represents mpri <- xpub; // ERROR
    //@ protected represents mpkg <- xpub; // ERROR

    //@ represents mpub <- xpub;
    //@ represents mpro <- xpub; 
    //@ represents mpri <- xpub; // ERROR
    //@ represents mpkg <- xpub;

    //@ private represents mpub <- xpub;
    //@ private represents mpro <- xpub; 
    //@ private represents mpri <- xpub; 
    //@ private represents mpkg <- xpub;

    //@ public represents mpub <- xpub;
    //@ public represents mpub <- xpro; // ERROR
    //@ public represents mpub <- xpkg; // ERROR
    //@ public represents mpub <- xpri; // ERROR

    //@ protected represents mpro <- xpub;
    //@ protected represents mpro <- xpro; 
    //@ protected represents mpro <- xpkg; // ERROR
    //@ protected represents mpro <- xpri; // ERROR

    //@ represents mpkg <- xpub;
    //@ represents mpkg <- xpro; 
    //@ represents mpkg <- xpkg; 
    //@ represents mpkg <- xpri; // ERROR

    //@ private represents mpri <- xpub;
    //@ private represents mpri <- xpro; 
    //@ private represents mpri <- xpkg; 
    //@ private represents mpri <- xpri;




    /*@ spec_public @*/ Inner ipub;
    //@ public represents ipub.x <- xpub;    // ERROR

    class Inner {
	//@ public model int x;
	//@ represents x <- x_;
	int x_;
    }
}

// @(#)$Id: RepresentsPrivacy.java,v 1.2 2003/08/07 06:20:23 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
