import org.jmlspecs.models.*;
import java.util.*;

class SetComprehension1 {

    Collection c;
    JMLValueSet d;

    // OK
    //@ ensures new JMLObjectSet {Object o | c.contains(o) && o != x }.int_size()
    //@         > 0;
    void m1(Object x) {}

    // OK
    //@ ensures new JMLValueSet {JMLType o | d.has(o) && o != x }.int_size() > 0;
    void m2(Object x) {}

    // ERROR
    //@ ensures new HashSet {Object o | c.has(o) && o != x }.size() > 0;
    void m3(Object x) {}
}
