class behavior_spec {

    //@ behavior
    //@  requires true;
    //@  assignable this.*;
    //@  ensures true;
    //@  signals (RuntimeException e) false;
    void m() {}

    //@ normal_behavior
    //@  requires x;      // ERROR: x is not defined
    //@  assignable this.*;
    //@  ensures y;      // ERROR: y is not defined
    void m1() {}


    //@ exceptional_behavior
    //@  requires y;      // ERROR: y is not defined
    //@  assignable this.*;
    //@  signals (RuntimeException e) true;
    void m2() {}

    // ERROR
    //@ behavior
    //@  requires 0;      // ERROR: 0 is not boolean valued
    //@  assignable this.*;
    //@  ensures 0;       // ERROR: 0 is not boolean valued
    //@  signals (RuntimeException e) 0; // ERROR: 0 is not boolean valued
    void m10() {}

}
