class fields_of {
    int a[];
    Object objs[];
    int i;

    //@ assignable this.*;
    void m() {}

    //@ assignable a[*];
    void m1() {}

    //@ assignable objs[*], objs[*].*;
    void m2() {}

    // ERROR: ref type expected
    //@ assignable i.*;
    void m3() {}

    // ERROR: ref type expected
    //@ assignable a[*].*;
    void m4() {}

    // ERROR: ref type expected
    //@ assignable a.*;
    void m5() {}

    class T {
	int x;
    }
    T t;

    //@ assignable t.*;
    void m6() {}

    // ERROR: Object is not a member of this
    //@ assignable this.Object;
    void m7() {}

    // ERROR: x is not a member of int ( 'a[*]' )
    //@ assignable a[*].x;
    void m8() {}

    // ERROR: x is not a member of 'a'
    //@ assignable a.x;
    void m9() {}

    // ERROR: y is not member of t
    //@ assignable t.y;
    void m10() {}

    class S extends T {
	int y;

	int a[];
    }
    S s;

    //@ assignable t.x;
    void m11() {}

    //@ assignable s.x;
    void m12() {}

    // ERROR: not non-array ref type
    //@ assignable t[*].x;
    void m13() {}

    //@ assignable s.a[0..1];
    void m220() {}

   //@ assignable s.y;
    void m219() {}

    // ERROR
    //@ assignable this.x[true];
    void m221() {}

    // ERROR: invalid field ref
    //@ assignable t.s;
    void m14() {}

    //@ assignable s.a[0..1];
    void m15() {}

    //@ assignable s.a[0];
    void m16() {}

    //@ assignable s.a[*];
    void m17() {}

    // ERROR - a[*] is not a reference type
    //@ assignable s.a[*].*;
    void m18() {}

    // ERROR - this is not a field of s
    //@ assignable s.this, this.a[0..1];
    void m19() {}

    // ERROR: a not defined in super 
    //@ assignable super.a[*];
    void m20() {}

    // ERROR: s is not an array type
    //@ assignable this.s[0];
    void m21() {}

    // ERROR
    //@ assignable this.s[0.0];
    void m22() {}

    // ERROR
    //@ assignable s.a[new Object()];
    void m23() {}

    // ERROR
    //@ assignable a.X;
    void m24() {}
}
