class measured_clause {
    int x, y;

    //@ code behavior
    //@   assignable x, y;
    //@   measured_by \not_specified;
    void m() {}

    //@ code behavior
    //@   assignable x, y;
    //@   measured_by_redundantly 0;
    void m1() {}
    
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by x + y;
    void m2() {}

    //@ code behavior
    //@   assignable x, y;
    //@   measured_by_redundantly 1L if true;
    void m3() {}

    //@ code behavior
    //@   assignable x, y;
    //@   measured_by (byte) 0;
    void m4() {}

    //@ code behavior
    //@   assignable x, y;
    //@   measured_by '0';
    void m5() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by 0.0f;
    void m6() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by 0.0;
    void m7() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by null;
    void m8() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by new Integer(0);
    void m9() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by new Object();
    void m10() {}

    int a[];

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by a;
    void m11() {}

    // ERROR
    //@ code behavior
    //@   assignable x, y;
    //@   measured_by 0 if 0;
    void m12() {}
}
