package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

class AndExpression {
   
   int m1(/*@ nullable */ String name, int x) { 
      if (name!=null && name.length() > 0) 
         return name.length(); 
      else
         return x;
   }
   int m2(/*@ nullable */ String name, int x) { 
      if (name!=null & name.length() > 0) 
         return name.length(); 
      else
         return x;
   }
   int m3(/*@ nullable */ String name, /*@ nullable */ String path, int x) { 
      if (name!=null && path!=null) {
         if (name.length() > 0)
            return name.length();
         else
            return x;
      }
      else 
         return 0;
   }
   int m4(/*@ nullable */ String name, /*@ nullable */ String path, int x) { 
      if (path!=null && name!=null) {
         if (name.length() > 0)
            return name.length();
         else
            return x;
      }
      else 
         return 0;
   }
   int m5(/*@ nullable */ String name, int x) { 
      int y;
      if (name!=null && name.length() > 0) 
         y=name.length(); 
      else
         y=x;
      return y + name.length();
   }
   int m6(/*@ nullable */ String name, int x) { 
      if (name!=null && name.length() > 0) 
         return name.length(); 
      else
         return name.length();
   }
   int m7(/*@ nullable */ String name, /*@ nullable */ String path, int x) { 
      if (path!=null && name!=null) {
         if (path.length() > 0)
            return path.length();
         else
            return x;
      }
      else 
         return 0;
   }
}
