package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

class AssignmentExpression {
   /*@ non_null */ String non  = "hello";
   /*@ nullable */ String able = null;

   void m1(/*@non_null*/ String s) { this.non = s; }
   void m2(/*@nullable*/ String s) { this.non = s; } //error
   void m3(/*@non_null*/ String s) { this.able = s; }
   void m4(/*@nullable*/ String s) { this.able = s; }
   void m7(/*@non_null*/ String s) { if (s!=null) this.non = s; }
   void m8(/*@nullable*/ String s) { if (s!=null) this.non = s; }
   void m9(/*@non_null*/ String s) { if (s!=null) this.able = s; }
   void m10(/*@nullable*/ String s) { if (s!=null) this.able = s; }
}
class ArrayAssignmentExpression {
   /*@ non_null */ String[] non  = {"hello"};
   /*@ nullable */ String[] able = null;

   void m1(/*@non_null*/ String[] s) { this.non = s; }
   void m2(/*@nullable*/ String[] s) { this.non = s; } //error
   void m3(/*@non_null*/ String[] s) { this.able = s; } //error
   void m4(/*@nullable*/ String[] s) { this.able = s; }
   void m7(/*@non_null*/ String[] s) { if (s!=null) this.non = s; }
   void m8(/*@nullable*/ String[] s) { if (s!=null) this.non = s; } //error
   void m9(/*@non_null*/ String[] s) { if (s!=null) this.able = s; } //error
   void m10(/*@nullable*/ String[] s) { if (s!=null) this.able = s; }
}
class ArrayInternalAssignmentExpression {
   /*@ non_null */ boolean[] non  = {true, false};
   /*@ nullable */ boolean[] able = null;

   void m1(/*@non_null*/ boolean[] s) { this.non = s; }
   void m2(/*@nullable*/ boolean[] s) { this.non = s; } //error
   void m3(/*@non_null*/ boolean[] s) { this.able = s; }
   void m4(/*@nullable*/ boolean[] s) { this.able = s; }
   void m7(/*@non_null*/ boolean[] s) { if (s!=null) this.non = s; }
   void m8(/*@nullable*/ boolean[] s) { if (s!=null) this.non = s; } 
   void m9(/*@non_null*/ boolean[] s) { if (s!=null) this.able = s; }
   void m10(/*@nullable*/ boolean[] s) { if (s!=null) this.able = s; }
}
