package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

class FlowAnalysis1 {
   void m1(/*@ nullable */ String s) { }
   void m2(/*@ non_null */ String s) { }
   void m3(/*@ nullable */ String v, /*@ nullable */ String n) {
      if (n!=null) {
         m2(n);
      }
   }
}

class FlowAnalysis2 {
   void m1(/*@ nullable */ String s) { }
   void m2(/*@ non_null */ String s) { }
   void m3(/*@ nullable */ String v, /*@ nullable */ String n) {
      if (n!=null) {
         m2(n);
         n=v;
      }
   }
}

class FlowAnalysis3 {
   void m1(/*@ nullable */ String s) { }
   void m2(/*@ non_null */ String s) { }
   void m3(/*@ nullable */ String v, /*@ nullable */ String n) {
      if (n!=null) {
         m2(n);
         n=v;
         m2(n);
      }
   }
}

class FlowAnalysis4 {
   void m1(/*@ nullable */ String s) { }
   void m2(/*@ non_null */ String s) { }
   void m3(/*@ nullable */ String v, /*@ nullable */ String n) {
      if (n!=null) {
         if (n!=null) {
            m2(n);
            n=v;
         }
         m2(n);
      }
   }
}

class FlowAnalysis5 {
   void m1(/*@ nullable */ String s) { }
   void m2(/*@ non_null */ String s) { }
   void m3(/*@ nullable */ String v, /*@ nullable */ String n) {
      n="a";
      n=v;
   }
}

// from nice.sourceforge.net OptionTypes
class FlowAnalysis6
{
  /*@nullable*/ String name;

   void process(/*@non_null*/FlowAnalysis6 a)
   {
       /*@nullable*/ String name = a.name;
       if (name != null)
       {
	  int len = name.length();
       }
       else
       {
       }
   }
}
