class signals_clause {
    class E extends Throwable {}
    class ES extends E {}

    //@ signals ( RuntimeException );
    void m() {}

    //@ signals_redundantly ( E );
    void m1() throws E {}

    //@ exsures ( ES );
    void m2() throws E {}

    //@ exsures_redundantly ( E x);
    void m3() throws E {}

    //@ signals (E e) true;
    void m4() throws E {}

    //@ signals (E e) e != null;
    void m5() throws E {}

    //@ signals (E) true;
    void m6() throws E {}

    // ERROR: not listed type
    //@ signals (E) true;
    void m7() {}

    // ERROR: not Throwable and not listed type
    //@ signals (signals_clause) true;
    void m8() {}

    // ERROR: not predicate
    //@ signals (E) 0;
    void m9() throws E {}

    // ERROR: undefined type
    //@ signals (T);
    void m10() {}
}
