public class spec_public_class_ref2 extends spec_public_class_ref2_super {
    
    // OK: spec_public
    //@ requires new T1() != null;
    public boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof T1;
    }
    
    // OK: spec_public
    //@ requires new T2() != null;
    public boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }

    // OK: spec_public
    //@ requires obj instanceof T2;
    public static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }
}

class spec_public_class_ref2_super {
    private /*@ spec_public @*/ static class T1 {}
    private /*@ spec_public @*/ static class T2 {}
}
