public class spec_public_class_ref7 {
    
    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref7_helper.T1;
    protected boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref7_helper.T1;
    }
    
    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref7_helper.T2;
    protected boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref7_helper.T2;
    }

    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref7_helper.T2;
    protected static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref7_helper.T2;
    }
}

class spec_public_class_ref7_helper {
    private /*@ spec_protected @*/ interface T1 {}
    private /*@ spec_protected @*/ interface T2 {}
}
