public class spec_public_class_ref8 extends spec_public_class_ref8_super {
    
    // OK: spec_protected
    //@ requires obj instanceof T1;
    protected boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof T1;
    }
    
    // OK: spec_protected
    //@ requires obj instanceof T2;
    protected boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }

    // OK: spec_protected
    //@ requires obj instanceof T2;
    protected static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }
}

class spec_public_class_ref8_super {
    private /*@ spec_protected @*/ interface T1 {}
    private /*@ spec_protected @*/ interface T2 {}
}
