public class spec_public_field_ref1 {
    /*@ spec_public @*/ private int val;
    /*@ spec_public @*/ private spec_public_field_ref1_helper helper;
    
    //@ requires helper != null && helper.val > 0; // OK: spec_public
    public void m1() { 
	val = helper.val; // ERROR: private
    }
    
    // OK: spec_public
    //@ requires helper != null && spec_public_field_ref1_helper.sval > 0; 
    public void m2() { 
	val = helper.sval; // ERROR: private
    }

    // OK: spec_public
    //@ requires spec_public_field_ref1_helper.sval > 0; 
    public static void m3() { 
	int x = spec_public_field_ref1_helper.sval; // ERROR: private
    }
}

class spec_public_field_ref1_helper {
    private /*@ spec_public @*/ int val;
    private /*@ spec_public @*/ static int sval;
}
