import helper.spec_public_method_ref_helper;

public class spec_public_method_ref5 {
    /*@ spec_public @*/ private int v;
    /*@ spec_public @*/ private spec_public_method_ref_helper helper;
    
    // OK: spec_public
    //@ requires helper != null && helper.val() > 0; 
    public void m1() { 
	v = helper.val(); // ERROR: protected
    }
    
    // OK: spec_public
    //@ requires helper != null && spec_public_method_ref_helper.sval() > 0; 
    public void m2() { 
	v = helper.sval(); // ERROR: protected
    }

    // OK: spec_public
    //@ requires spec_public_method_ref_helper.sval() > 0; 
    public static void m3() { 
	int x = spec_public_method_ref_helper.sval(); // ERROR: protected
    }
}
