// This test expressions involving \TYPE and java.lang.Class, which
// are supposed to be equivalent.

// Things of type \TYPE
//	variables declared \TYPE
//	result of \type
//	result of \typeof

// Things of type java.lang.Class
//	variables declared Class
//	result of typename.class
//	result of object.getClass()

public class type_exp2 {

	Object o;
	Class c;
	//@ ghost \TYPE t,tt;

	// Some of the \TYPE - \TYPE combinations
	//@ invariant \typeof(o) == \type(Object);
	//@ invariant \typeof(o) <: \type(Object);
	//@ invariant \type(\TYPE) == \type(java.lang.Class);
	//@ invariant \type(\TYPE) <: \typeof(c);
	//@ invariant t == tt;
	//@ invariant t <: tt;

	// Some of the \TYPE - Class combinations
	//@ invariant java.lang.Class.class == \type(java.lang.Class);
	//@ invariant java.lang.Class.class <: \type(java.lang.Class);
	//@ invariant java.lang.Object.class == t;
	//@ invariant java.lang.Object.class <: t;
	//@ invariant o.getClass() == \type(java.lang.Class);
	//@ invariant o.getClass() <: \type(java.lang.Class);
	//@ invariant c == t;
	//@ invariant c <: t;
	//@ invariant t == c;
	//@ invariant c <: t;

	// Some of the Class - Class combinations
	//@ invariant c == o.getClass();
	//@ invariant c <: o.getClass();

	// Some errors
	// invariant t == 5;
	// invariant t <: 5;
	// invariant c == 5;
	// invariant c <: 5;

	//@ ensures \result == \typeof(this);
	public Class c() {
		return null;
	}
}
