/*@ spec_bigint_math @*/ class working_space_clause {
    int x, y;

    //@ working_space \not_specified;
    void m() {}

    //@ working_space_redundantly 0;
    void m1() {}
    
    //@ working_space x + y;
    void m2() {}

    //@ working_space_redundantly 1L if true;
    void m3() {}

    //@ working_space (byte) 0;
    void m4() {}

    //@ working_space '0';
    void m5() {}

    // ERROR
    //@ working_space 0.0f;
    void m6() {}

    // ERROR
    //@ working_space 0.0;
    void m7() {}

    // ERROR
    //@ working_space null;
    void m8() {}

    // ERROR
    //@ working_space new Integer(0);
    void m9() {}

    // ERROR
    //@ working_space new Object();
    void m10() {}

    int a[];

    // ERROR
    //@ working_space a;
    void m11() {}

    // ERROR
    //@ working_space 0 if 0;
    void m12() {}

    //@ working_space 2*Math.max(\pre(x),0) + 2*Math.max(\old(x),0) + i;
    void m13(int i) {}

    //@ working_space \fresh(\result) ? x : x;
    Object m14() { return new Object();}

    //@ working_space \not_modified(y) ? x : x;
    void m15() {}

    //@ working_space x if (\pre(x) != 0 && \old(x) != 0);
    void m16() {}

    //@ working_space x if \result != null;
    Object m17() { return null; }

    //@ working_space \not_assigned(y) ? x : x;
    void m18() {}

}
