public class HelpPPPP extends Help2PPPP{

/*@
	model public int mm_public;
	model protected int mm_protected;
	model int mm_package;
	model private int mm_private;

	ghost public int gg_public;
	ghost protected int gg_protected;
	ghost int gg_package;
	ghost private int gg_private;

*/

	public int i_public;
	protected int i_protected;
	int i_package;
	private int i_private;
	// public /*@ spec_public */ int i_public_specpublic;
	// public /*@ spec_protected */ int i_public_specprotected;
	protected /*@ spec_public */ int i_protected_specpublic;
	// protected /*@ spec_protected */ int i_protected_specprotected;
	/*@ spec_public */ int i_package_specpublic;
	/*@ spec_protected */ int i_package_specprotected;
	private /*@ spec_public */ int i_private_specpublic;
	private /*@ spec_protected */ int i_private_specprotected;

    public void p_public() {}
    protected void p_protected() {}
     void p_package() {}
    private void p_private() {}
    /*@ spec_public */ protected void p_protected_spec_public() {}
     /*@ spec_public */  void p_package_spec_public() {}
     /*@ spec_public */ private void p_private_spec_public() {}
    /*@ spec_protected */  void p_package_spec_protected() {}
     /*@ spec_protected */ private void p_private_spec_protected() {}
     
    public class CC_public {}
    protected class CC_protected {}
	class CC_package {}
    private class CC_private {}
    /*@ spec_public */protected class CC_protected_spec_public {}
    /*@ spec_public */ class CC_package_spec_public {}
    /*@ spec_public */private class CC_private_spec_public {}
    /*@ spec_protected */ class CC_package_spec_protected {}
    /*@ spec_protected */private class CC_private_spec_protected {}

    public interface II_public {}
    protected interface II_protected {}
	interface II_package {}
    private interface II_private {}
    /*@ spec_public */protected interface II_protected_spec_public {}
    /*@ spec_public */ interface II_package_spec_public {}
    /*@ spec_public */private interface II_private_spec_public {}
    /*@ spec_protected */ interface II_package_spec_protected {}
    /*@ spec_protected */private interface II_private_spec_protected {}


	
    //@ public invariant i == 1;
    //@ public constraint i == 1;
    //@ public represents ii <- i+1;

	//@ protected invariant i == 2;
	//@ protected constraint i == 2;
	//@ protected represents ii <- i+2;

	//@ invariant i == 3;
	//@ constraint i == 3;
	//@ represents ii <- i+3;

	//@ private invariant i == 4;
	//@ private constraint i == 4;
	//@ private represents ii <- i+4;

	//@ requires true;
	//@ ensures false;
	public void m() {}


	/*@ public behavior
		ensures i == 1;
	also public normal_behavior
		ensures i == 1;
	also public exceptional_behavior
		signals (Exception) i == 1;
	also protected behavior
        ensures i == 2;
    also protected normal_behavior
        ensures i == 2;
    also protected exceptional_behavior
        signals (Exception) i == 2;
    also behavior
        ensures i == 3;
    also normal_behavior
        ensures i == 3;
    also exceptional_behavior
        signals (Exception) i == 3;
    also private behavior
        ensures i == 1;
    also private normal_behavior
        ensures i == 1;
    also private exceptional_behavior
        signals (Exception) i == 1;
    implies_that
		public behavior
			ensures i == 10;
	also protected normal_behavior
			ensures i == 11;
	also exceptional_behavior
			signals (Exception)  i == 12;
	for_example
		public example
			requires i == 100;
			modifies i;
			ensures i == 101;
	also protected normal_example
			requires i == 110;
			modifies i;
			ensures i == 111;
	also example
			requires i == 110;
			modifies i;
			ensures i == 111;
	also private exceptional_example
			requires i == 110;
			signals(Exception);
	*/
	public void p() throws Exception {}


	/*@ also public behavior
			ensures true;
		also
			modifies i;
		also public normal_behavior
			ensures i == 1;
		also public exceptional_behavior
			signals (Exception) i == 1;

		also protected behavior
			ensures true;
		also protected normal_behavior
			ensures i == 2;
		also protected exceptional_behavior
			signals (Exception) i == 2;

		also behavior
			ensures true;
		also normal_behavior
			ensures i == 3;
		also exceptional_behavior
			signals (Exception) i == 3;

		also private behavior
			ensures true;
		also private normal_behavior
			ensures i == 4;
		also private exceptional_behavior
			signals (Exception) i == 4;
			
	*/
	public void q() throws Exception {}

	/*@ also public behavior
			ensures true;
		also
			modifies i;
		also public normal_behavior
			ensures i == 1;
		also public exceptional_behavior
			signals (Exception) i == 1;

		also protected behavior
			ensures true;
		also protected normal_behavior
			ensures i == 2;
		also protected exceptional_behavior
			signals (Exception) i == 2;

		also behavior
			ensures true;
		also normal_behavior
			ensures i == 3;
		also exceptional_behavior
			signals (Exception) i == 3;

		also private behavior
			ensures true;
		also private normal_behavior
			ensures i == 4;
		also private exceptional_behavior
			signals (Exception) i == 4;
			
	*/
	public void r() throws Exception {}

}
