//#JMLFLAGS: -classpath . -Q 
// Tests that methods are labelled pure if they inherit purity

public class InheritPure2 extends InheritPureS implements InheritPureI, InheritPureII {

	public void m() {} // should inherit pure
	public void n() {} // should inherit pure
	public void k() {} // should inherit pure
	public void s() {} // should inherit pure
	public void p() {} // should not be pure
	public void pp() {} // should not be pure
	public void ppp() {} // should not be pure

}

//@ pure
class InheritPureS extends InheritPureSS {

	public void m() {}
}

class InheritPureSS {

	//@ pure
	public void n() {}

	public void p() {}
}

//@ pure
interface InheritPureI {

	public void k();
}

interface InheritPureII {

	//@ pure
	public void s();
	
	public void pp();
}
