// This tests whether comments are inherited from super classes and interfaces

public class TestInheritComments extends TIC implements TII {

	/** Class comment. */
	public void a() {}

	public void b_fromclass() {}

	public void c_frominterface() {}

	public void d_fromboth() {}

}

class TIC {
	/** SuperClass comment (not inherited). */
	public void a() {}

	/** Superclass comment. */
	public void b_fromclass() {}
 
	/** Super class comment - d */
	public void d_fromboth() {}
}

interface TII {
	/** Interface (not inherited) comment. */
	public void a();
	/** Interface comment.*/
        public void c_frominterface();

	/** Interface comment - d */
	public void d_fromboth();
}
 

