// Tests that with the -public flag, only public clauses are printed

//#JMLFLAGS: -public -Q -nonavbar -classpath .

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class TestPublic extends HelpPPPP {

	public void m() {}
	public void p() throws Exception {}
	public void q() throws Exception {}
	public void r() throws Exception {}

	public int j_public;
        protected int j_protected;
        int j_package;
        private int j_private;
        // public /*@ spec_public */ int j_public_specpublic;
        // public /*@ spec_protected */ int j_public_specprotected;
        protected /*@ spec_public */ int j_protected_specpublic;
        // protected /*@ spec_protected */ int j_protected_specprotected;
        /*@ spec_public */ int j_package_specpublic;
        /*@ spec_protected */ int j_package_specprotected;
        private /*@ spec_public */ int j_private_specpublic;
        private /*@ spec_protected */ int j_private_specprotected;

/*@
	model public int m_public;
	model protected int m_protected;
	model int m_package;
	model private int m_private;

	ghost public int g_public;
	ghost protected int g_protected;
	ghost int g_package;
	ghost private int g_private;

*/
    //@ public represents m_public <- j_public;
    //@ protected represents m_protected <- j_protected;
    //@ private represents m_private <- j_private;
    //@ represents m_package <- j_package;

    public void q_public() {}
    protected void q_protected() {}
     void q_package() {}
    private void q_private() {}
    /*@ spec_public */ protected void q_protected_spec_public() {}
     /*@ spec_public */  void q_package_spec_public() {}
     /*@ spec_public */ private void q_private_spec_public() {}
    /*@ spec_protected */  void q_package_spec_protected() {}
     /*@ spec_protected */ private void q_private_spec_protected() {}
     
// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
    public class C_public {}
    protected class C_protected {}
// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
	class C_package {}
    private class C_private {}
    /*@ spec_public */protected class C_protected_spec_public {}
    /*@ spec_public */ class C_package_spec_public {}
    /*@ spec_public */private class C_private_spec_public {}
    /*@ spec_protected */ class C_package_spec_protected {}
    /*@ spec_protected */private class C_private_spec_protected {}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
    public interface I_public {}
    protected interface I_protected {}
// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
	interface I_package {}
    private interface I_private {}
    /*@ spec_public */protected interface I_protected_spec_public {}
    /*@ spec_public */ interface I_package_spec_public {}
    /*@ spec_public */private interface I_private_spec_public {}
    /*@ spec_protected */ interface I_package_spec_protected {}
    /*@ spec_protected */private interface I_private_spec_protected {}

    public TestPublic(boolean b_public) {}
    protected TestPublic(int i_protected) {}
     TestPublic(float f_package) {}
    private TestPublic(double d_private) {}
    /*@ spec_public */ protected TestPublic(Object o_protected_spec_public) {}
     /*@ spec_public */  TestPublic(String s_package_spec_public) {}
     /*@ spec_public */ private TestPublic(int i, int i_private_spec_public) {}
    /*@ spec_protected */  TestPublic(double i, int i_package_spec_protected) {}
     /*@ spec_protected */ private TestPublic(float i, int i_private_spec_protected) {}

}
