package org.jmlspecs.jmlexec.jack.compiler;

import antlr.debug.misc.ASTFrame;
import antlr.CommonAST;

public class ViewJCHR {

    public static void main(String args[]) {

	CommonAST jchrAST = null;
	JCHRLexer  jchrl = new JCHRLexer(new java.io.DataInputStream(System.in));
	JCHRParser jchrp = new JCHRParser(jchrl);

	try {
	    
	    jchrp.program();
	    jchrAST = (CommonAST)jchrp.getAST();
	    
	} catch(antlr.RecognitionException e) {
	
	    System.err.println("RecognitionException: "+e);
	    
	} catch(antlr.TokenStreamException e) {
	
	    System.err.println("TokenStreamException: "+e);
	    
	}
	
	ASTFrame frame = new ASTFrame("AST", jchrAST);
	frame.setVisible(true);
    
    }


}
