package org.jmlspecs.jmlexec.jack.evaluator;

/**
 * CopyEnvironment.java <br>
 * $Id: CopyEnvironment.java,v 1.1 2008/03/05 00:08:34 wahlst Exp $
 *
 * @author Ekkehard Kramer (last modified by $Author: wahlst $)
 * @version $Date: 2008/03/05 00:08:34 $, $Revision: 1.1 $
 */

public class CopyEnvironment implements Environment {

    public UDCMState udcms;
    
    public BuiltInConstraintMemory bicm;

    public CopyEnvironment(UDCMState u, BuiltInConstraintMemory b) 
    {

	udcms = u;
	bicm = b;

    }

    public String toString() 
    {

	return ""+udcms;

    }
    
    public void set(ConstraintSystem system)
    {
	system.setCopyEnvironment(this);
    }
}

