package org.jmlspecs.jmlexec.jack.evaluator;

public class SimpagationHead {

  /**
     fields
  */

  protected ObjectContainer normalHead;
  protected ObjectContainer minusHead;
  protected ObjectContainer head;  // normalHead + minusHead

  /**
     constructors
  */

  public SimpagationHead(ObjectContainer nh, ObjectContainer mh) {

    normalHead = nh;
    minusHead = mh;
    head = (ObjectContainer)normalHead.clone();

    for (int i=0; i<minusHead.size(); i++) {
      
      ((UDConstraint)minusHead.get(i)).setRemove();
      head.add(minusHead.get(i));

    }

  }

  /**
     returns the head, which will be removed from the memory,
     if the rule is firing
  */

  public ObjectContainer getMinusHead() {

    return minusHead;

  }

  /**
     returns the head, which will be left in the memory
     when the rule is firing
  */

  public ObjectContainer getNormalHead() {

    return normalHead;

  }

  public ObjectContainer getHead() {

    return head;
  
  }

}
