// @(#)$Id: assertion_with_old_expr.java,v 1.3 2006/05/18 23:11:36 leavens Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

class assertion_with_old_expr{
    int val;

    //@ ensures val >= \old(val);
    void foo(int x) 
    {
    	int y = x;
	x = 20;
	//@ assert y >= \old(x + 0) : "y_ge_x";
    	//@ assert y < \old(x) : "this should fail x_eq_y";
	y = y + x;
    	//@ assert y == y + \old(x) : "old_x+y_eq_y";
    }

    void bar() 
    {
	int x = val;
	val++;
	//@ assert x == \old(val) : "x_eq_val";
    }

    public static void main(String args[]) 
    {
	// enable runtime checking of assertion
	org.jmlspecs.jmlrac.runtime.JMLChecker.setLevel(
	   org.jmlspecs.jmlrac.runtime.JMLChecker.ALL);

	assertion_with_old_expr a = new assertion_with_old_expr();
	a.foo(10);
	a.bar();
    }
}
