// KNOWN BUG: 
// Mutually recursive classes such as Account and BankCard here
// must be compiled together, e.g., jmlrac Account.java BankCard.java
// The problem is related with temporary copies of source files for
// the second pass of the compilation process.

public class BankCard {
    private Account acc;

    public void doIt() {
	if (acc.getBankCard() == this)
	    System.out.println(true);
    }

    public Account getAccount() {
	return acc;
    }
}
