// The generated prefix of a field reference expression should not be
// printed. E.g., if the field reference expression, "finalField", is
// printed as "PrintingFieldRef1.InnerClass.finalField", then we
// encounter a compile-time error (for a potential re-initialization of
// a final field). Thanks to Peter Chan for reporting this error.

import org.jmlspecs.jmlrac.runtime.*;

class PrintingFieldRef1 {
    static class InnerClass {
        static final int finalField ;

        static {
            finalField = 0;
        }
    }
}

// @(#)$Id: PrintingFieldRef1.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
