// Thanks to Gary for writing this test case.

package org.jmlspecs.jmlrac.testcase.racgen;

import java.util.Vector;

public class TypeTYPEVars {

    //@ ghost public \TYPE elementType;

    private /*@ spec_public non_null @*/ Vector objects;

    //+@ public 
    //@    invariant elementType <: \type(Object);

    /*+@ public invariant
      @         (\forall int i; 0 <= i && i < objects.size();
      @            \typeof(objects.get(i)) <: elementType);
      @+*/

    //+@ assignable elementType;
    public TypeTYPEVars() {
        //@ set elementType = \type(Object);
    }

    //+@ assignable elementType;
    public void minType(Object x) {
        /*@ set elementType
          @     = (\typeof(x) <: elementType
          @                   ? \typeof(x) : elementType);
          @*/
    }

}

// @(#)$Id: TypeTYPEVars.java,v 1.2 2005/05/31 00:07:10 leavens Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
