import org.jmlspecs.jmlrac.runtime.*;

public class ErrorMessage3 implements ErrorMessage3IF {

    public void m1() {
    }

    public static void main(String args[]) {
	ErrorMessage3 test = new ErrorMessage3();
        int fcnt = 0;

        // postcondition violation
	try { test.m1(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'this'") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        if (fcnt > 0) {
            System.out.print(fcnt + "F(ErrorMessage3.java)");
        } else {
            System.out.print(".");
        }
    }
}

interface ErrorMessage3IF {

    //@ ensures this == null;
    public void m1();
}

// @(#)$Id: ErrorMessage3.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
