// desugaring of missing requires clauses.

import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class Desugaring3 {

    //@ public normal_behavior 
    //@  ensures false;
    //@ also
    //@ public normal_behavior 
    //@  requires s != null;
    //@  ensures true;
    public /*@ pure @*/ void m1(Object s) {
    }

    //@ public normal_behavior 
    //@  {|
    //@    ensures false;
    //@  also
    //@    requires s != null;
    //@    ensures true;
    //@  |}
    //@ also
    //@ public normal_behavior 
    //@  requires s != null;
    //@  ensures true;
    public /*@ pure @*/ void m2(Object s) {
    }

    public static void main(String args[]) {
	Desugaring3 obj = new Desugaring3();
	int fcnt = 0;

        // postcondition violation expected
	try { obj.m1(null); fcnt++; }
        catch (JMLPostconditionError e2) {}
	catch (Throwable e3) { fcnt++; }

        // postcondition violation expected
	try { obj.m1(""); fcnt++; }
        catch (JMLPostconditionError e2) {}
	catch (Throwable e3) { fcnt++; }

        // postcondition violation expected
	try { obj.m2(""); fcnt++; }
        catch (JMLPostconditionError e2) {}
	catch (Throwable e3) { fcnt++; }

        // postcondition violation expected
	try { obj.m2(null); fcnt++; }
        catch (JMLPostconditionError e2) {}
	catch (Throwable e3) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Desugaring3.java)");
        }
    }
}
