import org.jmlspecs.jmlrac.runtime.*;

public class Desugaring4 {

    //@ requires true;
    public void m1() { 
        throw new NullPointerException(); 
    }

    //@ ensures true;
    public void m2() { 
        throw new NullPointerException(); 
    }

    //@ requires true;
    public void m3() throws NullPointerException { 
        throw new NullPointerException(); 
    }

    //@ ensures true;
    public void m4() throws NullPointerException { 
        throw new NullPointerException(); 
    }

    //@ signals_only IllegalArgumentException;
    public void m5() throws NullPointerException { 
        throw new NullPointerException(); 
    }

    //@ signals_only \nothing;
    public void m6() throws NullPointerException { 
        throw new NullPointerException(); 
    }

    public static void main(String args[]) {
	Desugaring4 obj = new Desugaring4();
	int fcnt = 0;

        // assertion violation expected
	try { obj.m1(); fcnt++; }
        catch (JMLExceptionalPostconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) { fcnt++; }

        // assertion violation expected
	try { obj.m2(); fcnt++; }
        catch (JMLExceptionalPostconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) { fcnt++; }

        // no assertion violation expected
        /*	try { obj.m3(); }
        catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) {} */


        // no assertion violation expected
	try { obj.m4(); }
        catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) {}


        // assertion violation expected
	try { obj.m5(); fcnt++; }
        catch (JMLExceptionalPostconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) { fcnt++; } 

        // assertion violation expected
	try { obj.m6(); fcnt++; }
        catch (JMLExceptionalPostconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
	catch (Throwable e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Desugaring4.java)");
        }
    }
}
