import org.jmlspecs.jmlrac.runtime.*;

public class EnsuresRedundantly1 { 

    //@ ensures \result > 10;
    //@ ensures_redundantly \result > 20;
    public int m1(int x) { return x; }

    //@ ensures_redundantly \result > 10;
    public int m2(int x) { return x; }

    public static void main(String args[]) {
	EnsuresRedundantly1 obj = new EnsuresRedundantly1();
	int fcnt = 0;

	try { obj.m1(30); }
	catch (Throwable e) { fcnt++; }


	try { obj.m1(5); }
        catch (JMLNormalPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	try { obj.m1(15); }
        catch (JMLNormalPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }


	try { obj.m2(20); }
	catch (Throwable e2) { fcnt++; }

	try { obj.m2(10); }
        catch (JMLPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(EnsuresRedundantly1.java)");
        }
    }
}
