import org.jmlspecs.jmlrac.runtime.*;

public class EnsuresRedundantly2 { 
    /*@ spec_public @*/ private int val;

    //@ ensures val > 10;
    //@ ensures_redundantly val > 20;
    public EnsuresRedundantly2(int x) { val = x; }

    //@ ensures_redundantly val > 10;
    public EnsuresRedundantly2(int x, int y) { val = x; }

    public static void main(String args[]) {
	int fcnt = 0;

	try { new EnsuresRedundantly2(30); }
	catch (Throwable e) { fcnt++; }


	try { new EnsuresRedundantly2(5); }
        catch (JMLPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	try { new EnsuresRedundantly2(15); }
        catch (JMLPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }


	try { new EnsuresRedundantly2(20, 0); }
	catch (Throwable e2) { fcnt++; }

	try { new EnsuresRedundantly2(10, 0); }
        catch (JMLPostconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(EnsuresRedundantly2.java)");
        }
    }
}
