import org.jmlspecs.jmlrac.runtime.*;

public class GhostField1 implements GhostField1IF {
    public void m1(int x) {
        //@ set g = x;
    }

    public static void main(String args[]) {
	GhostField1 exp = new GhostField1();
	int fcnt = 0;

	try { exp.m1(10); }
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; } 
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(GhostField1.java)");
        }
    }
}

interface GhostField1IF {
    //@ public ghost int g;

    //@ ensures x > 0;
    void m1(int x);
}

// @(#)$Id: GhostField1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
