import org.jmlspecs.jmlrac.runtime.*;

public class Inheritance3 implements Inheritance3IF {

    public void m1() {
        //@ set g = (int)(g + 1);
        m2();
        //@ set g = (int)(g - 1);
    }

    public void m2() {
        //@ set g = (int)(g + 1);
    }

    public static void main(String args[]) {
	Inheritance3 test = new Inheritance3();
	int fcnt = 0;

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        test.m1();

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Inheritance3.java)");
	}
    }
}

interface Inheritance3IF {
    //@ public instance ghost int g = 0;
    //@ constraint g == \old(g) + 1;

    //@ public ghost int gs = 10;
    //@ static constraint gs == \old(gs);
}

// @(#)$Id: Inheritance3.java,v 1.2 2003/06/29 01:02:48 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
