import org.jmlspecs.jmlrac.runtime.*;

public class InvariantRedundantly2 {
    public int val = 100;

    //@ public invariant_redundantly val > 20;
    public void m1(int x) { val = x; }

    public static void main(String args[]) {
	InvariantRedundantly2 obj = new InvariantRedundantly2();
	int fcnt = 0;

	try { obj.m1(30); }
	catch (Throwable e) { fcnt++; }

	try { obj.m1(5); }
        catch (JMLInvariantError e1) {}
	catch (Throwable e2) { fcnt++; }

	try { obj.val = 100; obj.m1(15); }
        catch (JMLInvariantError e1) {}
	catch (Throwable e2) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(InvariantRedundantly2.java)");
        }
    }
}
