import org.jmlspecs.jmlrac.runtime.*;

public class ModelField7A extends ModelField7ASuper {
    //@ ensures x > g;
    public void m1(int x, int y) {
        setGhost(y);
    }

    public static void main(String args[]) {
	ModelField7A exp = new ModelField7A();
	int fcnt = 0;

	try {
	    exp.m1(20, 10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(10, 20); fcnt++; } 
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(ModelField7A.java)");
    }
}

class  ModelField7ASuper implements ModelField7AIF {
    //@ public ghost int g;
    //@ represents val2 <- g; // can model fields depend on ghost fields?

    protected void setGhost(int y) {
        //@ set g = y;
    }
}

interface ModelField7AIF {
    //@ public instance model int val;
    //@ public instance model int val2;
    //@ represents val <- val2;
}

// @(#)$Id: ModelField7A.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
