import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod5 {

    //@ public model int theModel;
    protected int theRep = 10;
    //@               in theModel;
    //@ protected represents theModel <- theRepFun();
    
    /*@ protected pure model int theRepFun () {
      @   return theRep;
      @ }
      @*/

    //@ requires x == theModel;
    void m(int x) { theRep = x; }

    public static void main(String args[]) {
	ModelMethod5 exp = new ModelMethod5();
	int fcnt = 0;

	try { exp.m(10); }
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m(5); fcnt++; }
        catch (JMLPreconditionError e) {}
	catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod5.java)");
	}
    }
}

// @(#)$Id: ModelMethod5.java,v 1.2 2003/07/23 05:33:40 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

