import org.jmlspecs.jmlrac.runtime.*;

public class NeutralContext1 {

    /*@ pure @*/ Object angel() {
        throw new JMLNonExecutableException();
    }

    /*@ pure @*/ Object demon() {
        throw new RuntimeException();
    }

    Object obj = new Object();

    //@ requires b && (obj == angel());
    void eq1(boolean b) {
    }
    //@ requires b && (obj != angel());
    void eq2(boolean b) {
    }
    //@ requires b && (obj == demon());
    void eq3(boolean b) {
    }
    //@ requires b && (obj != demon());
    void eq4(boolean b) {
    }

    public static void main(String args[]) {
	NeutralContext1 test = new NeutralContext1();
	int fcnt = 0;

	//TODO Refactor the test cases
	if(JMLRacUtil.oldSem()){
	
	        // no assertion violation
		try { test.eq1(true); }
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eq2(true); }
	        catch (JMLAssertionError e) { fcnt++; }

	        // precondition violation
		try { test.eq3(true);  fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eq4(true);  fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
		
	} else {
	
    	try { test.eq1(true); }
    	catch (JMLEvaluationError e) { fcnt++; }
    	catch (Throwable t) { fcnt++; }
    	
    	try { test.eq2(true); }
    	catch (JMLEvaluationError e) { fcnt++; }
    	catch (Throwable t) { fcnt++; }
    	
    	try { test.eq3(true); fcnt++;}
    	catch (JMLEvaluationError e) { }
    	catch (Throwable t) {fcnt++; }
    	
    	try { test.eq4(true); fcnt++;}
    	catch (JMLEvaluationError e) { }
    	catch (Throwable t) { fcnt++; }
	
	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NeutralContext1.java)");
        }
    }
}

// @(#)$Id: NeutralContext1.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
