// non_null annotation to static model fields.

import org.jmlspecs.jmlrac.runtime.*;

public class NonNullField5 {

    //@ static model non_null Object mobj;
    static Object obj = new Object();
    //@ static represents mobj <- obj;

    NonNullField5(boolean b) {
	obj = b ? new Object() : null;
    }

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    new NonNullField5(true);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { 
	    new NonNullField5(false);
	    fcnt++;
	}
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NonNullField5.java)");
        }
	obj = new Object();
    }
}

// @(#)$Id: NonNullField5.java,v 1.2 2005/01/01 20:37:47 davidcok Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

