/*
 * Created on Nov 25, 2004
 */

/**
 * @author chalin; Dai
 */

import org.jmlspecs.jmlrac.runtime.*;

public class PrePostfixExp_bigint {

    public static final int C = 99;
    public final int Cplus1 = 100;
    public static int[] a = {C, C+1, C+2};
    public final int CMinus1 = 98;

    /*@
    
    public static pure model \bigint[] getBigintArray() {
     \bigint[] c = new \bigint[a.length];
    
     for (int i = 0; i < a.length; i++) {
     c[i] = a[i];
     }

     return c;
    }

    public static pure model int[] getIntArray() {
      return (int[])a.clone();
    }

    public pure model boolean compareArrays(\bigint[] c, int[]b) {
      if(c.length != b.length) {
        // System.out.println("different length");
        return false;
      }
      for(int i = 0; i < a.length; i++) {
        if(c[i] != b[i]) {
	  // System.out.println("The " + i + "th one in this array is not equal");
	  return false;
	}
      }
      return true;
    }


    // ------------------------------------------------------------------------------
    // Pre-expressions
    // ------------------------------------------------------------------------------
    
    public static pure model int testPlusPlusI(int i) { 
    return ++i;
    }
    
    public static pure model \bigint testPlusPlusI(\bigint i) { 
    return ++i;
    }
        
    public static pure model int testPlusPlusA(int i) { 
      int[] arrayTmp = getIntArray();

      //++arrayTmp[++i] is compiled wrong in jmlc
      ++i;
      return ++arrayTmp[i];
    }
    
    public static pure model \bigint testPlusPlusA_bigint( int i) { 
     \bigint[] c = getBigintArray();
     
     //++c[++i] will cause an compile error here.
     ++i;
     return ++c[i];
    }

    public static pure model int[] testPlusPlusA_rA(int i) { 
      int[] c = getIntArray();

      //++c[++i] is compiled wrong in jmlc
      ++i;
      ++c[i];
      return c;
    }
    
    public static pure model \bigint[] testPlusPlusA_bigint_rA( int i) { 
     \bigint[] c = getBigintArray();

     //++c[++i] will cause an compile error here.
     ++i;
     ++c[i];
      return c;
    }

    public static pure model int testPlusPlusI_PlusI(int i) { 
    return ++i + i;
    }

    public static pure model \bigint testPlusPlusI_PlusI(\bigint i) { 
    return ++i + i;
    }
    

    public static pure model int testMinusMinusI(int i) { 
    return --i;
    }
    
    public static pure model \bigint testMinusMinusI(\bigint i) { 
    return --i;
    }
    
    public static pure model int testMinusMinusA(int i) { 
     int[] c = getIntArray();

     //--c[--i] is compiled wrong in jmlc
     --i;
     return --c[i];
    }
    
    public static pure model \bigint testMinusMinusA_bigint(int i) { 
     \bigint[] c = getBigintArray();

     //--c[--i] will cause an compile error here.
     --i;
     return --c[i];
    }

    public static pure model int[] testMinusMinusA_rA(int i) { 
      int[] c = getIntArray();

      //--c[--i] is compiled wrong in jmlc
      --i;
      --c[i];
      return c;
    }
    
    public static pure model \bigint[] testMinusMinusA_bigint_rA(int i) { 
     \bigint[] c = getBigintArray();

     //--c[--i] will cause an compile error here.
     --i;
     --c[i];
      return c;
    }

    public static pure model int testMinusMinusI_MinusI(int i) { 
    return --i - i;
    }

    public static pure model \bigint testMinusMinusI_MinusI(\bigint i) { 
    return --i - i;
    }
    
    // ------------------------------------------------------------------------------
    // Post-expressions
    // ------------------------------------------------------------------------------
    
    public static pure model int testIPlusPlus(int i) { 
    return i++;
    }
    
    public static pure model \bigint testIPlusPlus(\bigint i) { 
    return i++;
    }
    
    public static pure model int testAPlusPlus(int i) { 
     int[] c = getIntArray();

     //c[i++]++ is compiled wrong in jmlc
      return c[i]++;
    }
    
    public static pure model \bigint testAPlusPlus_bigint(int i) { 
     \bigint[] c = getBigintArray();

     //c[i++]++ will cause a compile error here.
     return c[i]++;
    }

    public static pure model int[] testAPlusPlus_rA(int i) { 
     int[] c = getIntArray();

     //c[i++]++ is compiled wrong in jmlc
      c[i]++;
      return c;
    }
    
    public static pure model \bigint[] testAPlusPlus_bigint_rA(int i) { 
     \bigint[] c = getBigintArray();

     //c[i++]++ will cause a compile error here.
     c[i]++;
     return c;
    }

    public static pure model int testIPlusPlus_PlusI(int i) { 
    return i++ + i;
    }

    public static pure model \bigint testIPlusPlus_PlusI(\bigint i) { 
    return i++ + i;
    }


    public static pure model int testIMinusMinus(int i) { 
    return i--;
    }
    
    public static pure model \bigint testIMinusMinus(\bigint i) { 
    return i--;
    }
    
    public static pure model int testAMinusMinus(int i) { 
     int[] c = getIntArray();

     //c[i--]-- is compiled wrong in jmlc
      return c[i]--;
    }
    
    public static pure model \bigint testAMinusMinus_bigint(int i) { 
     \bigint[] c = getBigintArray();

     //c[i--]-- will cause a compile error here.
     return c[i]--;
    }

    public static pure model int[] testAMinusMinus_rA(int i) { 
     int[] c = getIntArray();

     //c[i--]-- is compiled wrong in jmlc
     c[i]--;
     return c;
    }
    
    public static pure model \bigint[] testAMinusMinus_bigint_rA(int i) { 
     \bigint[] c = getBigintArray();

     //c[i--]-- will cause a compile error here.
     c[i]--;
     return c;
    }

    public static pure model int testIMinusMinus_MinusI(int i) { 
    return i-- - i;
    }

    public static pure model \bigint testIMinusMinus_MinusI(\bigint i) { 
    return i-- - i;
    }

    // ------------------------------------------------------------------------------
    @*/

    // Pre

    //@ requires testPlusPlusI(C) == Cplus1;
    public void mPlusPlusI() { }

    //@ requires testPlusPlusI((\bigint)C) == Cplus1;
    public void mPlusPlusI_bigint() { }

    //@ requires (testPlusPlusA(nIndex) == testPlusPlusA_bigint(nIndex)) && compareArrays(testPlusPlusA_bigint_rA(nIndex), testPlusPlusA_rA(nIndex));
    public void mPlusPlusA(int nIndex) { }

    //@ requires testPlusPlusI_PlusI(C) == C + C + 2;
    public void mPlusPlusI_PlusI() { }

    //@ requires testPlusPlusI_PlusI((\bigint)C) == C + C + 2;
    public void mPlusPlusI_PlusI_bigint() { }


    //@ requires testMinusMinusI(C) == CMinus1;
    public void mMinusMinusI() { }

    //@ requires testMinusMinusI((\bigint)C) == CMinus1;
    public void mMinusMinusI_bigint() { }

    //@ requires (testMinusMinusA(nIndex) == testMinusMinusA_bigint(nIndex)) && compareArrays(testMinusMinusA_bigint_rA(nIndex), testMinusMinusA_rA(nIndex));
    public void mMinusMinusA(int nIndex) { }

    //@ requires testMinusMinusI_MinusI(C) == C - C;
    public void mMinusMinusI_MinusI() { }

    //@ requires testMinusMinusI_MinusI((\bigint)C) == C - C;
    public void mMinusMinusI_MinusI_bigint() { }

    // Post
    
    //@ requires testIPlusPlus(C) == C;
    public void mIPlusPlus() { }

    //@ requires testIPlusPlus((\bigint)C) == C;
    public void mIPlusPlus_bigint() { }

    //@ requires (testAPlusPlus(nIndex) == testAPlusPlus_bigint(nIndex)) && compareArrays(testAPlusPlus_bigint_rA(nIndex), testAPlusPlus_rA(nIndex));
    public void mAPlusPlus(int nIndex) { }

    //@ requires testIPlusPlus_PlusI(C) == C + C + 1;
    public void mIPlusPlus_PlusI() { }

    //@ requires testIPlusPlus_PlusI((\bigint)C) == C + C + 1;
    public void mIPlusPlus_PlusI_bigint() { }


    //@ requires testIMinusMinus(C) == C;
    public void mIMinusMinus() { }

    //@ requires testIMinusMinus((\bigint)C) == C;
    public void mIMinusMinus_bigint() { }

    //@ requires (testAMinusMinus(nIndex) == testAMinusMinus_bigint(nIndex)) && compareArrays(testAMinusMinus_bigint_rA(nIndex), testAMinusMinus_rA(nIndex));
    public void mAMinusMinus(int nIndex) { }

    //@ requires testIMinusMinus_MinusI(C) == C - (C - 1);
    public void mIMinusMinus_MinusI() { }

    //@ requires testIMinusMinus_MinusI((\bigint)C) == C - (C - 1);
    public void mIMinusMinus_MinusI_bigint() { }



    public static void main(String args[]) {
	PrePostfixExp_bigint test = new PrePostfixExp_bigint();
	int fcnt = 0;

	//pre

	try { test.mPlusPlusI(); }
        catch (JMLAssertionError e) { fcnt++; }
        
	try { test.mPlusPlusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mPlusPlusA(0);  }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.mPlusPlusI_PlusI();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mPlusPlusI_PlusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }


	try { test.mMinusMinusI(); }
        catch (JMLAssertionError e) { fcnt++; }
        
	try { test.mMinusMinusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mMinusMinusA(1);  }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.mMinusMinusI_MinusI();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mMinusMinusI_MinusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }


	//post

	try { test.mIPlusPlus(); }
        catch (JMLAssertionError e) { fcnt++; }
        
	try { test.mIPlusPlus_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mAPlusPlus(0);  }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.mIPlusPlus_PlusI();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mIPlusPlus_PlusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }


	try { test.mIMinusMinus(); }
        catch (JMLAssertionError e) { fcnt++; }
        
	try { test.mIMinusMinus_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mAMinusMinus(1);  }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.mIMinusMinus_MinusI();  }
        catch (JMLAssertionError e) { fcnt++; }

	try { test.mIMinusMinus_MinusI_bigint();  }
        catch (JMLAssertionError e) { fcnt++; }


	if (fcnt > 0) {
	    System.out.println(fcnt + "F(PrePostfixExp_bigint.java)");
        }
    }

}
