import org.jmlspecs.jmlrac.runtime.*;

public class QuantifiersWithImplicitRange4 {

    java.util.Collection c;
    java.util.Collection d;
    {
	c = new java.util.ArrayList();
	d = new java.util.ArrayList();
	c.add(new Integer(10));
	d.add(new Integer(20));
    }

    //@ requires (\exists Integer y; d.contains(y);
    //@             c.contains(y) && x > y.intValue());
    void m1(int x) {}

    public static void main(String args[]) {
	QuantifiersWithImplicitRange4 exp = 
            new QuantifiersWithImplicitRange4();
	int fcnt = 0;

        // expect assertion violation
	try { exp.m1(30); fcnt++; }
	catch (JMLPreconditionError e) {}
	catch (JMLAssertionError e) { fcnt++; }

        // expect assertion violation
	try { exp.m1(5); fcnt++; }
	catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + 
                               "F(QuantifiersWithImplicitRange4.java)");
	}
    }
}

// @(#)$Id: QuantifiersWithImplicitRange4.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
