import org.jmlspecs.jmlrac.runtime.*;

public class Recursion1A implements Recursion1AIF {

    public int m1(int x) {
        if (x <= 0) {
            return 0;
        }
        return m1(x - 1) + 1;
    }

    public static void main(String args[]) {
	Recursion1A test = new Recursion1A();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(2); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(0); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(-2); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Recursion1A.java)");
	}
    }
}

interface Recursion1AIF {
    /*@  requires x > 0;
      @  ensures \result == x;
      @ also
      @  requires x <= 0;
      @  ensures \result == 0;
      @*/
    int m1(int x);
}

// @(#)$Id: Recursion1A.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
