import org.jmlspecs.jmlrac.runtime.*;

public class RequiresRedundantly1 {

    //@ requires x > 10;
    //@ requires_redundantly x > 20;
    public void m1(int x) {}

    //@ requires_redundantly x > 10;
    public void m2(int x) {}

    public static void main(String args[]) {
	RequiresRedundantly1 obj = new RequiresRedundantly1();
	int fcnt = 0;

	try { obj.m1(30); }
	catch (Throwable e) { fcnt++; }


	try { obj.m1(5); }
        catch (JMLPreconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	try { obj.m1(15); }
        catch (JMLPreconditionError e1) {}
	catch (Throwable e2) { fcnt++; }


	try { obj.m2(20); }
	catch (Throwable e2) { fcnt++; }

	try { obj.m2(10); }
        catch (JMLPreconditionError e1) {}
	catch (Throwable e2) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(RequiresRedundantly1.java)");
        }
    }
}
