import org.jmlspecs.jmlrac.runtime.*;
import org.jmlspecs.models.*;

public class SetComprehension1 {
    java.util.Collection c = null;
    {
	c = new java.util.HashSet();
	c.add(new Integer(5));
	c.add(new Integer(10));
    }

    //@ requires new JMLObjectSet { Integer i | c.contains(i) 
    //@  && i.intValue() > x }.int_size() == y;
    void m1(int x, int y) {
    }

    public static void main(String args[]) {
	SetComprehension1 exp = new SetComprehension1();
	int fcnt = 0;

	try { 
	    exp.m1(4,2);
	    exp.m1(5,1);
	    exp.m1(10,0);
	}
	catch (JMLAssertionError e) { fcnt++; }

	if(JMLRacUtil.oldSem()){
		try { exp.m1(4,1); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m1(5,0); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m1(10,1); fcnt++; } catch (JMLAssertionError e) {}
	} else {
		try { exp.m1(4,1); } catch (JMLAssertionError e) {fcnt++;}
		try { exp.m1(5,0); } catch (JMLAssertionError e) {fcnt++;}
		try { exp.m1(10,1); } catch (JMLAssertionError e) {fcnt++;}
	}	

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SetComprehension1.java)");
	}
    }
}

// @(#)$Id: SetComprehension1.java,v 1.3 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
