import org.jmlspecs.jmlrac.runtime.*;
import org.jmlspecs.models.*;

public class SetComprehension4 {
    java.util.Collection c = null;
    {
	c = new java.util.HashSet();
	c.add(new SetComprehension4Helper(5));
	c.add(new SetComprehension4Helper(10));
    }

    //@ requires new JMLValueSet { SetComprehension4Helper i | c.contains(i) 
    //@  && i.val() > x }.int_size() == y;
    void m1(int x, int y) {
    }

    public static void main(String args[]) {
	SetComprehension4 exp = new SetComprehension4();
	int fcnt = 0;

	try { 
	    exp.m1(4,2);
	    exp.m1(5,1);
	    exp.m1(10,0);
	}
	catch (JMLAssertionError e) { fcnt++; }

	if(JMLRacUtil.oldSem()){
		try { exp.m1(4,1); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m1(5,0); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m1(10,1); fcnt++; } catch (JMLAssertionError e) {}
	} else {
		try { exp.m1(4,1); } catch (JMLAssertionError e) {fcnt++;}
		try { exp.m1(5,0); } catch (JMLAssertionError e) {fcnt++;}
		try { exp.m1(10,1); } catch (JMLAssertionError e) {fcnt++;}
	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SetComprehension4.java)");
	}
    }

    static class SetComprehension4Helper implements JMLType {
        SetComprehension4Helper(int val) {
            this.val = val;
        }

        public Object clone() {
            return new SetComprehension4Helper(val);
        }

        public boolean equals(/*@ nullable @*/ Object other) {
            return other != null && 
                (other instanceof SetComprehension4Helper) &&
                ((SetComprehension4Helper) other).val == val;
        }

        public int hashCode() {
            return val;
        }

        public /*@ pure @*/ int val() {
            return val;
        }

        private int val;
    }
}

// @(#)$Id: SetComprehension4.java,v 1.4 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
