import org.jmlspecs.jmlrac.runtime.*;

public class Signals3 {
    //@ signals (Throwable e) false;
    int m1() throws Throwable { throw new Throwable(); }

    //@ signals (Throwable e) true;
    int m2() throws Throwable { throw new Throwable(); }

    public static void main(String args[]) {
	Signals3 obj = new Signals3();
	int fcnt = 0;

        // (excpetional) postcondition violation expected
	try { obj.m1(); }
        catch (JMLExceptionalPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // no assertion violation expected
	try { obj.m2(); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (Throwable e2) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Signals3.java)");
        }
    }
}
