import org.jmlspecs.jmlrac.runtime.*;

public class Signals3A {
    //@ signals (Throwable e) false;
    public Signals3A() throws Throwable { throw new Throwable(); }

    //@ signals (Throwable e) true;
    public Signals3A(int x) throws Throwable { throw new Throwable(); }

    public static void main(String args[]) {
	int fcnt = 0;

        // (excpetional) postcondition violation expected
	try { new Signals3A(); }
        catch (JMLExceptionalPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // no assertion violation expected
	try { new Signals3A(0); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (Throwable e2) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Signals3A.java)");
        }
    }
}
