import org.jmlspecs.jmlrac.runtime.*;

public class Signals4 {

    class E1 extends Throwable {}
    class E2 extends E1 {}

    //@ signals (E2 e) false;
    int m1() throws E1 { throw new E1(); }

    //@ signals (E1 e) true;
    int m2() throws E1 { throw new E2(); }

    public static void main(String args[]) {
	Signals4 obj = new Signals4();
	int fcnt = 0;

        // no assertion violation expected
	try { obj.m1(); }
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) {}

        // no assertion violation expected
	try { obj.m2(); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (Throwable e2) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Signals4.java)");
        }
    }
}
