import org.jmlspecs.jmlrac.runtime.*;

public class SignalsOnly1 {

    //@ signals_only NullPointerException;
    public void m1() {
        throw new NullPointerException();
    }

    //@ signals_only NullPointerException;
    public void m2() {
        throw new IllegalArgumentException();
    }

    //@ signals_only \nothing;
    public void m3() {
    }

    //@ signals_only \nothing;
    public void m4() {
        throw new NullPointerException();
    }

    public static void main(String args[]) {
        SignalsOnly1 exp = new SignalsOnly1();
        int fcnt = 0;

        try { exp.m1(); fcnt++; }
        catch (NullPointerException e) {}
        catch (JMLAssertionError e) { fcnt++; }

        try { exp.m2(); fcnt++; }
        catch (Exception e) { fcnt++; }
        catch (JMLExceptionalPostconditionError e) {}

        try { exp.m3(); }
        catch (JMLAssertionError e) { fcnt++; }
        catch (Throwable e) { fcnt++; }

        try { exp.m4(); fcnt++; }
        catch (Exception e) { fcnt++; }
        catch (JMLExceptionalPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        if (fcnt > 0) {
            System.out.println(fcnt + "F(SignalsOnly1.java)");
        }
    }
}

