import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class SpecPublicField1 extends SpecPublicField1Helper {
    private /*@ spec_public @*/ int x = 20;

    //@ requires x == y;
    void m1(int y) {}

    //@ requires super.x == y;
    void m2(int y) {}

    public static void main(String args[]) {
        SpecPublicField1 exp = new SpecPublicField1();
        int fcnt = 0;

        try { exp.m1(20); } catch (JMLAssertionError e) { fcnt++; }
        try { exp.m1(10); fcnt++; } catch (JMLAssertionError e) {}

        try { exp.m2(10); } catch (JMLAssertionError e) { fcnt++; }
        try { exp.m2(20); fcnt++; } catch (JMLAssertionError e) {}

        if (fcnt > 0) {
            System.out.println(fcnt + "F(SpecPublicField1.java)");
        }
    }
}

class SpecPublicField1Helper {
    private /*@ spec_public @*/ int x = 10;
}
