import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class SpecPublicMethod1 {

    SpecPublicMethod1Helper helper;

    //@ requires x > SpecPublicMethod1Helper.sval();
    void m1(int x) {}

    //@ requires x > new SpecPublicMethod1Helper().val();
    void m2(int x) {}

    public static void main(String args[]) {
	SpecPublicMethod1 test = new SpecPublicMethod1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m1(5); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
        // no assertion violation
	try { test.m2(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(5); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SpecPublicMethod1.java)");
	}
    }
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
class SpecPublicMethod1Helper {
    /*@ spec_public pure @*/ private int val() {
        return 10;
    }

    /*@ spec_public pure @*/ private static int sval() {
        return 10;
    }
}

// @(#)$Id: SpecPublicMethod1.java,v 1.2 2005/12/06 19:54:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
