import org.jmlspecs.jmlrac.runtime.*;

public class Undefined13 {

    /*@ public normal_behavior
      @   ensures \result <==>
      @     (\forall Object e; ; true); // non-executable
      @*/
    public /*@ pure @*/ boolean m1(boolean b) {
        return b;
    }

    public static void main(String args[]) {
	Undefined13 test = new Undefined13();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(false); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined13.java)");
	}
    }
}

// @(#)$Id: Undefined13.java,v 1.2 2003/09/24 03:51:29 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
