import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class Undefined8 {
    //@ requires (\forall int i; i >= 0 && i < 10;
    //@  (* informal description *));
    void m1() {}

    //@ requires (\forall int i; i >= 0 && i < 10;
    //@  !(* informal description *));
    void m2() {}

    //@ requires (\exists Object o; c.contains(o);
    //@  (* informal description *));
    void m3() {}

    //@ requires (\exists Object o; c.contains(o); 
    //@  !(* informal description *));
    void m4() {}

    java.util.Collection c;

    public static void main(String args[]) {
	Undefined8 test = new Undefined8();
	int fcnt = 0;

	if(JMLRacUtil.oldSem()){

        // no assertion violation, i.e., non-executable
        try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation, i.e., non-executable
        try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation, i.e., null pointer
        try { test.m3(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation, i.e., null pointer
        try { test.m4(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	} else {
	
		try { test.m1(); test.m2(); test.m3(); test.m4(); }
        catch (JMLAssertionError e) { fcnt++; }

	}
       
        if (fcnt > 0) {
            System.out.println(fcnt + "F(Undefined8.java)");
        }
    }
}

// @(#)$Id: Undefined8.java,v 1.3 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
