import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class blank_final {
    final int size;
    final static int MAX_SIZE = 10;

    //@ requires x > 0;
    //@ ensures  size <= MAX_SIZE;
    blank_final(int x) {
	size = x;
    }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    new blank_final(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { new blank_final(11); } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(blank_final.java)");
    }
}
