import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class cast_exp {

    //@ requires (String)o != "";
    void m1(/*@ nullable @*/ Object o) {}

    //@ requires (String)null != "";
    void m2(Object o) {}

    /*@ normal_behavior
      @  requires (\bigint) 0 < i;
      @  assignable \nothing;
      @*/
    void test1(int i) { return ; }

    public static void main(String args[]) {
	cast_exp exp = new cast_exp();
	int fcnt = 0;

	try { exp.m1("a string");
	      exp.m1(null);
	      exp.test1(1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try {
            exp.m1(new Object()); fcnt++;
        } catch (JMLAssertionError e) {
        }
	try {
            exp.m1(new Integer(0)); fcnt++;
        } catch (JMLAssertionError e) {
        }
	try {
            exp.test1(0); fcnt++;
	} catch (JMLAssertionError e) {
	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(cast_exp.java)");
	}
    }
}
