import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class conditional_exp {

    //@ requires b ? true : false;
    void m1(boolean b) {}

    //@ requires true ? x >= 0 : x < 0;
    void m2(int x) {}

    public static void main(String args[]) {
	conditional_exp exp = new conditional_exp();
	int fcnt = 0;

	try {
	    exp.m1(true);
	    exp.m2(10);
	}
	catch (JMLAssertionError e) {
	    fcnt++;
	}

	try {
	    exp.m1(false);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	try {
	    exp.m2(-10);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(conditional_exp.java)");
    }
}
