import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class conditional_or_exp {

    //@ requires true || x > 0;
    void m1(int x) {}

    //@ requires false || x > 0;
    void m2(int x) {}

    //@ requires x > 0 || true;
    void m3(int x) {}

    //@ requires x > 0 || x > 10;
    void m4(int x) {}

    //@ requires x > 0 || false;
    void m5(int x) {}

    public static void main(String args[]) {
	conditional_or_exp exp = new conditional_or_exp();
	int fcnt = 0;

	try { exp.m1(10); exp.m1(-10); exp.m2(10); exp.m3(10); 
	      exp.m3(-10); exp.m4(1); exp.m5(1); 
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m5(-10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(conditional_or_exp.java)");
	}
    }
}
