import org.jmlspecs.jmlrac.runtime.*;

public class constraint_spec {
    //@ static constraint sval() >= 0;
    static int sval = 0;

    //@ constraint val() >= 0;
    int val = 0;

    static /*@ pure @*/ int sval() { return sval; }
    /*@ pure @*/ int val() { return val; }
    
    void m1(int x) { val = x; }

    void m2(int x) { sval = x; }


    public static void main(String args[]) {
	constraint_spec o = new constraint_spec();
	int fcnt = 0;

	try { 
	    o.m1(1); o.m1(10); o.m1(20);
	    o.m2(1); o.m2(10); o.m2(20);
	}
	catch (Throwable e) { fcnt++; }

	try { o.m1(-10); fcnt++; } 
	catch (JMLHistoryConstraintError e) {}
	catch (Throwable e) { fcnt++; }

	try { o.m2(-10); fcnt++; } 
	catch (JMLHistoryConstraintError e) {}
	catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(constraint_spec.java)");
	sval = 100;
    }
}
