import org.jmlspecs.jmlrac.runtime.*;

public class exception_exp {

    //@ requires mayFailBool(x) || y > 0;
    void m0(int x, int y) {}

    //@ requires mayFail(x)  > 0;
    void m1(int x) {}

    //@ requires workOut(mayFail(x)) > 0;
    void m2(int x) {}

    //@ requires !(mayFail(x) > 0);
    void m3(int x) {}

    //@ requires !mayFailBool(x);
    void m4(int x) {}

    /*@ pure @*/ int mayFail(int x) {
	if (x < 0)
	    throw new RuntimeException("I accept only positive numbers");
	return x;
    }

    /*@ pure @*/ boolean mayFailBool(int x) {
	if (x < 0)
	    throw new RuntimeException("I accept only positive numbers");
	return true;
    }

    /*@ pure @*/ int workOut(int x) { return x; }

    public static void main(String args[]) {
	exception_exp exp = new exception_exp();
	int fcnt = 0;

	if(JMLRacUtil.oldSem()){
		try { exp.m0(-1, 1);} catch (JMLAssertionError e) { fcnt++; }
	} else {
		try { exp.m0(-1, 1); fcnt++; } catch (JMLAssertionError e) {}
	}
	
	try { 
	    exp.m0(1, -1);
		exp.m0(1, 1);
	    exp.m1(1);
		exp.m2(1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m0(-1, -1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(-1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(exception_exp.java)");
	}
    }
}
