import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class final_arg {
    // rac should NOT throw away "final" modifier.
    //@ ensures \result > 0;
    public int m1(final int x) {
        class T {
            int val() { return x; }
        }
	return x; //new T().val();
    }

    public static void main(String args[]) {
	final_arg exp = new final_arg();
	int fcnt = 0;

	try { exp.m1(10); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m1(0); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(final_arg.java)");
    }
}
