import org.jmlspecs.jmlrac.runtime.*;

public class inherit_constraint extends inherit_constraint_super {
    void m1(int x) { val = x; }
    void m2(int x) { sval = x; }

    public static void main(String args[]) {
	inherit_constraint o = new inherit_constraint();
	int fcnt = 0;

	try { 
	    o.m1(1); o.m1(10); o.m1(20);
	    o.m2(1); o.m2(10); o.m2(20);
	}
	catch (Throwable e) { fcnt++; }

	try { o.m1(-10); fcnt++; } 
	catch (JMLHistoryConstraintError e) {}
	catch (Throwable e) { fcnt++; }

	try { o.m2(-10); fcnt++; } 
	catch (JMLHistoryConstraintError e) {}
	catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(inherit_constraint.java)");
    }
}

class inherit_constraint_super {

    //@ constraint val() >= 0;
    protected int val = 0;

    //@ static constraint sval() >= 0;
    static int sval = 0;

    protected /*@ pure @*/ int val() { return val; }
    static /*@ pure @*/ int sval() { return sval; }
}
