import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

class inherit_post_constructor_super {
    //@ ensures x > 10;
    inherit_post_constructor_super(int x) {}

    inherit_post_constructor_super() {}
}

public class inherit_post_constructor extends inherit_post_constructor_super {

    //@ ensures x > 0;
    inherit_post_constructor(int x) {}

    public static void main(String args[]) {
	int fcnt = 0;

	// constructor's spec is not inherited
	try {
	    new inherit_post_constructor(5);
	}
	catch (Throwable e) { fcnt++; }
	
	try { new inherit_post_constructor(0); fcnt++; }
        catch (JMLAssertionError e) {}
        catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(inherit_post_constructor.java)");
    }
}
