import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

import org.jmlspecs.jmlrac.runtime.*;

public class internal_violation {
    void m1(int x) { m10(x); }
    //@ requires x > 0;
    void m10(int x) {}

    //@ normal_behavior ensures true;
    /*@ pure @*/ void m2(int x) { m20(x); }
    //@ ensures x > 0;
    /*@ pure @*/ void m20(int x) {}

    public static void main(String args[]) {
	internal_violation o = new internal_violation();
	int fcnt = 0;

	try { o.m1(20); o.m2(20); }
	catch (JMLAssertionError e) { fcnt++; }

	try { o.m1(0); fcnt++; }
	catch (JMLInternalPreconditionError e) {}
	catch (JMLAssertionError e) { fcnt++; }

	try { o.m2(0); fcnt++; }
	catch (JMLPostconditionError e) {}
	catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(internal_violation.java)");
    }
}
