import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
class methodcall_exp_super {
    /*@ pure @*/ int val() { return 10; }
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class methodcall_exp extends methodcall_exp_super {
    Object o;

    //@ requires o1.equals(new Integer(0));
    void m0(Object o1) {}

    //@ requires incr(x) > 0;
    void m1(int x) {}

    //@ requires x > val();
    void m2(int x) {}

    //@ requires isPositive(x);
    void m3(int x) {}

    //@ requires x > this.val();
    void m4(int x) {}

    //@ requires x > super.val();
    void m5(int x) {}

    //@ requires x > ((methodcall_exp_super)this).val();
    void m6(int x) {}

    /*@ pure @*/ int incr(int x) { return ++x; }
    /*@ pure @*/ int val() { return 0; }
    /*@ pure @*/ boolean isPositive(int x) { return x > 0; }

    public static void main(String args[]) {
	methodcall_exp exp = new methodcall_exp();
	int fcnt = 0;

	try { exp.m1(1); exp.m2(1); exp.m3(1);
	exp.m4(1); exp.m5(11); exp.m6(11);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m0(new Object()); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m0(null); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m5(5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(methodcall_exp.java)");
	}
    }
}
