import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class model_field1 {
    //@ public model instance int val;
    //@ public represents val <- v;
    
    public int v = 10;

    //@ requires val > 0;
    public void m1() {}

    // testing for inheritance by model_field1_inherit
    //@protected model instance int val2;
    
    //@ requires val2 >= 0;
    protected void m2() {}

    public static void main(String args[]) {
	model_field1 exp = new model_field1();
	int fcnt = 0;

	try {
	    exp.m1();
	    exp.m2(); // val2 has no rep, so not executable!
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.v = -10; exp.m1(); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(model_field1.java)");
    }    
}
