import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class new_anonymous_class_exp {
    static class T {
	T(int x, int y) { this.x = x; this.y = y; }
	/*@ pure @*/ int val() { return x * y; }
	int x, y;
    }

    // JNewAnonymousClassExpression
    //@ requires new T(x,y) { int val() { return (int)(x + y); } }.val() > 10;
    void m3(int x, int y) {}

    public static void main(String args[]) {
	new_anonymous_class_exp exp = new new_anonymous_class_exp();
	int fcnt = 0;
	Integer i = new Integer(10);

	try { exp.m3(5, 6);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m3(5, 5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(new_anonymous_class_exp.java)");
	}
    }
}
