import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class outer_this_and_anonymous_class {
    class T {
	T(int x) { this.x = x; }
	int val() { return x; }
	int x;
    }
    
    //@ ensures \result;
    boolean m1(int x) {
	return new T(x) { int val() { return x; } }.val() > 10;
    }

   public static void main(String args[]) {
	outer_this_and_anonymous_class exp 
	    = new outer_this_and_anonymous_class();
	int fcnt = 0;

	try { exp.m1(20); 
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + 
	      "F(outer_this_and_anonymous_class.java)");
	}    
   }
}
