import org.jmlspecs.jmlrac.runtime.*;

public class quanti_boolean {

    //@ requires (\forall boolean y; ; y == x);
    void m1(boolean x) {}

    //@ requires (\exists boolean y; ; y == x);
    void m2(boolean x) {}

    //@ requires (\sum boolean y; y; x) == sum;
    void m3(int x, int sum) {}

    //@ requires (\product boolean y; ; x) == sum;
    void m4(int x, int sum) {}

    //@ requires (\max boolean y; ; x) == sum;
    void m5(int x, int sum) {}

    //@ requires (\min boolean y; ; x) == sum;
    void m6(int x, int sum) {}

    //@ requires (\num_of boolean y; ; true) == sum;
    void m7(int x, int sum) {}

    java.util.Collection c;
    { 
	c = new java.util.ArrayList();
	c.add(new Integer(5));
	c.add(new Integer(4));
    }
    //@ requires (\num_of Integer y; c.contains(y); y.intValue() > 4) == sum;
    void m6(int sum) {}
    
    public static void main(String args[]) {
	quanti_boolean exp = new quanti_boolean();
	int fcnt = 0;

	try { 
	    exp.m2(true); exp.m2(false);
	    exp.m3(5,5); exp.m3(10,10);
	    exp.m4(5,25); exp.m4(10,100);
	    exp.m5(5,5); exp.m5(10,10);
	    exp.m6(5,5); exp.m6(10,10);
	    exp.m7(5,2); exp.m7(10,2);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(true); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(false); fcnt++; } catch (JMLAssertionError e) {}
	if(JMLRacUtil.oldSem()){
		try { exp.m3(5,4); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m4(2,1); fcnt++; } catch (JMLAssertionError e) {}
	} else {
		try { exp.m3(5,4);} catch (JMLAssertionError e) { fcnt++; }
		try { exp.m4(2,1);} catch (JMLAssertionError e) { fcnt++; }
	}
	try { exp.m5(2,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m6(2,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m7(2,1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(quanti_boolean.java)");
	}
    }
}
