import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class quanti_forall_char_exp {

    //@ requires (\forall char y; 5 <= y && y < 10; x < y);
    void m1(int x) {}

    //@ requires (\forall char y; 5 < y && y <= 10; x < y);
    void m2(int x) {}

    //@ requires (\exists char y; 5 <= y && y < 10; x == y);
    void m3(int x) {}

    //@ requires (\exists char y; 5 < y && y <= 10; x == y);
    void m4(int x) {}

    //@ requires (\exists char y; y < 5 && y <= 10 && y >= 4 && y > 0; x == y);
    void m5(int x) {}

    //@ requires (\exists char y; 5 < y ; x == y);
    void m6(int x) {}

    public static void main(String args[]) {
	quanti_forall_char_exp exp = new quanti_forall_char_exp();
	int fcnt = 0;

	try { 
	    exp.m1(4); exp.m1(0);
	    exp.m2(5);
	    exp.m3(5); exp.m3(8); exp.m3(9);
	    exp.m4(6); exp.m4(10);
	    exp.m5(4);
	    exp.m6(3); exp.m6(4); exp.m6(5); exp.m6(6); // non_exe
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(5); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(8); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(10); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m2(6); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m3(4); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(10); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m4(5); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(11); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m5(3); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m5(5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(quanti_forall_char_exp.java)");
	}
    }
}
