import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class quanti_forall_exp {

    java.util.Collection c;
    java.util.Collection d;
    java.util.Collection e;
    {
	c = new java.util.ArrayList();
	d = new java.util.ArrayList();
	c.add(new Integer(5));
	d.add(new Integer(10));
    }

    //@ requires (\forall Integer y; c.contains(y); x > y.intValue());
    void m1(int x) {}

    //@ requires (\forall Integer y1; c.contains(y1);
    //@  (\forall Integer y2; d.contains(y2); 
    //@     x > y1.intValue() && x > y2.intValue()));
    void m2(int x) {}

    //@ requires (\forall Integer y; c.contains(y) || d.contains(y); 
    //@     x > y.intValue());
    void m3(int x) {}

    //@ requires (\forall Integer y; c.contains(y) && c.contains(y); 
    //@     x > y.intValue());
    void m4(int x) {}

    //@ requires (\forall Integer y; c.contains(y) && d.contains(y); 
    //@     x > y.intValue());
    void m5(int x) {}

    // exception during qset comuptation
    //@ requires (\forall Integer y; e.contains(y); x > y.intValue());
    void m99(int x) {}

    public static void main(String args[]) {
	quanti_forall_exp exp = new quanti_forall_exp();
	int fcnt = 0;

	try { 
	    exp.m1(6);
	    exp.m2(20);
	    exp.m3(20); exp.m3(30);
	    exp.m4(6); exp.m4(15);
	    exp.m5(0); exp.m5(6); exp.m5(15);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(4); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m2(4); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(7); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m3(4); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(7); fcnt++; } catch (JMLAssertionError e) {}

	try { exp.m4(4); fcnt++; } catch (JMLAssertionError e) {}

	// exception during qset calculation! polarity???
	try { exp.m99(4); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(quanti_forall_exp.java)");
	}
    }
}
