import org.jmlspecs.jmlrac.runtime.*;

public class quanti_numof {

    //@ requires (\num_of byte y; 0 < y && y <= x; true) == sum;
    void m1(byte x, byte sum) {}

    //@ requires (\num_of char y; 0 < y && y <= x; true) == sum;
    void m2(char x, char sum) {}

    //@ requires (\num_of short y; 0 < y && y <= x; true) == sum;
    void m3(short x, short sum) {}

    //@ requires (\num_of short y; 0 < y && y <= x; true) == sum;
    void m4(int x, int sum) {}

    //@ requires (\num_of long y; 0 < y && y <= x; true) == sum;
    void m5(long x, long sum) {}

    //@ requires (\num_of \bigint y; 0 < y && y <= x; true) == sum;
    void m7(long x, long sum) {}

    java.util.Collection c;
    { 
	c = new java.util.ArrayList();
	c.add(new Integer(5));
	c.add(new Integer(4));
    }
    //@ requires (\num_of Integer y; c.contains(y); y.intValue() > 4) == sum;
    void m6(int sum) {}
    
    public static void main(String args[]) {
	quanti_numof exp = new quanti_numof();
	int fcnt = 0;

	try { 
	    exp.m1((byte)1, (byte)1); 
	    exp.m1((byte)2, (byte)2); 
	    exp.m1((byte)3, (byte)3);

	    exp.m2((char)1, (char)1); 
	    exp.m2((char)2, (char)2); 
	    exp.m2((char)3, (char)3);

	    exp.m3((short)1, (short)1); 
	    exp.m3((short)2, (short)2); 
	    exp.m3((short)3, (short)3);

	    exp.m4(1, 1); exp.m4(2, 2);  exp.m4(3, 3);
	    exp.m5(1L, 1L); exp.m5(2L, 2L);  exp.m5(3L, 3L);
	    exp.m7(1L, 1L); exp.m7(2L, 2L);  exp.m7(3L, 3L);

	    exp.m6(1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1((byte)2,(byte)0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2((char)2,(char)0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3((short)2,(short)0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(2,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m5(2L,0L); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m7(2L,0L); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m6(0); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(quanti_numof.java)");
	}
    }
}
