import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_public1 {
    spec_public1_T t1 = new spec_public1_S(10); // gets -10
    spec_public1_T t2 = new spec_public1_T(10);
    spec_public1_S s1 = new spec_public1_S(10);

    //@ requires t1.val > x;
    void m1(int x) {}

    //@ requires t2.val > x;
    void m2(int x) {}

    //@ requires s1.val > x;
    void m3(int x) {}

    public static void main(String[] args) {
	spec_public1 exp = new spec_public1();
	int fcnt = 0;

	try {
	    exp.m1(-20);
	    exp.m2(5);
	    exp.m3(5);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(5); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(20); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(20); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_public1.java)");
    }    
}

class spec_public1_T {
    private /*@ spec_public @*/ int val;
    spec_public1_T(int x) {
	val = x;
    }

    //@ requires this.val > 0;
    void m2() {}
}

class spec_public1_S extends spec_public1_T {
    private /*@ spec_public @*/ int val;
    spec_public1_S(int x) {
	super(-x);
	val = x;
    }

    //@ requires super.val > 0 && this.val > 0;
    void m3() {}
}
