import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_public2 {
    /*@ spec_public @*/ private spec_public2_helper helper 
        = new spec_public2_helper();

    //@ ensures helper.val > 0;
    public void m1(int x) { helper.setValue(x); }

    public static void main(String args[]) {
	spec_public2 exp = new spec_public2();
	int fcnt = 0;

	try {
	    exp.m1(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_public2.java)");
    }    
}

class spec_public2_helper {
    private /*@ spec_public @*/ int val = 10;
    public void setValue(int x) { val = x; }
}
