import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_public3 extends spec_public3_super {
    //@ ensures val > 0;
    void m1(int x) { setVal(x); }

    //@ ensures this.val > 0;
    void m2(int x) {  setVal(x); }

    //@ ensures super.val > 0;
    void m3(int x) {  setVal(x); }

    public static void main(String[] args) {
	spec_public3 exp = new spec_public3();
	int fcnt = 0;

	try {
	    exp.m1(10);
	    exp.m2(10);
	    exp.m3(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(0); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_public3.java)");
    }    
}

class spec_public3_super {
    protected /*@ spec_public @*/ int val;
    protected void setVal(int x) { val = x; }
}
