import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

class supercall_super {
    public /*@ pure @*/ int val() { return 10; }
}

public class supercall extends supercall_super {
    public /*@ pure @*/ int val() { return 0; }

    //@ requires x > super.val();
    void m1(int x) {}

    public static void main(String args[]) {
	supercall exp = new supercall();
	int fcnt = 0;

	try {
	    exp.m1(11);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(supercall.java)");
	}
    }
}
