// Tests that the -private option works
//#JMLFLAGS: -private

public class Private {

  public boolean fPublic;
  protected int fProtected = 10;
  java.lang.String fPackage;
  private java.lang.Object fPrivate;

  public Private();

  protected Private(int i);

  Private(boolean b);

  private Private(Object o);

  public void mPublic();

  protected int mProtected(int i);

  String mPackage(String s, Object o);

  private double mPrivate(double d);


  public static class CPublic {
	public CPublic() {}
  }

  protected class CProtected {
	protected void m() {}
  }

  class CPackage {
	int f;
  }

  private class CPrivate {
	private int g;
  }
  
  public static interface IPublic {
	abstract void m();
  }

  protected interface IProtected {
	abstract void m();
  }

  interface IPackage {
	abstract void m();
  }

  private interface IPrivate {
	abstract void m();
  }
}
