#!/bin/csh
#
# $Id: example-developers-sourceme-unix.csh,v 1.5 2006/07/12 18:51:17 wdietl Exp $

# This file should be sourced (i.e., '. <filename>' or 'source <filename>')

# Java CLASSPATH setting (comment this out if you don't need it)
setenv CLASSPATH ".:${HOME}/MJ:/usr/local/antlr:/usr/local/junit:/usr/local/gnu:/usr/local/jdk1.4/lib/tools.jar"

# The shell's name of the directory containing the MJC project files
setenv PLSL_CLASSROOT "${HOME}/MJ"
setenv MJ_CLASSROOT "${HOME}/MJ"

# OS native (javac compatible) format for
# the name of the directory containing the MJC project files
setenv MJ_JCLASSROOT "${HOME}/MJ"

# Java file separator character on this machine
setenv JFILESEP '/'

# Java path separator character on this machine
setenv JPATHSEP ':'

# Name of the java compiler
setenv JAVAC 'javac'

# Name of the java virtual machine
setenv JAVA 'java'

# Temporary directory in OS native format
setenv JTEMP "$TEMP"

# Use forward slashes for the URIs below

# URI for the directory containing the javadocs for the JDK on this machine
setenv JDKDOCDIR 'file:/usr/local/jdk1.4/docs/api'

# URI for the directory containing the javadocs for antlr on this machine
setenv ANTLRDOCDIR 'file:/usr/local/antlr/javadocs'

# Give a -link <URI> option to other javadoc directories below if desired
setenv JDLINKS ''


## Copyright (C) 2000-2002 Iowa State University
##
## This file is part of mjc, the MultiJava Compiler.
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

