/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CDispatcherSignature.java,v 1.1 2002/06/13 22:37:20 cclifton Exp $
 */

package org.multijava.mjc;

/**
 * This interface is implemented by classes that represent the type
 * (i.e., $signature) for inner dispatcher classes of an external
 * generic function.
 *
 * @author Curtis Clifton
 * @version $Revision: 1.1 $ */
public interface CDispatcherSignature {

    String qualifiedName();

    CClassType getType();

}
