/* $Id: TestCaseGenerator.java,v 1.3 2004/11/13 17:40:38 leavens Exp $
 *
 * Copyright (C) 2003 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.multijava.mjc.testcase.bugs.typecheck;

import org.multijava.mjc.*;

public class TestCaseGenerator {

    public boolean hasCloneMethod(CClass selfClass) {
        CMethod result;
        try {
            result = selfClass.lookupMethod("clone",
                                            new CType[] {CStdType.Object},
                                            new CClassType[] {},
                                            null);
        } catch (UnpositionedError e) {
            return false;
        }
        return result != null;
    }
}
