#!/bin/sh
	
# Tests various combinations of naming, not naming, and reordering of
# files of command line.

#echo ... Testing BytecodeAttr2.sh

# compiled together we should detect ambiguity, regardless of order
rm -f BytecodeAttr2A.class BytecodeAttr2C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr2A.java BytecodeAttr2C.java

rm -f BytecodeAttr2A.class BytecodeAttr2C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr2C.java BytecodeAttr2A.java

# compiled separately we should detect ambiguity
rm -f BytecodeAttr2A.class BytecodeAttr2C.class
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr2A.java
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr2C.java # should get an error
