#!/bin/sh
	
# Tests various combinations of naming, not naming, and reordering of
# files of command line.

#echo ... Testing BytecodeAttr3.sh

# compiled together we should detect ambiguity, regardless of order
rm -f BytecodeAttr3A.class BytecodeAttr3B.class BytecodeAttr3C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr3A.java BytecodeAttr3B.java

rm -f BytecodeAttr3A.class BytecodeAttr3B.class BytecodeAttr3C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr3B.java BytecodeAttr3A.java

# compiled separately we should detect ambiguity
rm -f BytecodeAttr3A.class BytecodeAttr3B.class BytecodeAttr3C.class
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr3A.java
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr3B.java # should get an error
