package org.multijava.mjc.testcase.codegen;
import org.multijava.util.testing.Utils;
import org.multijava.util.testing.Diff;

public class StrAttributeATestCase extends org.multijava.util.testing.TestCase {

    public StrAttributeATestCase(String name) {
	super(name);
    }

    public void test() throws java.io.IOException {

	String s = Utils.executeCompile(org.multijava.dis.Main.class,
			new String[] {"--stdout","--sorted","--multijava",
					"StrAttributeA"});

	Diff df = Utils.compareStringToFile(s,"StrAttributeA.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}

    }
}
