package org.multijava.mjc.testcase.java5.generics;

public class RawTypeAccess2Fail<T> {

    RawTypeAccess2_Sub_Fail<Integer> f;

    RawTypeAccess2_Sub_Fail<Integer> m() { return null; };
}

class RawTypeAccess2_Sub_Fail<S> extends RawTypeAccess2Fail {

    S s;

    public void foo() {
        RawTypeAccess2_Sub_Fail raw = null;
        RawTypeAccess2_Sub_Fail<Integer> nonRaw = null;
        Integer i = null;

        // The types of raw.f and nonRaw.f are both erased since the field is
        // accessed on the type RawTypeAccess2OK which is always a raw type,
        // no matter whether its subtype is a raw type or not.
        // Note also that f's type is erased when accessed through a raw type
        // even though it does not depend on any type parameter!
        i = raw.f.s;
        i = nonRaw.f.s;

        // Check the very same thing with methods.
        i = raw.m().s;
        i = nonRaw.m().s;
    }
}
