package org.multijava.mjc.testcase.java5.generics;

public class RawTypeAccess2OK {

    RawTypeAccess2_Sub_OK<Integer> f;

    RawTypeAccess2_Sub_OK<Integer> m() { return null; };
}

class RawTypeAccess2_Sub_OK<S> extends RawTypeAccess2OK {

    S s;

    public void foo() {
        RawTypeAccess2_Sub_OK raw = null;
        Integer i = null;

        // The type of raw.f is NOT erased since the field is accessed on the
        // type RawTypeAccess2OK which is no raw type (and actually no generic
        // type at all) even though raw is a raw type.
        i = raw.f.s;

        // Check the very same thing with methods.
        i = raw.m().s;
    }
}
