package org.multijava.mjc.testcase.java5.generics;

public class RawTypeAccess3OK<T> {

    static RawTypeAccess3_Sub_OK<Integer> f;

    static RawTypeAccess3_Sub_OK<Integer> m() { return null; };
}

class RawTypeAccess3_Sub_OK<S> extends RawTypeAccess3OK {

    S s;

    public void foo() {
        RawTypeAccess3_Sub_OK raw = null;
        RawTypeAccess3_Sub_OK<Integer> nonRaw = null;
        Integer i = null;

        // In both cases, the field f is accessed on the raw type RawTypeAccess3OK.
        // However, since the field is static, it's type is not erased.
        i = raw.f.s;
        i = nonRaw.f.s;

        // Check the very same thing with methods.
        i = raw.m().s;
        i = nonRaw.m().s;
    }
}
