package org.multijava.mjc.testcase.java5.generics;

public class RawTypeMethodCall2Unchecked<T extends Number> {

    public void foo(RawTypeMethodCall2Unchecked<Integer> p) { }

    public void bar(T t) { }

    class Sub extends RawTypeMethodCall2Unchecked {

        public void sub_foo() {
            Sub nonRaw = null;

            // nonRaw itself is no raw type, but the methods are declared in its
            // supertype RawTypeMethodCall2Unchecked which is a raw type.

            nonRaw.foo(new RawTypeMethodCall2Unchecked<Integer>());

            nonRaw.bar(new Integer(0));
        }
    }
}
