package org.multijava.mjc.testcase.java5.generics;

public class WildcardAssignment1Fail<T extends Number> {

    WildcardAssignment1Fail<?> b1;

    WildcardAssignment1Fail<? extends Integer> b2;

    WildcardAssignment1Fail<? super Integer> b3;

    WildcardAssignment1Fail<? extends Number> b4;

    WildcardAssignment1Fail<? super Number> b5;

    T t;

    public void foo() {
        b1.t = b2.t;
        b1.t = b3.t;
        b1.t = b4.t;
        b1.t = b5.t;

        b2.t = b1.t;
        b2.t = b3.t;
        b2.t = b4.t;
        b2.t = b5.t;

        b3.t = b1.t;
        b3.t = b4.t;
        b3.t = b5.t;

        b4.t = b1.t;
        b4.t = b2.t;
        b4.t = b3.t;
        b4.t = b5.t;
    }
}

// If the type variable has no bound, some additional statements are wrong,
// so let's check for these.
class WildcardAssignment1NoBoundFail<T> {

    WildcardAssignment1NoBoundFail<?> b1;

    WildcardAssignment1NoBoundFail<? super Integer> b3;

    WildcardAssignment1NoBoundFail<? super Number> b5;

    T t;

    public void foo() {
        b5.t = b1.t;
        b5.t = b3.t;
    }
}
