package org.multijava.mjc.testcase.java5.generics;

import java.io.Serializable;
import java.util.AbstractList;
import java.util.Vector;

public class WildcardCapture1OK<T extends AbstractList & Cloneable & Serializable> {

    WildcardCapture1OK<?> b1;

    WildcardCapture1OK<? extends Vector> b2;

    WildcardCapture1OK<? super Vector> b3;

    T t;

    public void foo() {
        AbstractList abstractList = null;
        Cloneable cloneable = null;
        Serializable serializable = null;
        Vector vector = null;

        abstractList = b1.t;
        abstractList = b2.t;
        abstractList = b3.t;

        cloneable = b1.t;
        cloneable = b2.t;
        cloneable = b3.t;

        serializable = b1.t;
        serializable = b2.t;
        serializable = b3.t;

        vector = b2.t;
    }
}
