package org.multijava.mjc.testcase.java5.generics;

/*
 * Make sure that applying capture conversion to the toplevel wildcard type
 * arguments leads to the below assigments to produce compiler errors.
 */
public class WildcardCapture3Fail<T extends Number> {

    WildcardCapture3Fail<T> f;

    WildcardCapture3Fail<?> b1;

    WildcardCapture3Fail<? extends Integer> b2;

    WildcardCapture3Fail<? super Integer> b3;

    WildcardCapture3Fail<? extends Number> b4;

    WildcardCapture3Fail<? super Number> b5;

    public void foo() {
        b1.f = b2.f;
        b1.f = b3.f;
        b1.f = b4.f;
        b1.f = b5.f;

        b3.f = b5.f;

        b4.f = b1.f;
        b4.f = b2.f;
        b4.f = b3.f;
        b4.f = b5.f;
    }
}
