package org.multijava.mjc.testcase.java5.generics;

/*
 * Make sure that applying capture conversion to the toplevel wildcard type
 * arguments leads to the below assigments to produce compiler errors.
 */
public class WildcardCapture4Fail<T extends Number> {

    WildcardCapture4Fail<T> f;

    WildcardCapture4Fail<?> b1;

    WildcardCapture4Fail<? extends Integer> b2;

    WildcardCapture4Fail<? super Integer> b3;

    WildcardCapture4Fail<? extends Number> b4;

    WildcardCapture4Fail<? super Number> b5;

    public void foo() {
        b1.f = new WildcardCapture4Fail<Number>();
        b1.f = new WildcardCapture4Fail<Integer>();

        b2.f = new WildcardCapture4Fail<Integer>();

        b3.f = new WildcardCapture4Fail<Number>();
        b3.f = new WildcardCapture4Fail<Integer>();

        b4.f = new WildcardCapture4Fail<Number>();
        b4.f = new WildcardCapture4Fail<Integer>();

        b5.f = new WildcardCapture4Fail<Number>();
    }
}
