package org.multijava.mjc.testcase.java5.generics;

import java.math.BigInteger;

/*
 * Make sure that capture conversion is never applied to the LHS of an assignment
 * thereby allowing for the below assignments.
 */
public class WildcardCapture7OK<T> {

    WildcardCapture7OK<? extends Number> field;

    public void foo(WildcardCapture7OK<? extends BigInteger> param) {
        WildcardCapture7OK<BigInteger> bigInteger = null;

        WildcardCapture7OK<? extends Number> local = null;
        local = bigInteger;

        param = bigInteger;

        field = bigInteger;

        WildcardCapture7OK<?> wc = null;
        wc.field = bigInteger;

        // check array access
        WildcardCapture7OK<? extends Number>[] wcArray = null;
        wcArray[0] = bigInteger;
    }
}
