package org.multijava.mjc.testcase.java5.generics;

public class WildcardTypeAssignmentFrom1Fail<T extends Number> {

    WildcardTypeAssignmentFrom1Fail<?> b1;

    WildcardTypeAssignmentFrom1Fail<? extends Integer> b2;

    WildcardTypeAssignmentFrom1Fail<? super Integer> b3;

    WildcardTypeAssignmentFrom1Fail<? extends Number> b4;

    WildcardTypeAssignmentFrom1Fail<? super Number> b5;

    T t;

    public void foo() {
        Integer integer = new Integer(0);
        Float floatt = new Float(0.0f);

        integer = b1.t;
        integer = b3.t;
        integer = b4.t;
        integer = b5.t;

        floatt = b1.t;
        floatt = b2.t;
        floatt = b3.t;
        floatt = b4.t;
        floatt = b5.t;
    }
}

//If the type variable has no bound, some additional statements are wrong,
//so let's check for these.
class WildcardTypeAssignmentFrom1NoBoundFail<T> {

    WildcardTypeAssignmentFrom1NoBoundFail<?> b1;

    WildcardTypeAssignmentFrom1NoBoundFail<? super Integer> b3;

    WildcardTypeAssignmentFrom1NoBoundFail<? super Number> b5;

    T t;

    public void foo() {
        Number number = new Integer(0);

        number = b1.t;
        number = b3.t;
        number = b5.t;
    }
}
