package org.multijava.mjc.testcase.java5.generics;

public class WildcardTypeAssignmentTo1OK<T extends Number> {

    WildcardTypeAssignmentTo1OK<?> b1;

    WildcardTypeAssignmentTo1OK<? extends Integer> b2;

    WildcardTypeAssignmentTo1OK<? super Integer> b3;

    WildcardTypeAssignmentTo1OK<? extends Number> b4;

    WildcardTypeAssignmentTo1OK<? super Number> b5;

    T t;

    public void foo() {
        // assigning null to a wildcard is always fine
        b1.t = null;
        b2.t = null;
        b3.t = null;
        b4.t = null;
        b5.t = null;

        Number number = new Integer(0);
        Integer integer = new Integer(0);

        b5.t = number;

        b3.t = integer;
        b5.t = integer;
    }
}
