package org.multijava.mjc.testcase.java5.generics;

public class WildcardTypeMethodParam1Fail<T extends Number> {

    WildcardTypeMethodParam1Fail<?> b1;

    WildcardTypeMethodParam1Fail<? extends Integer> b2;

    WildcardTypeMethodParam1Fail<? super Integer> b3;

    WildcardTypeMethodParam1Fail<? extends Number> b4;

    WildcardTypeMethodParam1Fail<? super Number> b5;

    T t;

    public void foo(T x) {
    }

    // We put the statements into separate methods to check everything in a
    // single file as the compiler would stop at the first error of this kind.

    void m1() {
        Object object = new Object();
        b1.foo(object);
    }

    void m2() {
        Object object = new Object();
        b2.foo(object);
    }

    void m3() {
        Object object = new Object();
        b3.foo(object);
    }

    void m4() {
        Object object = new Object();
        b4.foo(object);
    }

    void m5() {
        Object object = new Object();
        b5.foo(object);
    }

    void m6() {
        Number number = new Integer(0);
        b1.foo(number);
    }

    void m7() {
        Number number = new Integer(0);
        b2.foo(number);
    }

    void m8() {
        Number number = new Integer(0);
        b3.foo(number);
    }

    void m9() {
        Number number = new Integer(0);
        b4.foo(number);
    }

    void m10() {
        Integer integer = new Integer(0);
        b1.foo(integer);
    }

    void m11() {
        Integer integer = new Integer(0);
        b2.foo(integer);
    }

    void m12() {
        Integer integer = new Integer(0);
        b4.foo(integer);
    }
}
