package org.multijava.mjc.testcase.java5.generics;

public class WildcardTypeMethodReturn1Fail<T extends Number> {

    WildcardTypeMethodReturn1Fail<?> b1;

    WildcardTypeMethodReturn1Fail<? extends Integer> b2;

    WildcardTypeMethodReturn1Fail<? super Integer> b3;

    WildcardTypeMethodReturn1Fail<? extends Number> b4;

    WildcardTypeMethodReturn1Fail<? super Number> b5;

    T t;

    public T foo() {
        Integer integer = new Integer(0);
        Float floatt = new Float(0.0f);

        integer = b1.foo();
        integer = b3.foo();
        integer = b4.foo();
        integer = b5.foo();

        floatt = b1.foo();
        floatt = b2.foo();
        floatt = b3.foo();
        floatt = b4.foo();
        floatt = b5.foo();

        return null;
    }
}

//If the type variable has no bound, some additional statements are wrong,
//so let's check for these.
class WildcardTypeMethodReturn1NoBoundFail<T> {

    WildcardTypeMethodReturn1NoBoundFail<?> b1;

    WildcardTypeMethodReturn1NoBoundFail<? super Integer> b3;

    WildcardTypeMethodReturn1NoBoundFail<? super Number> b5;

    T t;

    public T foo() {
        Number number = new Integer(0);

        number = b1.foo();
        number = b3.foo();
        number = b5.foo();

        return null;
    }
}
