// adapted from class C from Clifton-01, Figures 24 and 25

package org.multijava.mjc.testcase.runtime;
import org.multijava.mjc.testcase.runtime.upcalls.A;
import org.multijava.mjc.testcase.runtime.upcalls.B;
import org.multijava.mjc.testcase.runtime.upcalls.extGF1;
import org.multijava.mjc.testcase.runtime.upcalls.extGF2;

public class Upcalls_s_e1 extends B {
    public static void main (String[] args) {
	new Upcalls_s_e1().extGF1(new Integer(1));
	new Upcalls_s_e1().extGF1(new Float(1.0f));
    }
    
    public void intGF1(Object@Number n) {
	System.out.println("In Upcalls_s_e1::intGF1(Object@Number)");
    }
    
    public void intGF1(Object@Float n) {
	System.out.println("In Upcalls_s_e1::intGF1(Object@Float)");
    }

    public void extGF1(Object@Number n) {
	System.out.println("In Upcalls_s_e1::extGF1(Object@Number)");
	super.intGF1(n);
    }

    public void extGF1(Object@Float n) {
	System.out.println("In Upcalls_s_e1::extGF1(Object@Float)");
 	super.intGF1(n);
   }
}
