// Test case for bug 719438 on search for implicitly imported external
// generic functions.

package org.multijava.mjc.testcase.typecheck;

import org.multijava.mjc.*;
import java.util.ArrayList;

public class Main extends org.multijava.mjc.Main {
    public void main() {
	// the presence of this method and the import above trigger
	// the compilation of org/multijava/mjc/Main.java looking for
	// an external generic function.
    }

    // The following nested class exposes a bug where the
    // CSourceClasses for nested types are not flushed following the
    // abortion of compilation of org/multijava/mjc/Main.java.
    public class MyParseTask extends ParseTask {
	MyParseTask(ArrayList foo) {
	    super(foo);
	}
    }
}
