// Some illegal resends

package org.multijava.mjc.testcase.typecheck;

public class Resend4 {
    void m1(final Object o1, final Object o2) {
	resend(o1, o2);		// error, no overridden methods
    }

    void m1(Object o1, final Object@Resend4 r2) {
	resend(o1,r2);		// OK
    }

    void m1(final Object@Resend4 r1, Object o2) {
	resend(r1,o2); 		// OK
    }

    void m1(final Object@Resend4 r1, final Object@Resend4 r2) {
	resend(r1,r2); 		// error, ambiguous
    }

    void m2(Object o) { }

    void m2(final Object@Resend4 r) {
	resend();		// error, wrong number of arguments
    }
 
    void m3(Object o) { }
 
    void m3(final Object@Resend4 r) {
	resend(r,r);		// error, wrong number of arguments
    }
 
    void m4(Number n1, Number n2) { }
 
    void m4(final Number@Integer i1, final Number n2) {
	resend(i1, new Object());	// error, wrong argument type
    }

    void m5(Number n) { }
 
    void m5(final Number@Integer i) {
	i.resend(i);		// error, wrong receiver type
    }
}
