#!/bin/sh

# IF YOU MODIFY THJIS FILE, YOU NEED TO MAKE CORRESPONDING MODIFICATIONS TO
# TopMethodCalcTestCase.java

# cannot use $USERMJCFLAGS argument to mjc.Main, since this file is processed
# by some JUnit harnesses that don't know about it
	
# Tests various combinations of naming, not naming, and reordering of
# files of command line.

# We are concerned with the external generic function so permutations
# that don't include TopMethodCalc1C.java or topMethodCalc1func.java,
# or that difer only in the order of TopMethodCalc1A.java and 
# TopMethodCalc1B.java are skipped.

echo ... Testing TopMethodCalc.sh

# singles
#java org.multijava.mjc.Main -W TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java
java org.multijava.mjc.Main -W topMethodCalc1func.java

# doubles
#java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java topMethodCalc1func.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1C.java

# triples
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1B.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1B.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1C.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1C.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1A.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1A.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1C.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1C.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1A.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1A.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1B.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1B.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1B.java

# home runs
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1B.java TopMethodCalc1C.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1C.java TopMethodCalc1B.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1B.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1B.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1A.java TopMethodCalc1C.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1C.java TopMethodCalc1A.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1A.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1A.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1A.java TopMethodCalc1B.java topMethodCalc1func.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1A.java topMethodCalc1func.java TopMethodCalc1B.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1B.java TopMethodCalc1A.java topMethodCalc1func.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java TopMethodCalc1B.java topMethodCalc1func.java TopMethodCalc1A.java
java org.multijava.mjc.Main -W TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1B.java
#java org.multijava.mjc.Main -W TopMethodCalc1C.java topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1A.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1B.java TopMethodCalc1C.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1A.java TopMethodCalc1C.java TopMethodCalc1B.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1A.java TopMethodCalc1C.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1B.java TopMethodCalc1C.java TopMethodCalc1A.java
java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1A.java TopMethodCalc1B.java
#java org.multijava.mjc.Main -W topMethodCalc1func.java TopMethodCalc1C.java TopMethodCalc1B.java TopMethodCalc1A.java

