// Some illegal resends

package org.multijava.mjc.testcase.typecheck;

void Object.resendMethod4(final Object o) {
    resend(o);		// error, no overridden methods
}

void Object.resendMethod4(final Object@Number n) {
    resend(n);		// OK
}

void Number.resendMethod4(final Object o) {
    resend(o); 		// OK
}

void Number.resendMethod4(final Object@Number n) {
    resend(n); 		// error, ambiguous
}

void Number.resendMethod4(Object@String s) {
    resend(s);			// error, s not final
}

void Number.resendMethod4(final Object@Boolean b) {
    resend(new Object());	// error, arg must be b
}

void Object.resendMethod4A(Object o) { }

void Object.resendMethod4A(final Object@Number n) {
    resend();		// error, wrong number of arguments
}

void Object.resendMethod4B(Object o) { }

void Object.resendMethod4B(final Object@Number n) {
    resend(n,n);		// error, wrong number of arguments
}

void Number.resendMethod4C() { }

void Integer.resendMethod4C() {
    new Object().resend();	// error, wrong receiver type
}

void Float.resendMethod4C() {
    this.resend();	// OK
}


