package org.multijava.mjc.testcase.typecheck;

import org.multijava.util.testing.Diff;

public class reservedWordTestsTestCase 
    extends org.multijava.util.testing.TestCase 
{

    public reservedWordTestsTestCase(String n) {
	super(n);
    }

    String[][] args = new String[][]{
	{"--relaxed", "Glue.java"},
	{"--nomultijava", "ResendSyntax.java"}};

    public void test() throws java.io.IOException {
	StringBuffer sb = new StringBuffer();
	for (int i=0; i<args.length; ++i) {
	    String[] ar = args[i];

	    sb.append("TESTING");
	    for (int k=0; k<ar.length; ++k) sb.append(" " + ar[k]);
	    sb.append(System.getProperty("line.separator"));

	    String s = org.multijava.util.testing.Utils.executeCompile(
		org.multijava.mjc.Main.class, ar);

	    sb.append(s);
	}
	String s = sb.toString();
	Diff df = org.multijava.util.testing.Utils.compareStringToFile(s,"reservedWordTests.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}

    }
}
