package org.multijava.mjc.testcase.typecheck;

// -------------------------------------------------------------
// In each pair of methods the second statically overloads the
// first when it could use multiple dispatch.
void Object.staticOverloadWarnings2a(Object o) {}
void Object.staticOverloadWarnings2a(Number n) {}

void Object.staticOverloadWarnings2b(Object o) {}
void Number.staticOverloadWarnings2b(Number n) {}

// -------------------------------------------------------------
// No warnings here, because multiple dispatch is used
void Object.staticOverloadWarnings2c(Object o) {}
void Object.staticOverloadWarnings2c(Object@Number n) {}

void Object.staticOverloadWarnings2d(Object o) {}
void Number.staticOverloadWarnings2d(Object@Number n) {}

// -------------------------------------------------------------
// This method is an error so that the compilation return value is
// false, correpsonding to what is expected given the "error"
// output for the cautions.
void Object.staticOverloadWarnings2e() {
    return "error";
}
