package org.multijava.mjc.testcase.typecheck;

import org.multijava.util.testing.Diff;

public class testsTestCase extends org.multijava.util.testing.TestCase {

    public testsTestCase(String n) {
	super(n);
    }

    String[][] args = new String[][]{
			{"OK.java","OK2.java"},
			{"OK.java","BadParse.java","BadParse2.java","OK2.java"},
			{"NoSuper.java","OK.java"},
			{"OKSuper.java","OK.java"},
			{"BadSuper.java","OK.java"},
			{"OKSuperSuper.java","OK.java"},
			{"BadSuperSuper.java","OK.java"},
			{"BadBody.java"}};

    String[] common = new String[]{"-classpath",".","-M","-W"};

    public void test() throws java.io.IOException {
	StringBuffer sb = new StringBuffer();
	for (int i=0; i<args.length; ++i) {
	    String[] a = args[i];
	    String[] ar = new String[common.length+a.length];
	    System.arraycopy(common,0,ar,0,common.length);
	    System.arraycopy(a,0,ar,common.length,a.length);

	    sb.append("TESTING");
	    for (int k=0; k<a.length; ++k) sb.append(" " + a[k]);
	    sb.append(System.getProperty("line.separator"));

	    String s = org.multijava.util.testing.Utils.executeCompile(
		org.multijava.mjc.Main.class, ar);

	    sb.append(s);
	}
	String s = sb.toString();
	Diff df = org.multijava.util.testing.Utils.compareStringToFile(s,"tests.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}

    }
}
