#!/bin/sh
	
# tests the sourcecode transformations applied to instanceof
# for normal references (arrays are tested in )

echo ... Testing array_instanceof.sh

rm -f array_instanceof*.class external.class functions.class

# instanceof peer
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_peer_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_peer_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_peer_fail1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_peer_fail1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_peer_fail2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_peer_fail2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_peer_fail3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_peer_fail3

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_peer_fail4.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_peer_fail4

# instanceof rep
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_rep_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_rep_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_rep_fail1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_rep_fail1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_rep_fail2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_rep_fail2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_rep_fail3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_rep_fail3

# instanceof readonly
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_readonly_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_readonly_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_readonly_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_readonly_success2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_instanceof_readonly_success3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_instanceof_readonly_success3
