#!/bin/sh
	
# tests the sourcecode transformations applied to instanceof
# for normal references (arrays are tested in )

echo ... Testing instanceof.sh

rm -f instanceof*.class external.class functions.class

# compile this one *without* universe support
# it gets called later and simulates external non-universe aware libs
${JAVA} org.multijava.mjc.Main $USERMJCFLAGS external.java

# helper functions
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS functions.java

# instanceof peer
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_peer_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_peer_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_peer_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_peer_success2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_peer_fail1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_peer_fail1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_peer_fail2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_peer_fail2

# instanceof rep
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_rep_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_rep_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_rep_fail1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_rep_fail1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_rep_fail2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_rep_fail2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_rep_fail3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_rep_fail3

# instanceof readonly
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_readonly_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_readonly_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_readonly_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_readonly_success2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS instanceof_readonly_success3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.instanceof_readonly_success3
