#!/bin/sh
	
# tests if interaction with native code is handled well

# threads are special because their HashtableEntries
# store additional information

echo ... Testing native.sh

rm -f native*.class functions.class

# helper
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS functions.java

# compile this one *without* universe support
# it gets called later and simulates external non-universe aware libs
${JAVA} org.multijava.mjc.Main $USERMJCFLAGS native_external.java

# tests
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS native_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.native_success
