#!/bin/sh
	
# tests if static methods are handled well

echo ... Testing static.sh

rm -f static*.class functions.class native_external.class

# helper
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS functions.java

# compile this one *without* universe support
# it gets called later and simulates external non-universe aware libs
${JAVA} org.multijava.mjc.Main $USERMJCFLAGS native_external.java

# tests
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS static_peer_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.static_peer_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS static_peer_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.static_peer_success2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS static_rep_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.static_rep_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS static_rep_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.static_rep_success2
