/**
Changes from default to rep/peer are not possible, only
going to readonly is allowed.

@author Werner Dietl
*/
public class OverridingChangeSignature3 {

    static class Super {
	rep Object m( rep Object a ) {
	    System.out.println("Super m");
            return a;
	}
    }

    static class Sub extends Super {
	rep Object m( Object a ) { // error
	    super.m(a);
	    System.out.println("Sub m");
            return null;
	}
    }

    peer Object o;
    peer Sub s = new peer Sub();
    any Object f = s.m(o);

    public static void main( String[] args ) {
	peer Sub s = new peer Sub();
	s.m( new peer Integer(4) );
    }
}
