/**
If an overriding method provides an inconsistent Universe modifier
we create an error.

@author Werner Dietl
*/
public class OverridingSignatureError {

    static class Super {
	void m( peer Integer a ) {
	    System.out.println("Super m");
	}
    }

    static class Sub extends Super {
	void m( rep Integer a ) {
	    super.m(a);
	    System.out.println("Sub m");
	}
    }

    public static void main( String[] args ) {
	Super s = new Sub();
	s.m( new Integer(4) );
    }

}
