/** 
 * Pure constructors in inner classes work, but can not
 * assign to fields of the outer class.
 */
class Constructor_03 {
    int i;
    Object f;
    Object[] a;

    static Object sf;

    class C03_Inner {
	int my_i;
	Object my_f;
	readonly peer Object[] my_a;

	pure C03_Inner() {
	    // OK
	    my_i = 6;
	    my_f = new C03_Inner();
	    my_a = new Object[10];

	    // not OK
	    my_a[1] = my_f;

	    i = 5;
	    Constructor_03.this.i = 4;

	    f = new C03_Inner();

	    a = new Object[10];
	    a[1] = f;

	    sf = null;
	}
    }
}
