/**
    This class determines the version of the tools classes used in Javadoc,
    which on many platforms is the tools.jar library.
*/

package org.multijava.mjdoc;
import java.lang.reflect.Method;

public class ToolsVersion {

    static public int version() {
	try {
	Class c = Class.forName("com.sun.javadoc.Tag");
	try {
	    Method m = c.getDeclaredMethod("holder",new Class[0]);
	    return 142;
	} catch (NoSuchMethodException e) {
	    return 141;
	}
	} catch (Exception e) {
	    return 0;
	}
    }

    public static void main(String[] args) {
	try {
	    System.out.println(version());
	} catch (Exception e) {
	    System.out.println("FAILED " + e);
	}
    }
}
