/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MjMemberDoc.java,v 1.1 2004/01/14 11:05:44 davidcok Exp $
 * Author: David R. Cok
 */

package org.multijava.mjdoc.mjdoc_142;
import com.sun.javadoc.*;

/** This class implements the javadoc MemberDoc interface, but it clearly
    does not do very much.
    @author David R. Cok
*/
public abstract class MjMemberDoc extends MjProgramElementDoc 
    implements MemberDoc 
{

    /** Not sure what this definition should be or when it is called -
	probably something to do with compiler generated
	members. !FIXME!  */
    public boolean isSynthetic() { return false; }
    
    /** Constructs an object, by simply constructing the super class object. */
    public MjMemberDoc(MjClassDoc container) {
	super(container);
    }
}
