
public class Multi2 extends Multi1 {

	//overrides Multi1.m1(Object) with some multimethods
	// could link each to the overridden method, or have a single
	// "Overrides:" link?
    public void m1(Object@String s) {}
    public void m1(Object@Multi1 m) {}

	// inherit Multi1.m2(Object), override the others, add a new
	// multimethod
        // these two methods directly override the
	// identical methods from Multi1, but maybe one "Overrides:"
	// link pointing to all the multimethods from Multi1 is
	// sufficient?
    public void m2(Object@String s) {}
    public void m2(Object@Multi1 m) {}
	// this multimethod overrides the one directly above
    public void m2(Object@Multi2 m) {}

	// these methods belong to the external operation in foo.java...
	// this fact should be pointed out in the documentation
	// this method overrides the Multi1.foo method in foo.java
    public void foo(Object o) {}
	// this method overrides the above foo method
    public void foo(Object@Multi2 m) {}
}
