import java.lang.reflect.*;

public class main {
    public static void main(String args[]) throws Exception {
	if (args.length < 0) {
	    test();
	} else {
	    System.out.println("OK; just checking compilation here");
	}
    }

    public static void test() throws Exception {
	Class testClass = null;
	try {
	    Method runTestMethod = 
		testClass.getDeclaredMethod("runTest", new Class[0]);
	    try {
		try {
		    System.out.println("invoking method");
		    runTestMethod.invoke(null, new Object[0]);
		} finally {
		    System.out.println("finally");
		}
		System.out.println("OK");
	    } catch (InvocationTargetException ex) {
		System.out.println("invocation target exception");
		ex.printStackTrace();
	    } catch(Exception ex) {
		System.out.println("???? other exception:");
		ex.printStackTrace();
	    }
	} catch(NoSuchMethodException ex) {
	    System.out.println("#### runTest() method missing");
	} catch(SecurityException ex) {
	    System.out.println("???? security exception (!?)");
	}
    }
}
