package org.multijava.relaxed.util;

public class Hexdump
{
    static public String byte2hex(byte b)
    {
	String s = Integer.toHexString(b);
	if (s.length() > 2)
	    s = s.substring(s.length() - 2,s.length());
	while (s.length() < 2)
	    s = "0" + s;
	return s;
    }

    static public String int2hex(int i)
    {
	String s = Integer.toHexString(i);
	while (s.length() < 8)
	    s = "0" + s;
	return s;
    }

    static public void dump(byte[] byteArray)
    {
	int l = byteArray.length;

	for (int i = 0; i < l; i += 16) {
	    System.out.print(int2hex(i) + ": ");
	    for (int j = i; j < l && j < i + 16; j++) {
		System.out.print(" " + byte2hex(byteArray[j]));
	    }
	    System.out.println();
	}
    }
}
