/*
 * This file is part the Universe Annotation Classes.
 *
 * Copyright (C) 2003-2005 Swiss Federal Institute of Technology Zurich
 *
 * Part of mjc, the MultiJava Compiler.
 *
 * Copyright (C) 2000-2005 Iowa State University
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: UniversePure.java,v 1.1 2005/06/24 09:02:58 wdietl Exp $
 */

package org.multijava.universes;

import java.lang.annotation.*;

/**
 * This is a marker annotation.
 * If it is present, then the annotated method is pure.
 *
 * @author AHS
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface UniversePure {
    /* empty marker annotation */
}
