/*
 * Definitions of the input token vacabulary for JML.
 * $Id: JmlExprID.t,v 1.18 2008/03/16 16:03:50 wdietl Exp $
 */

@package	org.jmlspecs.checker
@vocabulary	JmlExprID

/*
 * Extends JmlTopID.t, adding the additional keywords from the
 * jml-predicate-keyword non-terminal of the JML-PDD, Appendix B.
 */

@flags		QUANTIFIER

@literal	BS_TYPE			"\\TYPE"
@literal	BS_bigint		"\\bigint"
@literal	BS_bigint_math		"\\bigint_math"
@literal	BS_duration		"\\duration"
@literal	BS_elemtype		"\\elemtype"
@literal	BS_everything		"\\everything"
@literal	BS_exists		"\\exists"		@flags QUANTIFIER
@literal	BS_forall		"\\forall"		@flags QUANTIFIER
@literal	BS_fresh		"\\fresh"
@literal	BS_into			"\\into"
@literal	BS_invariant_for	"\\invariant_for"
@literal	BS_is_initialized	"\\is_initialized"
@literal	BS_java_math		"\\java_math"
@literal	BS_lblneg		"\\lblneg"
@literal	BS_lblpos		"\\lblpos"
@literal	BS_lockset		"\\lockset"
@literal	BS_max			"\\max"			@flags QUANTIFIER
@literal	BS_min			"\\min"			@flags QUANTIFIER
@literal	BS_nonnullelements	"\\nonnullelements"
@literal	BS_not_modified		"\\not_modified"
@literal	BS_not_assigned		"\\not_assigned"
@literal	BS_not_specified	"\\not_specified"
@literal	BS_nothing		"\\nothing"
@literal	BS_nowarn		"\\nowarn"
@literal	BS_nowarn_op		"\\nowarn_op"
@literal	BS_num_of		"\\num_of"		@flags QUANTIFIER
@literal	BS_old			"\\old"
@literal	BS_only_assigned	"\\only_assigned"
@literal	BS_only_accessed	"\\only_accessed"
@literal	BS_only_called		"\\only_called"
@literal	BS_only_captured	"\\only_captured"
@literal	BS_other		"\\other"
@literal	BS_pre			"\\pre"
@literal	BS_product		"\\product" 		@flags QUANTIFIER
@literal	BS_reach		"\\reach"
@literal	BS_real			"\\real"
@literal	BS_result		"\\result"
@literal	BS_safe_math		"\\safe_math"
@literal	BS_same			"\\same"
@literal	BS_space		"\\space"
@literal	BS_such_that		"\\such_that"
@literal	BS_sum			"\\sum" 		@flags QUANTIFIER
@literal	BS_type			"\\type"
@literal	BS_typeof		"\\typeof"
@literal	BS_warn			"\\warn"
@literal	BS_warn_op		"\\warn_op"
@literal	BS_working_space	"\\working_space"

// WMD added
@literal        U_peer				"\\peer"
@literal        U_rep				"\\rep"
@literal	U_readonly			"\\readonly"
@literal	U_any				"\\any"
