// @(#)$Id: BritishModelProgram.java,v 1.1 2005/07/12 02:32:34 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;

public abstract class BritishModelProgram {

  //@ public ghost int theGhost;

  //@ public model int theModel;
  protected int theRep;
  //@           in theModel;
  //@ protected represents theModel <- theRep;

  /*@ public model_program {
    @   behaviour
    @     requires theGhost > 0;
    @     assignable theGhost, theModel;
    @     assignable_redundantly theRep;
    @     ensures theGhost > theModel;
    @   abrupt_behaviour
    @     returns \result == 3 && theModel < 0;
    @   loop:
    @   while (true) {
    @     abrupt_behaviour
    @       diverges 4 > x;
    @       continues x == 4;
    @       breaks 4 < x;
    @   }
    @ }
    @*/
    public abstract int m(int x);
}
