// @(#)$Id: InnerPrivate2.java,v 1.2 2002/10/28 12:18:38 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// AUTHOR: David R. Cok

package org.jmlspecs.checker.testcase.syntax;

class InnerPrivate2 {

     static private int n = 3;
     private int m = n;

     int useM() { return m; }

     static private class I  extends InnerPrivate2 {
          I i = new I();
          static private int nn = n;

          static private class II {

               I ii = new I();
               int m = nn;
               int nnn = n;

          }
     }
}
