/*
 * Copyright (C) 2000-2001 Iowa State University
 *
 * This file is part of JML
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: IntAndByte.java,v 1.1 2003/06/01 08:23:18 leavens Exp $
 */

package org.jmlspecs.checker.testcase.syntax;

public class IntAndByte {

    public static final int TID_BYTE = 0;
    public static final int TID_BOOLEAN = 1;

    public void test(int x) {

        byte	num;

        switch (x) {
        case TID_BYTE:
            num = 8;
            break;
        case TID_BOOLEAN:
            num = 4;
            break;
        default:
            fail();
            num = -1;
        }

    }

    public void fail() {}
}
