// @(#)$Id: MyClass.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class MyObject{

   public int x;
}

public class MyClass {

   // constants

   public final static int MAX_LEN=10;
      
   public static MyObject[] myArray = new MyObject[MAX_LEN]; 

  /*@ behavior
    @ requires \nonnullelements(myArray);
    @ assignable myArray[*].x;  // it is not supported
    @ ensures true;
    @*/
   public void changeObjects()
    {    for (int i=0; i< MAX_LEN; i++)
		changeObject (i);
    }
    
  /*@ behavior
    @ requires myArray!=null && myArray[i]!=null;
    @ assignable myArray[i].x;  // it is not supported
    @ ensures true;
    @*/
    public void changeObject(int i)
    {   myArray[i].x=5;
    }
}
