// @(#)$Id: PureInAnonymousClassMethod.java,v 1.1 2004/10/01 21:36:59 leavens Exp $

// Copyright (C) 2004 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public class PureInAnonymousClassMethod {

    // JNewAnonymousClassExpression
    //@ requires new AbsClas(x) { pure int val() { return x; } }.val() > 10;
    void foo(final int x) {
        new AbsClas(x) { int val() { return x; } }.val();
    }
}

abstract class AbsClas { 
    public AbsClas(int x) {}
}
