// @(#)$Id: SigOnly.java,v 1.4 2005/07/11 17:57:45 leavens Exp $

// Copyright (C) 2005 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public abstract class SigOnly { 

    //@ signals_only Exception, RuntimeException;
    public void test1() {}

    //@ signals_only java.lang.RuntimeException;
    public void test2() {}

    //@ signals_only RuntimeException;
    public void test3() {}

    //@ signals_only java.io.IOException;
    public void test4() throws java.io.IOException {}

    //@ signals_only_redundantly Exception, RuntimeException;
    public void test5() {}

    //@ signals_only_redundantly java.lang.RuntimeException;
    public void test6() {}

    //@ signals_only_redundantly RuntimeException;
    public void test7() {}

    //@ signals_only_redundantly java.io.IOException;
    public void test8() throws java.io.IOException {}

    //@ signals_only \nothing;
    public void test9() {}

    //@ signals_only_redundantly \nothing;
    public void test10() {}

}
