// @(#)$Id: axiom_test.java,v 1.2 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

/*@spec_bigint_math@*/ class axiom_test {

  //@ axiom (\forall int x; (\exists int y; y >= x));

  //@ axiom (\forall int x, y; x >= 0 & y >= 0; x*y >= 0);

  //@ axiom (\sum int i; 0 <= i && i < 4; i) == 6;
  //@ axiom (\product int i; 0 < i && i < 4; i) == 6;

  //@ axiom (\max int i; 0 <= i && i < 4; i) == 3;
  //@ axiom (\min int i; 0 <= i && i < 4; i) == 0;

  //@ axiom (\num_of int i ; ; 0 <= i && i < 4) == 4;

  //@ requires i >= 0;
  //@ ensures \result >= 0;
  static int s(int i) {
    return i * i;
  }

}
