// @(#)$Id: non_null_test.java,v 1.2 2002/10/28 12:18:38 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public abstract class non_null_test {

    // The following complains - it is ok if you have either non_null or
    // spec_public alone or in reverse order, but not like this.
    
    // The syntax in Appendix B does not list non_null as a modifier, but
    // it seems to be used in that sense.

    // This order is ok in ESC/Java

    private /*@ spec_public non_null @*/ String a; 
    /*@ spec_public non_null @*/ private String b; 
    /*@ non_null spec_public @*/ private String c; 

    //@ non_null spec_public
    private String d;

    public String toString() {
        return a + b + c + d;
    }
}
