// @(#)$Id: quantifier_switching3.java,v 1.5 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;

public /*@ spec_bigint_math @*/ /*@ pure model @*/ class quantifier_switching3 {

    /*@ axiom (\forall int i; (\exists int j; (j > i); (j < 10));
                   (\sum int k;
                      ((0 <= k) && (k < 6));
                      ((k)+ 3))
                   < 6); @*/

    /*@ axiom (\forall int i; (\exists int j; (j > i); (j < 10));
                   (\sum int k;
                         ((0 <= k) && (k < 6));
                         (k + 3))
                   < 6); @*/

    Integer i = new Integer(3);
    //@ model Integer foobar3;

    //@ represents foobar3 <- i;
}
