// @(#)$Id: inherit_spec.java,v 1.1 2002/06/25 03:38:49 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

class super_super_spec {

    //@ requires x > 10;
    //@ ensures x > 11;
    void foo(int x) {
    }
}

class super_spec extends super_super_spec {

    //@ also ensures x > 200;
    void foo(int x) {
    }
}

class inherit_spec extends super_spec {

    /*@ 
      @ also
      @   requires x > 2000;
      @ also
      @   requires x > 3000;
      @   ensures x > 4000;
      @*/
    void foo(int x) {
    }
}
