// @(#)$Id: let_decl.java,v 1.3 2004/07/09 15:56:30 f_rioux Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax.runchecker;

/*@spec_bigint_math@*/ class let_decl {

    int v1 = 10;
    int v2 = 100;
    int sum = 0;

    /*@   old int v1 = 200; 
      @   old int v12 = (int)(v1 + v2 + x);
      @   requires v12 > 0;
      @   ensures sum == v12 * 10 + x; // x should be replaced!
      @ also
      @   old int v3 = 300;
      @   requires v3 + v1 > 0; // v1 should be 10!
      @*/
    void foo(int x) {
	sum = (v1 + v2) * 2 + x;
    }
}
