// @(#)$Id: nested_behavior_spec.java,v 1.2 2003/01/11 04:46:47 davidcok Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

class nested_behavior_spec {

    /*@ behavior 
      @ requires x > 0;
      @ {|
      @   requires x > 20;
      @   {|
      @     modifies \nothing;
      @     ensures x > 25;
      @ also
      @     modifies \nothing;
      @     ensures x > 100;
      @   |}
      @ |}
      @
      @ also
      @   requires x > 30;
      @   ensures x > 40;
      @ also 
      @   requires x > 300;
      @*/
    void foo(int x) {
    }
}
