// @(#)$Id: pattern_based_quanti.java,v 1.1 2002/06/25 03:38:49 leavens Exp $

// Copyright (C) 1998, 1999, 2000, 2001 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax.runchecker;

import java.util.*;

class pattern_based_quanti {
    HashSet c = new HashSet();

    public pattern_based_quanti() 
    { 
	c.add(new Integer(10));
	c.add(new Integer(20));
	c.add(new Integer(30));
    }

    //@ requires c != null;
    //@ requires (\forall Integer i; c.contains(i); i.intValue() >= 10);
    void doIt1() {}

    //@ requires c != null;    
    //@ requires (\exists Integer i; c.contains(i); i.intValue() == 20);
    void doIt2() {}

    public static void main(String args[]) 
    {
	pattern_based_quanti q = new pattern_based_quanti();
	q.doIt1();
	q.doIt2();
    }
}
