// @(#)$Id: return_type.java,v 1.1 2002/06/25 03:38:49 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker;

class return_type {
    class T {
    }

    //@ ensures \result == 0;
    int f_int() { return 0; }
    
    //@ ensures \result == false;
    boolean f_boolean() { return false; }

    //@ ensures \result == (short) 0;
    short f_short() { return 0; }

    //@ ensures \result == 0L;
    long f_long() { return 0; }

    //@ ensures \result == 0.0D;
    double f_double() { return 0.0D; }

    //@ ensures \result == 'c';
    char f_char() { return 'c'; }
    
    //@ ensures \result == (byte) 0;
    byte f_byte() { return 0; }

    //@ ensures \result == 0.0F;
    float f_float() { return 0.0F; }

    //@ ensures \result == null;
    int[] f_int_array() { return null; }

    //@ ensures \result == null;
    T f_T() { return null; }
}
