// @(#)$Id: static_constant.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class OtherClass {
    public static int CONSTANT = 342;
    public static final int ICONSTANT = 181;

    public static class Nested {
        public static String foo = "foo";
        public static final String bar = "bar";

        public static class DoublyNested {
            public static int CONSTANT = 342;
            public static final int ICONSTANT = 181;
        }
    }
}

public class static_constant
{
    protected String foo;

    public int test() {
        return OtherClass.ICONSTANT + OtherClass.CONSTANT;
    }

    public String test_n() {
        return OtherClass.Nested.foo + OtherClass.Nested.bar;
    }

    public int test_n_n() {
        return OtherClass.Nested.DoublyNested.CONSTANT
            + OtherClass.Nested.DoublyNested.ICONSTANT;
    }

    public int test2() {
        return OtherClass2.ICONSTANT + OtherClass2.CONSTANT;
    }

    public String test22() {
        return OtherClass2.Nested2.foo + OtherClass2.Nested2.bar;
    }

    public int test222() {
        return OtherClass2.Nested2.DoublyNested.CONSTANT
            + OtherClass2.Nested2.DoublyNested.ICONSTANT;
    }
}

class OtherClass2 {
    public static int CONSTANT = 342;
    public static final int ICONSTANT = 181;

    public static class Nested2 {
        public static String foo = "foo";
        public static final String bar = "bar";

        public static class DoublyNested {
            public static int CONSTANT = 342;
            public static final int ICONSTANT = 181;
        }
    }
}
