
package org.jmlspecs.checker.testcase.typecheck;

//@ refine "AlsoClass.jml-refined";

public class AlsoClass {
    protected int val_;
    //@             in val;

    //@ represents val <- val_;


    /*@ also
      @   protected normal_behavior
      @     assignable val;
      @     ensures val_ == newVal;
      @*/
    public AlsoClass(int newVal) {
	val_ = newVal;
    }

    /*@ also
      @   protected normal_behavior
      @     ensures \result == val_;
      @*/
    /*@ pure @*/ public int get( ) {
	return val_;
    }
}
