
package org.jmlspecs.checker.testcase.typecheck;

//@ refine "AlsoSubClass.jml-refined";

public class AlsoSubClass extends AlsoClass implements AlsoInterface {

    /*@ also
      @   public normal_behavior
      @     assignable val;
      @     ensures val == newVal;
      @*/
    public AlsoSubClass(int newVal);

    /*@ also
      @   protected normal_behavior
      @     assignable val_;
      @     ensures val_ == newVal;
      @*/
    public void put(int newVal) {
	val_ = newVal;
    }

    /*@ also
      @   protected normal_behavior
      @     assignable val_;
      @     ensures val_ == newVal && \result == \pre(val_);
      @*/
    public int putGet( int newVal ) {
	int oldVal = val_;
	val_ = newVal;
	return oldVal;
    }
}
