package org.jmlspecs.checker.testcase.typecheck;

public class Callable3 {

    //@ protected behavior modifies \nothing;
    /*@ also
      @  protected code behavior    assignable \nothing;
      @     callable org.jmlspecs.checker.testcase.typecheck.Callable3. m(), 
      @          this.m(), 
      @          org.jmlspecs.checker.testcase.typecheck.Callable3. foo(), 
      @          org.jmlspecs.checker.testcase.typecheck.Callable3. foo(int);
      @*/
    public void foo() {}

    /*@ protected code behavior    assignable \nothing;
      @     callable this.m(int), 
      @          org.jmlspecs.checker.testcase.typecheck.Callable3.foo(int);
      @*/
    public void m() {}

}

// @(#)$Id: Callable3.java,v 1.2 2005/09/07 19:42:14 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
