
// File: InconsistentMethods.java

//@ refine "InconsistentMethods.jml";

public class InconsistentMethods {

    public InconsistentMethods(int x) {
    }
    private InconsistentMethods() {
    }

    private int pub() {
	return 0;
    }
    public int pro() {
	return 0;
    }
    protected int pri() {
	return 0;
    }
    protected int def() {
	return 0;
    }

    int pub2() {
	return 0;
    }
    int pro2() {
	return 0;
    }
    int pri2() {
	return 0;
    }
    private int def2() {
	return 0;
    }


    public int mod() {
	return 0;
    }
    //@ public model int non_mod() {return 0;}

    public String obj() {
	return "obj";
    }
    public Object str() {
	return "obj";
    }
    protected int str2() {
	return 0;
    }
    protected int ch() {
	return 0;
    }
    protected char in() {
	return '0';
    }

    private Object fl() {
	return "fl";
    }

    public void stat() {
    }
    public static void non_stat() {
    }

    public void n(int x) throws java.io.IOException {
    }
    public void p(int y) {
    }

    //@ public model int mod2() {return 0;} // ERROR -- body already defined

    protected void b(int y) {
    }

    private void t(int y) {
    }

    public void v(int y) {
    }

    private void d(int y) {
    }

    public int non_mod2() {return 0;}
}

// @(#)$Id: InconsistentMethods.java,v 1.6 2005/07/09 16:00:12 leavens Exp $

// Copyright (C) 2005 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

