// Local variables can be ghost or model? What about other
// JML-specific modifiers such as pure, non-null, spec_public,
// spec_protected, etc? Nothing is checked by JML type checker now.

package org.jmlspecs.checker.testcase.typecheck;

public class LocalVariablesAndModifiers {
    void m1() {
        //@ ghost int x1;               // OK
        //@ model int x2;
        //@ ghost model int x3;
        /*@ ghost @*/ int x4;            // OK
        /*@ model @*/ int x5;
        /*@ ghost model @*/ int x6;

        //@ pure int x7;
        /*@ pure @*/ int x8;

        //@ instance int x9;
        /*@ instance @*/ int x10;

        //@ spec_public int x11;
        /*@ spec_public @*/ int x12;

        //@ spec_protected int x13;
        /*@ spec_protected @*/ int x14;

        //@ monitored int x15;
        /*@ monitored @*/ int x16;

        //@ uninitialized int x17;
        /*@ uninitialized @*/ int x18;

        //@ non_null int x19;            // OK
        /*@ non_null @*/ int x20;        // OK

        //@ helper int x21;
        /*@ helper @*/ int x22;
    }
}

// @(#)$Id: LocalVariablesAndModifiers.java,v 1.2 2003/05/25 03:48:28 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
