// From David R. Cok

package org.jmlspecs.checker.testcase.typecheck;

public /*@spec_bigint_math@*/ class LoopStatement1 {
    public static void test() {
        //@ loop_invariant i < 10;
        //@ decreasing \bigint_math(10 - i);
        for (int i=0; i < 10; i++) {
            ;
        }
    }

    public static void test2() {
        //@ loop_invariant i < 10;
        //@ decreasing i;
        for (int i = 9; i != 0; i--) {
            ;
        }
    }

    boolean k;
    public static void test3() {
        //@ loop_invariant k < 10;
        //@ decreasing \bigint_math(10 - k);
        for (int k = 0; k != 10; k++) {
            ;
        }
    }

    public static void test4() {
        for (int k = 0; k < 10; k++) {
            ;
        }
    }
}

// @(#)$Id: LoopStatement1.java,v 1.2 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
