public class MethodPureness3 implements MethodPureness3IF {

    //@ requires val1() > x; // OK
    public void m1(int x) {}

    //@ requires val2() > x; // ERROR
    public void m2(int x) {}

    public int val1() { return 0; }

    public int val2() { return 0; }
}

interface MethodPureness3IF {
    /*@ pure @*/ int val1();
    int val2();
}

// @(#)$Id: MethodPureness3.java,v 1.1 2002/10/29 03:40:04 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
