// THIS TEST FILE IS BEING SKIPPED pending resolution of bug #1376678.
/**
 * There is no specification _refinement_ going on in this case.  *The* spec
 * for this class is given in the .refined-java file.  Hence, in particular,
 * members or parameters declared nullable in the .refined-java file will be
 * taken as nullable (rather than being interpreted as conflicting with an
 * apparently implicit declaration of non_null in this file).
 */

public class NullableRefinement3 {
    public static Object nonNull0 = NullableRefinement3.class;
    private Object nonNull1 = this;
    public  Object nonNull2 = this;

    public static Object nullable0 = null;
    private Object nullable1 = null;
    public  Object nullable2 = null;

    public Object methodReturnNonNull() { return ""; }
    public Object methodReturnNullable() { return null; }

    public void methodParamNullable(Object nullableParam) {
	nullable1 = nullableParam;
    }
    public void methodParamNonNull(Object nonNullParam) {
	nonNull1 = nonNullParam; 
    }
    public void methodParamNonNull2(Object nonNullParam) {
	nonNull1 = nonNullParam; 
    }
    public void methodParamNonNull3(Object nonNullParam) {
	nonNull1 = nonNullParam; 
    }
}

// @(#)$Id: NullableRefinement3.java,v 1.2 2005/12/24 21:19:51 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
