public class Signals1 {

    // OK: a subtype of java.lang.RuntimeException (i.e., unchecked)
    //@ signals (java.lang.ClassCastException e) true; 
    public void m1() {
    }

    // OK: a supertype of java.lang.RuntimeException
    //@ signals (java.lang.Throwable e) x > 0;
    public void m1_1(int x) {
    }

    // OK: a supertype of java.lang.RuntimeException
    //@ signals (java.lang.Exception e) x > 0;
    public void m1_2(int x) {
    }

    // OK: checked exception
    //@ signals (MidException e) true;
    public void m2() throws MidException {
    }

    // OK: subtype of checked exception
    //@ signals (BottomException e) true;
    public void m3() throws MidException {
    }

    // OK: supertype of checked exception
    //@ signals (TopException e) true;
    public void m4() throws MidException {
    }

    // OK: supertype of RuntimeException
    //@ signals (Exception e) true;
    public void m5() {
    }

    // OK: supertype of RuntimeException
    //@ signals (Throwable e) false;
    public void m6() {
    }

    // ERROR
    //@ signals (UnrelatedException e) true;
    public void m7() throws MidException {
    }

    // ERROR: must be a subtype of java.lang.Throwable
    //@ signals (Object e) true; 
    public void m8() throws Object {
    }

    public class TopException extends java.lang.Exception {}
    public class MidException extends TopException {}
    public class BottomException extends MidException {}
    public class UnrelatedException extends java.lang.Exception {}
}
