// @(#)$Id: TestGhostAssign2.java,v 1.2 2005/08/05 06:52:46 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// from Steve Shaner

package org.jmlspecs.checker.testcase.typecheck;

import java.util.*;

public abstract class TestGhostAssign2 {

    private /*@ spec_public @*/ int lastValue;
    //@   ghost char x = '3';

    /*@ public model_program
      @ {
      @   ghost int x = 3;
      @   choose { set x = 0; }
      @     or { x = 1; }  // error: must use set for ghost variables
      @     or { set x = 2; }
      @   return x;
      @ }
      @*/
    public int shortRandomJump() {
	//@     set x = '1';  // OK since it uses the set statement
	//@     x = '2';  // error: must use set for ghost variables
	Random r = new Random();
	return r.nextInt(3);
    }
}
