/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of JML
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestsWithWarningsTestSuite.java,v 1.4 2004/01/18 20:28:08 leavens Exp $
 * Author: David R. Cok
 */
package org.jmlspecs.checker.testcase.typecheck;

import org.multijava.util.testing.TestCase;
import org.multijava.util.testing.*;
import junit.framework.*;

/** This is a JUnit test case that executes the tests in the package in 
    which it resides.  This test is actually a suite of tests produced from
    a sequence of filenames (contained in 'warning-tests').
<P>
    The test must be run from the directory in which it resides - because
    it opens files in the current directory.

    @author David R. Cok
*/
public class TestsWithWarningsTestSuite  extends org.multijava.util.testing.TestSuite {

    static public Test suite() {
	return new TestFilesTestSuite("TestsWithWarningsTestSuite","warning-tests",
                        new String[]{"-Q","-w3",},
                        org.jmlspecs.checker.Main.class) {

		public boolean expectedStatus(String filename, String output) {
			return true;
		}
	};
    }
}


