import org.jmlspecs.models.*;

class context_ensures {

    interface MySet {
	/*@ pure @*/ boolean has(Object o);
    }
    MySet s;

    int x;
    Object o;

    //@ ensures new JMLObjectSet {Object i | s.has(i) 
    //@   && \fresh(o)} != null;
    void m() {}

    //@ ensures new JMLObjectSet {Object i | s.has(i) 
    //@   && \not_modified(o)} != null;
    void m1() {}

    //@ ensures new JMLObjectSet {Object i | s.has(i) 
    //@   && \pre(x) > 0 && \old(x) > 0} != null;
    void m2() {}

    //@ ensures new JMLObjectSet {Object i | s.has(i) 
    //@   && \result > 0} != null;
    int m3() { return 0; }

    //@ requires new JMLObjectSet {Object i | s.has(i) 
    //@   && \fresh(o)} != null;
    void m4() {}

    //@ requires new JMLObjectSet {Object i | s.has(i) 
    //@   && \not_modified(o)} != null;
    void m5() {}

    //@ requires new JMLObjectSet {Object i | s.has(i) 
    //@   && \pre(x) > 0 && \old(x) > 0} != null;
    void m6() {}

    //@ requires new JMLObjectSet {Object i | s.has(i) 
    //@   && \result > 0} != null;
    int m7() { return 0; }

    //@ ensures new JMLObjectSet {Object i | s.has(i) 
    //@   && \not_assigned(o) && \only_assigned(o)} != null;
    void m8() {}

    //@ requires new JMLObjectSet {Object i | s.has(i) 
    //@   && \not_assigned(o) && \only_assigned(o)} != null;
    void m9() {}
}
