/*@ spec_bigint_math @*/ class duration_clause {
    int x, y;

    //@ duration \not_specified;
    void m() {}

    //@ duration_redundantly 0;
    void m1() {}
    
    //@ duration x + y;
    void m2() {}

    //@ duration_redundantly 1L if true;
    void m3() {}

    //@ duration (byte) 0;
    void m4() {}

    //@ duration '0';
    void m5() {}

    // ERROR
    //@ duration 0.0f;
    void m6() {}

    // ERROR
    //@ duration 0.0;
    void m7() {}

    // ERROR
    //@ duration null;
    void m8() {}

    // ERROR
    //@ duration new Integer(0);
    void m9() {}

    // ERROR
    //@ duration new Object();
    void m10() {}

    int a[];

    // ERROR
    //@ duration a;
    void m11() {}

    // ERROR
    //@ duration 0 if 0;
    void m12() {}

    //@ duration 4*Math.max(\old(x),0) + i;
    void m13(int i) {}

    //@ duration \fresh(\result) ? x : x;
    Object m14() { return new Object(); }

    //@ duration \not_modified(y) ? x : x;
    void m15() {}

    //@ duration x if \old(x) != 0;
    void m16() {}

    //@ duration x if \result != null;
    Object m17() { return null; }

}
