// @(#)$Id: model_field_ref7.java,v 1.1 2003/08/13 00:57:07 cruby Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

public class model_field_ref7 extends Super1 implements Interface1 
{
    
    //@ private represents val <- v_; // ERROR: val is ambiguous 
    int v_ = val_;        // ERROR: val_ is not visible

    //@ also
    //@ requires val > 0; // ERROR: ambiguous from Super1 and Interface1
    //@ requires super.val > 0;   // OK
    //@ ensures \result == Interface1.val; // ERROR: not a static field
    public int m1() {
	return v_;      // OK
    }

}

abstract class Super1 {
    //@ model public int val;

    private int val_;
}
interface Interface1 {

    //@ model instance public int val;

    int m1();
}
