package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

class ArrayExpression {
   int x;
   /*@ non_null */ String[] non=new /*@ non_null*/ String[]{"hello"};
   /*@ nullable */ String[] able;

   int m1() { return this.non[x].length(); }
   int m2() { return this.non.length; }
   int m3() { return this.able.length; }   //error
   /*@ nullable */ String m3(int x) { return this.able[x]; } //error

   /*@ nullable */ String[] f() { 
     if (x==0) 
        return null;
     else
        return new /*@ nullable */ String[] {"hello"};
   }
   /*@ nullable */ String m4(int x) { 
     String[] names = f();
     if (names==null)
        return "null";
     else
        return names[x];
   }
   int m5(int x) {
     if (this.non!=null)
        return this.non.length;
     else
        return 0;
   }
   int m6(int x) {
     if (this.able!=null)
        return this.able.length; //error
     else
        return 0;
   }
}
