package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

class DoubleAssignment {
   /*@ non_null */ String non_1="name";
   /*@ non_null */ String non_2="path";
   /*@ nullable */ String able_1;
   /*@ nullable */ String able_2;

   void m1(/*@ nullable */ String s) { this.non_2  = this.non_1  = s; } // error
   void m2(/*@ nullable */ String s) { this.able_2 = this.non_1  = s; } // error
   void m3(/*@ nullable */ String s) { this.non_2  = this.able_1 = s; } // error
   void m4(/*@ nullable */ String s) { this.able_2 = this.able_1 = s; }
   void m5(/*@ non_null */ String s) { this.non_2  = this.non_1  = s; }
   void m6(/*@ non_null */ String s) { this.able_2 = this.non_1  = s; } 
   void m7(/*@ non_null */ String s) { this.non_2  = this.able_1 = s; } // error
   void m8(/*@ non_null */ String s) { this.able_2 = this.able_1 = s; } 
}


