//@ model import org.jmlspecs.models.JMLObjectSet;
class reach_exp {
    //@ public model JMLObjectSet reachOfThis;
    //@ public represents reachOfThis <- \reach(this);

    class T {
	int f;
	//@ in objectState;  // inherited from Object

	T nextT;
	//@   in objectState;
	//@   maps nextT.objectState \into objectState;

	// the above maps clause recursively includes all fields reachable 
	// from type T.
    }

    int x;
    //@ in reachOfThis;

    T y;
    //@ in reachOfThis;
    //@ maps y.objectState \into reachOfThis;
    //@ maps_redundantly y.f \into reachOfThis;
    //@ maps_redundantly y.nextT \into reachOfThis;

    // the first 4 assignable clauses include all fields reachable from this!

    //@ assignable reachOfThis;
    void m1() {}

    //@ assignable this.x, this.y, this.y.objectState;
    void m2() {}

    //@ assignable x, y, y.objectState;
    void m3() {}

    //@ assignable x, y.*;
    void m4() {}

    // this assignable clause does not include all fields reachable from this!
    // it doesn't include any fields reachable from y. 
    //@ assignable this.*;
    void m5() {}

    // this assignable clause does not include all fields reachable from this!
    // it doesn't include all fields reachable from y. 
    //@ assignable x, y.f, y.nextT;
    void m6() {}
}

// @(#)$Id: reach_exp.java,v 1.3 2003/10/23 01:13:29 cruby Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

