// @(#)$Id: signals_only_clause.java,v 1.2 2005/07/11 17:57:45 leavens Exp $

// Copyright (C) 2005 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.typecheck;

class signals_only_clause {
    class E extends Throwable {}
    class ES extends E {}
    class RTE extends RuntimeException {}

    //@ signals_only RuntimeException;
    void m() {}

    //@ signals_only E;
    void m1() throws E {}

    //@ signals_only ES, RTE;
    void m2() throws E {}

    //@ signals_only RTE;
    void m3() {}

    // ERROR: not listed type
    //@ signals_only E;
    void m7() {}

    // ERROR: not Throwable and not listed type
    //@ signals_only signals_only_clause;
    void m8() {}

    // ERROR: undefined type
    //@ signals_only T;
    void m10() {}
}
