public class spec_protected_field_ref1 {
    /*@ spec_public @*/ private int val;
    /*@ spec_public @*/ private spec_protected_field_ref1_helper helper;
    
    //@ requires helper != null && helper.val > 0; // OK: spec_public
    protected void m1() { 
	val = helper.val; // ERROR: private
    }
    
    // OK: spec_public
    //@ requires helper != null && spec_protected_field_ref1_helper.sval > 0; 
    protected void m2() { 
	val = helper.sval; // ERROR: private
    }

    // OK: spec_public
    //@ requires spec_protected_field_ref1_helper.sval > 0; 
    protected static void m3() { 
	int x = spec_protected_field_ref1_helper.sval; // ERROR: private
    }
}

class spec_protected_field_ref1_helper {
    private /*@ spec_protected @*/ int val;
    private /*@ spec_protected @*/ static int sval;
}
