public class spec_public_class_ref3 {

    // OK: spec_public
    //@ requires obj instanceof spec_public_class_ref3_helper.T1;
    public boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref3_helper.T1;
    }
    
    // OK: spec_public
    //@ requires obj instanceof spec_public_class_ref3_helper.T2;
    public boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref3_helper.T2;
    }

    // OK: spec_public
    //@ requires obj instanceof spec_public_class_ref3_helper.T2;
    public static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref3_helper.T2;
    }
}

class spec_public_class_ref3_helper {
    private /*@ spec_public @*/ interface T1 {}
    private /*@ spec_public @*/ interface T2 {}
}
