public class spec_public_class_ref4 extends spec_public_class_ref4_super {
    
    // OK: spec_public
    //@ requires obj instanceof T1;
    public boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof T1;
    }
    
    // OK: spec_public
    //@ requires obj instanceof T2;
    public boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }

    // OK: spec_public
    //@ requires obj instanceof T2;
    public static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof T2;
    }
}

class spec_public_class_ref4_super {
    private /*@ spec_public @*/ interface T1 {}
    private /*@ spec_public @*/ interface T2 {}
}
