public class spec_public_class_ref5 {
    
    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref5_helper.T1;
    protected boolean m1(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref5_helper.T1;
    }
    
    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref5_helper.T2;
    protected boolean m2(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref5_helper.T2;
    }

    // OK: spec_protected
    //@ requires obj instanceof spec_public_class_ref5_helper.T2;
    protected static boolean m3(Object obj) { 
        // ERROR: private
        return obj instanceof spec_public_class_ref5_helper.T2;
    }
}

/*@ spec_public @*/ class spec_public_class_ref5_helper {
    private /*@ spec_protected @*/ static class T1 {}
    private /*@ spec_protected @*/ static class T2 {}
}

// @(#)$Id: spec_public_class_ref5.java,v 1.2 2002/09/12 15:35:44 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
