package org.jmlspecs.jmldoc;
import java.lang.reflect.Method;

/** This class just has a main routine that invokes the main routine in the
    subpackage appropriate to the version of the Java tools library that is
    on the classpath.
*/

public class JmldocGUI {

    static public void main(String[] args) {
    init(args, true);
    }

    static public void init(String[] args, boolean standAlone) {
    int version = org.multijava.mjdoc.ToolsVersion.version();
    String s = "org.jmlspecs.jmldoc.jmldoc_" + version + ".JmldocGUI";
    try {
        Class c = Class.forName(s);
        Method m = c.getDeclaredMethod("init",
            new Class[]{String[].class,boolean.class});
        m.invoke(null,new Object[]{args,new Boolean(standAlone) });
    } catch (Exception e) {
        System.out.println("FAILED TO START VERSION " + version
        + ": " + e);
    }
    }
}
