// Tests that \max can be used as a quantifier and a function; also that
// we can use < and <= to test lock order.  Note that the implementation
// is convoulted with code that keeps track of whether words like 'requires'
// are keywords or ordinary identifiers - hence some of the other test cases.
//#JMLFLAGS: -classpath . -nonavbar -Q -xnodate
public class TestMax {

	public int ensures;

	//@ requires (\max int i; 0<i && i<5; i) == 4;
	//@ requires (\max(\lockset) < this);
	//@ requires \max(\lockset) != null;
	//@ requires (\max Object o; (\max(\lockset) < o); ensures) == 0;
	//@ requires (\max Object o; \max(\lockset) < o; ensures) == 0;
	//@ requires \max(\lockset) < this;
	public void p() {}


/**
<pre><esc>
	requires (\max int i; 0<i && i<5; i) == 4;
	requires (\max(\lockset) < this);
	requires \max(\lockset) != null;
	requires (\max Object o; (\max(\lockset) < o); ensures) == 0;
	requires (\max Object o; \max(\lockset) < o; ensures) == 0;
	requires (\max Object o; (\max(\lockset) < o); 
		ensures + (\max Object oo; ; ensures) ) == 0;
	requires \max(\lockset) < this;
</esc></pre>
*/
	public void q() {}
}
