//#JMLFLAGS: -xnodate -private -Q -nonavbar -f org.jmlspecs.checker.JMLWarningFilter -a  -classpath .
// This tests the various specs and clauses that can be applied to a method.
// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class TestMethodClauses {

	// light-weight spec

	int i11;
	static public TestMethodClauses t;
        /*@ spec_public @*/ int pp;
	/*@ spec_public @*/ int[] a;
	
	/*@ // To really check the following one should have all combinations
	    // of clauses omitted and present, but that really tests the grammar
	    // and we are concentrating on testing the html rendition, so we'll
	    // just make sure that 0, 1 or 2 of each kind of clause works, but 
	    // not worry about all the combinations.

		public model int i;
		public ghost int ii;
		forall int fi;
		forall int fia[];
		forall boolean[] bb;
		old int i1 = 1, i12 = 5;
		old int[] i2 = { 1,2,3 };
		old int[][] i3 = { {2,3,4} , {5} };
		old \TYPE t = \type(Object);
		old Object o = null;
		requires true;
		requires_redundantly \not_specified;
		when true;
		when_redundantly \not_specified;
		working_space i;
		working_space_redundantly \not_specified;
		working_space i if true;
		duration i;
		duration_redundantly \not_specified;
		duration i if true;
		modifies i;
		assignable i;
		modifies_redundantly i,ii;
		assignable_redundantly ii;
		ensures i == 0;
		ensures_redundantly \not_specified;
		signals ( Exception); // default is true
		signals (Exception) \not_specified;
		signals_redundantly (Exception e) e != null;
		diverges false;
		diverges \not_specified;
		diverges_redundantly i<0;
	@*/
		public void m() throws Exception {}

		//@ requires true;
		public void n() {}

		/*@
		when true;
		working_space i;
		duration i;
		modifies i;
		ensures true;
		signals (Exception) false;
		diverges false;
		@*/
		public void p() throws Exception {}
		
		// Heavy-weight specs
	/*@
		// method_specification =
		// specification = spec-case-seq redundant-spec
		// spec-case-seq =
			// generic-spec-case = spec-var-decls spec-header generic-spec-body
				requires true;
				ensures true;
			also
			// behavior-spec = privacy behavior generic-spec-case
				public behavior
					requires i == 1;
					ensures  i == 2;
			also
			// behavior-spec = privacy exceptional_behaviorexceptional-spec-case
				protected exceptional_behavior
					signals (Exception) i == 3;
			also
			// behavior-spec = privacy normal_behavior normal-spec-case
				private normal_behavior
					ensures i == 4;
			also
			// behavior-spec = privacy normal_behavior normal-spec-case
				normal_behavior
					requires i == 4;
					{|
						requires ii == 1;
						ensures true;
					also
						requires ii == 2;
						ensures ii == 3;
					also
						{| 
							requires i == ii;
							ensures i == 0;
						|}
					|}
			also
			// model-program - tested in another test
			

		

		protected code behavior
			assignable \nothing;

			accessible t, t.pp, a[0], super, this.i;
			accessible_redundantly t.pp, a, a[0], a[*], a[0..2];
			accessible \nothing;
			accessible \everything;
			accessible \not_specified;
			
			callable q(int);
			callable \nothing;
			callable \everything;
			callable \not_specified;
			callable_redundantly q(int), new TestMethodClauses;

		measured_by i;
		measured_by_redundantly \not_specified;
		measured_by i if true;
		measured_by i;
			
		// redundant-spec = implications examples
		// implications
		
		implies_that
			requires true;
			ensures true;
		also
			requires i == ii;
			ensures ii == 0;
		also public exceptional_behavior
			requires i < 0;
			signals (Exception);
			
		// examples
		
		for_example
			example
			requires i == 1;
			ensures ii == 2;
			signals (Exception) false;
		also
			public normal_example
			requires i == 3;
			ensures ii == 4;
		also
			protected exceptional_example
			requires i == 5;
			signals (Exception);
			
		
	@*/
		public void q(int i) throws Exception {}
}
		
