// This test checks for parsing of asterisks in a javadoc comment, and also
// checks the parsing of embedded jml annotations.

public class Testjdoc {
	/*************************/
	public int i;

	/** Simple text */

	/** Multi-
		line
		text
	*/

	/** Javadoc
	 ***** is
	 * * * great; there should be two * before great.
	 */

	 public void m() {}


	/** Annotations.
	 * 
<pre>
i=1;

j=2;
</pre>
	 ********* <pre><jml>
	 ********  requires true;
	 ********  
	 ********  requires true;
	 ********* </jml></pre>

	asd <esc>
	ensures i == 0;
	</esc>

	<pre><esc>
	ensures i == 1;
	</esc></pre>

	<PRE><ESC>
	ensures i == 2;
	</ESC></PRE>

	<PRE><JML>
	ensures i == 3;
	</JML></PRE>

	<jml>diverges false;</jml>

	###<jml>diverges false;</jml>%%%
	 *********/

	public void n() {}


	/*** Comment
	     Comment2 ***
	**** Comment3 * 3 ** 4 *** 5 ****/
	public void p() {}

	/*@@@ requires true;
	@@@@ ensures false;  @@@@*/
	/*+@@@ ensures true;
	@@@@ modifies \nothing; @@@@+*/
	//@@@@ pure
	public void q() {}

/** Comment. ***
*/
	public void r() {}

/* *<pre><jml>requires true;</jml></pre> Annotation.*/
	public void rr() {}

/** Comment.

    Comment2.
*/
	public void s() {}

/*
	comment *********
*/
/*******************************************
  comment
********************************************/
	public void t() {}
}
	
