// This test checks that leading asterisks in an annotation embedded in a 
// javadoc comment are parsed correctly.

class Teststar {
	/************/
	int x = 2;

	/** Javadoc.
	 *	<pre><esc>
	 *	requires true;
	 **** requires true;
		ensures false;
		ensures 2 
	 *          * x == 4;
	 *	</esc></pre>
	 */

	 void m() {}

	 /*** Javadoc.  ****/
	 void n() {}

	 /*** Javadoc.  
	  ****/
	 void nn() {}

	 /*** Javadoc.  */
	 void nnn() {}


	 /**** Javadoc with trailing stars ****
*/
	 void p() {}

	 /**** Javadoc with 4 stars  ****
	  **** and 4 more stars      ****
****/
	void r() {}
}
	
