package org.jmlspecs.jmlexec.jack.compiler;

import antlr.CommonAST;
import antlr.Token;
import antlr.collections.AST;
import java.io.*;

public class JCHRAST extends CommonAST {

    int line;

    public JCHRAST() {

    }

    public JCHRAST(Token tok) {

	setText(tok.getText());
	setType(tok.getType());       
	line = tok.getLine();

    }

    public int getLine() {

	return line;

    }
    
    public String toString() {

	return ""+this+"("+line+")";

    }

    public void initialize(Token tok) {

	setText(tok.getText());
	setType(tok.getType());       
	line = tok.getLine();

    }

}
