package org.jmlspecs.jmlexec.jack.evaluator;

/**
 * SExploration.java <br>
 * $Id: SExploration.java,v 1.1 2008/03/05 00:08:35 wahlst Exp $
 *
 * @author Ekkehard Kramer (last modified by $Author: wahlst $)
 * @version $Date: 2008/03/05 00:08:35 $, $Revision: 1.1 $
 */

// An example for a class implementing SExploration would be Depth-First

public interface SExploration
{
    
    // Returns null when finished
    SNode performOneStep();

    // Resets the constraint system to the state just after the
    // exploration was created, with a new constraint system (the
    // previous underlying constraint system is NOT modified)
    void reset(ConstraintSystem system);
}
