package org.jmlspecs.jmlexec.jack.evaluator;

public class SimpagationRule extends Rule {

  /**
     fields
  */

  protected ObjectContainer minusHead;
  protected ObjectContainer normalHead;

  /**
     constructors
  */

  public SimpagationRule(String id, SimpagationHead head, ObjectContainer guard, ObjectContainer body) {

    super(id, head.getHead(), guard, body);
    this.minusHead = head.getMinusHead();
    this.normalHead = head.getNormalHead();

  }

  public SimpagationRule(String id, SimpagationHead head, ObjectContainer body) {

    super(id, head.getHead(), body);
    this.minusHead = head.getMinusHead();
    this.normalHead = head.getNormalHead();

  }

  public String toString() {

    if (guard == null)
      return (identifier+" @ "+normalHead+" \\ "+minusHead+"  <=>  "+body);
    else
      return (identifier+" @ "+normalHead+" \\ "+minusHead+"  <=>  "+guard+" | "+body);

  }

}
