package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: SetIBase.java,v 1.1 2008/04/18 15:44:26 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

public interface SetIBase {
  //@public model instance int i;
  //@public invariant i != - 27;
  public int qrl = 7;
  /*@ requires x <= 0;
      assignable i;
      ensures i == x + qrl; */
  public void setI(int x);

  /*@ ensures \result == i; */
  public /*@ pure */ int getI();
}
