/*
This program will run a sequence of classes as if they were invoked from 'java'.
Each is run in sequence in the same VM with no command-line arguments.
Note that if a class being run is not public (i.e. has access only within its
package), then this class must be a member of that package as well.
*/

import java.lang.reflect.Method;

public class JavaMany {

    public static void main(String[] args) {

	Class[] argtypes = new Class[]{args.getClass()};
	Object[] argss = new Object[]{ new String[]{} };
	
	for (int i=0; i<args.length; ++i) {
	    String classname = args[i];
	    try {
		Class cls = Class.forName(classname);
		Method method = cls.getMethod("main",argtypes);
		method.invoke(null,argss);
		//System.out.println("Executed " + classname);
	    } catch (Exception e) {
		System.out.println("Failed to execute " + classname + ": " + e);
	    }
	}
    }
}
	    
