// @(#)$Id: GhostTYPELocal.java,v 1.1 2005/12/20 05:00:47 leavens Exp $

// Copyright (C) 2005 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.



import org.jmlspecs.jmlrac.runtime.*;

public class TestTemplate {

    //@ requires x > 0;
    void m1(int x) {}

    public static void main(String args[]) {
	TestTemplate test = new TestTemplate();
	int fcnt = 0;

        // no assertion violation
	try { 
            //@ ghost \TYPE t = \type(Object);  // dies in compiler...
            //@ assert t.equals(Object.class);
        } catch (JMLAssertionError e) { fcnt++; }
        
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(GhostTYPELocale.java)");
        }
    }
}

// @(#)$Id: GhostTYPELocal.java,v 1.1 2005/12/20 05:00:47 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
