// @(#)$Id: PrivateSpecificationSub.java,v 1.3 2005/07/06 22:21:00 leavens Exp $

// Copyright (C) 2005 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

import org.jmlspecs.jmlrac.runtime.*;

public class PrivateSpecificationSub extends PrivateSpecificationSuper {

    public int m() {
        return 6;     // satisfies the public specification, so should be ok
    }

    public static void main(String [] argv) {
        int fcnt = 0;

        try {
            new PrivateSpecificationSub().m();
        } catch (JMLAssertionError e) {
            // The call to m() above shouldn't give an assertion violation
            // as the private specification shouldn't be inherited
            fcnt++;
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: PrivateSpecificationSub.java");
            System.exit(-1);
	}
    }
}

