// KNOWN BUG: 
// Mutually recursive classes such as Account and BankCard here
// must be compiled together, e.g., jmlrac Account.java BankCard.java
// The problem is related with temporary copies of source files for
// the second pass of the compilation process.

public class Account {
    private BankCard bankc;

    public void doit() {
	// this expression doesn't compile with jmlrac
	if (bankc.getAccount() == this) {
	    // do it all
	}
    }

    public BankCard getBankCard() {
	return bankc;
    }
}

