// Thanks to Jake.
//
public class NativeMethod {

  static boolean _nolibrary = false;

  public NativeMethod()
    throws Exception {
    if (_nolibrary) {
      throw new Exception("add the directory of libgetpid.so to LD_LIBRARY_PATH");
    }
  }

  public native int getpid();

  static {
    try {
      System.loadLibrary("getpid");
    } catch (UnsatisfiedLinkError e) {
      _nolibrary = true;
      e.printStackTrace();
    }
  }
}
