package org.jmlspecs.jmlrac.testcase.bugs;

public abstract class PrintingDoubles {
    //@ requires f != Double.POSITIVE_INFINITY || f != Double.NEGATIVE_INFINITY;
    //@ ensures \result != Double.NaN;
    //@ ensures \result <= Double.MAX_VALUE;
    //@ ensures \result >= Double.MIN_VALUE;
    public double careful(double f) {
        return 3.0D;
    }
}

// @(#)$Id: PrintingDoubles.java,v 1.1 2003/01/22 04:20:55 cheon Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

