// The purpose of this test is to ensure that the spec of m() gets properly
// desugared to include a signals clause like this
//
//  signals (Throwable e) e instanceof E1 || ... || e instanceof En;
//
// It used to be desugared to 
//
//  signals (Exception e) e instanceof E1 || ... || e instanceof En;
//
// which will cause the generated code to fail to compile if any of the Ei is
// an Error rather than an Exception.  See bug #1274892.

public class SignalsDesugaring
{
    //@ ensures true;
    void m() 
	throws ClassFormatError, NullPointerException
    {}
}
