// old expressions

import org.jmlspecs.jmlrac.runtime.*;

public class ErrorMessage11 {
    int x = 0;

    //@ ensures \old(x) > 0;
    void m1() {}

    //@ ensures x > 0 && \old(val(true)) > 0;
    void m2() {}

    //@ ensures \old(val(false)) > 0;
    void m3() {}

    /*@ pure @*/ int val(boolean b) {
        if (b) {
            throw new JMLNonExecutableException();
        } else {
            throw new RuntimeException();
        }
    }

    public static void main(String args[]) {
	ErrorMessage11 test = new ErrorMessage11();
        int fcnt = 0;

        // postcondition violation
	try { test.m1(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'\\old(x)'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        // postcondition violation
	try { test.m2(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'\\old(val(true))'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        // postcondition violation
	try { test.m3(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'\\old(val(false))'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        if (fcnt > 0) {
            System.out.print(fcnt + "F(ErrorMessage11.java)");
        } else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: ErrorMessage11.java,v 1.2 2003/05/01 17:00:40 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
