// old variables

import org.jmlspecs.jmlrac.runtime.*;

public class ErrorMessage12 {
    int x = 0;

    //@ old int v = (int)(x + 10);
    //@ requires v < 0;
    void m1() {}

    //@ old int v = (int)(x + 10);
    //@ ensures v < 0;
    void m2() {}

    //@ old int v = val();
    //@ ensures v > 0;
    void m3() {}

    /*@ pure @*/ int val() { throw new RuntimeException(); }

    public static void main(String args[]) {
	ErrorMessage12 test = new ErrorMessage12();
        int fcnt = 0;

        // precondition violation
	try { test.m1(); fcnt++; }
        catch (JMLPreconditionError e) {
            if (e.getMessage().indexOf("'v'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        // postcondition violation
	try { test.m2(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'v'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        // postcondition violation
	try { test.m3(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'v'") == -1) {
                fcnt++;
            }
        }
        catch (Throwable e) { fcnt++; }

        if (fcnt > 0) {
            System.out.print(fcnt + "F(ErrorMessage12.java)");
        } else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: ErrorMessage12.java,v 1.2 2003/06/29 01:02:48 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
