import org.jmlspecs.jmlrac.runtime.*;

public class Desugaring2 {

    // Light-weight specification
    //@ ensures true;
    public void m1() { throw new RuntimeException(); }

    // Light-weight specification
    //@ signals (Exception e) true;
    public void m2() {}

    // Light-weight specification
    //@ ensures true;
    //@ signals (Exception e) true;
    public void m3() {}

    // Light-weight specification
    //@ ensures true;
    //@ signals (Exception e) true;
    public void m4() { throw new RuntimeException(); }

    public static void main(String args[]) {
	Desugaring2 obj = new Desugaring2();
	int fcnt = 0;

        // assertion violation expected
	try { obj.m1(); fcnt++; }
        catch (JMLExceptionalPostconditionError e2) { }
	catch (JMLAssertionError e3) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // no assertion violation expected
	try { obj.m2(); }
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }


        // no assertion violation expected
	try { obj.m3(); }
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // no assertion violation expected
	try { obj.m4(); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (Exception e2) {}
        catch (Throwable e3) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Desugaring2.java)");
        }
    }
}
