// Tests mjc's constant unfolding; mjc unfolds "TAB_SIZE >= 0" into
// "false" at compile time, thus the following code causing an
// invariant violation if compiled with jmlc.

public class Invariant1 {
    private static final int TAB_SIZE = 2;
    //@ invariant TAB_SIZE >= 0;

    public static void main(String[] args) {
	int fcnt = 0;

	try { new Invariant1(); }
	catch (Throwable e3) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Invariant1.java)");
        }        
    }
}
