public class IsInitialized1 {

    //@ requires \is_initialized(IsInitialized1);
    public void m1() {
    }

    //@ requires \is_initialized(IsInitialized1IF);
    public void m2() {
    }

    //@ requires \is_initialized(IsInitialized1IF);
    public void m3() {
    }

    private static class Inner {
    }

    //@ requires \is_initialized(Inner);
    private void m4() {
    }

    public static void main(String args[]) {
	IsInitialized1 obj = new IsInitialized1();
	int fcnt = 0;

	try { obj.m1(); } catch (Throwable e) { fcnt++; }
	try { obj.m2(); } catch (Throwable e) { fcnt++; }
	try { obj.m3(); } catch (Throwable e) { fcnt++; }
	try { obj.m4(); } catch (Throwable e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(IsInitialized1.java)");
        }
    }
}

interface IsInitialized1IF {
}

class IsInitialized1Helper {
}

// @(#)$Id: IsInitialized1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
