import org.jmlspecs.jmlrac.runtime.*;

public class IsRacCompiled1 {

    private static class IsRacCompiled1Inner {
    }

    private static interface IsRacCompiled1InnerIF {
    }

    public static void main(String args[]) {
	int fcnt = 0;

        if (!JMLChecker.isRACCompiled(IsRacCompiled1.class)) {
            fcnt++;
        }

        if (!JMLChecker.isRACCompiled(IsRacCompiled1IF.class)) {
            fcnt++;
        }

        // currently inner classes are not rac-compiled
        if (JMLChecker.isRACCompiled(IsRacCompiled1Inner.class)) {
            fcnt++;
        }

        // currently inner classes are not rac-compiled
        if (JMLChecker.isRACCompiled(IsRacCompiled1InnerIF.class)) {
            fcnt++;
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(IsRacCompiled1.java)");
	}
    }
}

interface IsRacCompiled1IF {
}

// @(#)$Id: IsRacCompiled1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
