import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class MInheritance3 extends MInheritance3Super {
    public void m(int x) {}

    public static void main(String args[]) {
	MInheritance3 exp = new MInheritance3();
	int fcnt = 0;

        try {
            exp.m(20); exp.m(-20);
        }
        catch (Throwable e) { fcnt++; }

        try { exp.m(5); fcnt++; }
        catch (JMLAssertionError e) {}
        catch (Throwable e) { fcnt++; }

        try { exp.m(30); }
        catch (Throwable e) { fcnt++; }

        try { exp.m(8); fcnt++; }
        catch (JMLAssertionError e) {}
        catch (Throwable e) { fcnt++; }

        if (fcnt > 0) {
            System.out.println(fcnt + "F(MInheritance2.java)");
        }
    }
}

interface MInheritance3IF {
    //@ requires x > 10;
    void m(int x);
}

class MInheritance3Super implements MInheritance3IF {
    //+@ also
    //@    requires x < -10;
    public void m(int x) {}
}

// @(#)$Id: MInheritance3.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
