import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class ModelField1 extends ModelField1Helper {
    //@ public model int val;    
    //@ public represents super.val <- v1;
    //@ public represents val <- v2;
    
    public int v1 = 10;
    public int v2 = 20;

    //@ requires super.val == 10 && val == 20;
    public void m1() {}

    //@ requires super.val != 10;
    public void m2() {}

    //@ requires val != 20;
    public void m3() {}

    public static void main(String args[]) {
	ModelField1 exp = new ModelField1();
	int fcnt = 0;

	try {
	    exp.m1();
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(); fcnt++; } catch (JMLAssertionError e) { }
	try { exp.m3(); fcnt++; } catch (JMLAssertionError e) { }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelField1.java)");
        }
    }    
}

class ModelField1Helper {
    //@ public model int val;
}
