import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod6 extends ModelMethod6Super {

    //@ public model int theModel;
    //@                      in theRep;
    //@ represents theModel <- theRepFun();

    //@ requires x > theModel;
    void fun(int x) {
    }

    //@ public model int theModelOk;
    //@                      in theRep;
    //@ represents theModelOk <- theRepFunOk();

    //@ requires x > theModelOk;
    void funOk(int x) {
    }

    public static void main(String args[]) {
	ModelMethod6 test = new ModelMethod6();
	int fcnt = 0;

        // no assertion violation;
	try { test.fun(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation;
	try { test.fun(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.funOk(20); }
        catch (JMLAssertionError e) { fcnt++; }

        try { test.funOk(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod6.java)");
	}
    }
}

class ModelMethod6Super {
    protected /*@ spec_public @*/ int theRep = 10;

    /*@ pure protected model int theRepFun () {
      @   return theRep;
      @ }
      @*/

    protected /*@ pure @*/ int theRepFunOk() {
	return theRep;
    }
}

// @(#)$Id: ModelMethod6.java,v 1.3 2003/08/03 03:53:48 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
