import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod_bigint2 {
    //un-executable
    /*@ normal_behavior
      @ ensures \result == i + 1;
      @ public model pure \bigint binc(\bigint i);
      @*/ 

    /*@ public normal_behavior
      @  assignable \nothing;
      @  ensures  (\bigint)\result == binc(i);
      @*/
    public int inc(int i) {
	return i + 1;
    }

    public static void main(String args[]) {
	ModelMethod_bigint2 test = new ModelMethod_bigint2();
	int fcnt = 0;

        // no assertion violation
	try { test.inc(0); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // no assertion violation
	try { test.inc(Integer.MAX_VALUE);  }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod_bigint2.java)");
        }
    }

}



