import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class OldExpression11 {

    /*@ ensures x == \old(null);
      @*/
    void m1(Object x) { 
    }

    public static void main(String args[]) {
	OldExpression11 exp = new OldExpression11();
	int fcnt = 0;

	try {
            exp.m1(null);
        } catch (JMLAssertionError e) {
            fcnt++;
        }

        // postcondition violation
        try { exp.m1(new Object()); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldExpression11.java)");
	}
    }
}

// @(#)$Id: OldExpression11.java,v 1.2 2005/12/06 19:54:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
