import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// old expr in quantifiers w/o free vars
public class OldExpression5 {
    int x = 10;
    int[] v = new int[] { 11, 12, 13 };

    /*@ ensures
      @  (\forall int i; i >= 0 && i < v.length; v[i] > \old(x));
      @*/
    void m1() {
    }

    public static void main(String args[]) {
	OldExpression5 exp = new OldExpression5();
	int fcnt = 0;

	try {
            exp.m1();
        } catch (JMLAssertionError e) {
            fcnt++;
        }

	try {
            exp.x = 12; exp.m1(); fcnt++;
        } catch (JMLAssertionError e) {
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldExpression5.java)");
	}
    }
}

// @(#)$Id: OldExpression5.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
