import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// old expr in non-executable quantified expression

public class OldExpression7 {
    int cnt = 5;
    int[] v = new int[] { 0, 1, 2, 3, 4, 5, 6 };

    // non-executable
    /*@ ensures
      @  (\exists int i; i >= 0; \old(v[i]) == x);
      @*/
    void m1(int x) {
    }

    public static void main(String args[]) {
	OldExpression7 exp = new OldExpression7();
	int fcnt = 0;

	try { exp.m1(3); } catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(6); } catch (JMLAssertionError e) { }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldExpression7.java)");
	}
    }
}

// @(#)$Id: OldExpression7.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
