import org.jmlspecs.jmlrac.runtime.*;

public class OldVarAndMethodCall {
    /*@ pure @*/ int val() { return 0; }

    /*@ old int[] a = new int[] { 0, 1 };
      @ ensures a.length > 0;
      @*/
    void m1() {}

    /*@ old OldVarAndMethodCall s = new OldVarAndMethodCall();
      @ ensures s.val() > 0;
      @*/
    void m2() {}

    public static void main(String [] argv) {
	OldVarAndMethodCall test = new OldVarAndMethodCall();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.m2(); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldVarAndMethodCall.java)");
        }
    }
}
