import org.jmlspecs.jmlrac.runtime.*;

public class Signals4A {

    class E1 extends Throwable {}
    class E2 extends E1 {}

    //@ signals (E2 e) false;
    public Signals4A() throws E1 { throw new E1(); }

    //@ signals (E1 e) true;
    public Signals4A(int x) throws E1 { throw new E2(); }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation expected
	try { new Signals4A(); }
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) {}

        // no assertion violation expected
	try { new Signals4A(0); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (Throwable e2) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Signals4A.java)");
        }
    }
}
