import org.jmlspecs.jmlrac.runtime.*;

public class Undefined6 {
    //@ model boolean b;

    //@ requires b;
    void m1() {}

    //@ requires !b;
    void m2() {}

    public static void main(String args[]) {
	Undefined6 test = new Undefined6();
	int fcnt = 0;

        // no assertion violation, i.e., non-executable
        try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation, i.e., non-executable
        try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }
       
        if (fcnt > 0) {
            System.out.println(fcnt + "F(Undefined6.java)");
        }
    }
}

// @(#)$Id: Undefined6.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
