// contextual interpretation of \old expression

import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class UndefinedOld2 {

    //@ ensures b == \old((* informal description *)); // non-exe in \old
    void m1(boolean b) {}

    //@ ensures x == \old(10 + (c.isEmpty() ? 0 : 2)); // exception in \old
    void m2(int x) {}

    java.util.Collection c;

    public static void main(String args[]) {
	UndefinedOld2 test = new UndefinedOld2();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(false); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPostconditionError.class, e)) fcnt += 40; }
		catch (Throwable t) { fcnt++; }

        // precondition violation
	try { test.m2(0); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPostconditionError.class, e)) fcnt += 100; }
		catch (Throwable t) { fcnt++; }

        // precondition violation
	try { test.m2(-10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPostconditionError.class, e)) fcnt += 33; }
		catch (Throwable t) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(UndefinedOld2.java)");
	}
    }
}

// @(#)$Id: UndefinedOld2.java,v 1.3 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
