import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class bitwise_exp {

    //@ requires (x | y) > 0;
    void m1(int x, int y) {}

    //@ requires (x & y) > 0;
    void m2(int x, int y) {}

    //@ requires (x ^ y) > 0;
    void m3(int x, int y) {}

    public static void main(String args[]) {
	bitwise_exp exp = new bitwise_exp();
	int fcnt = 0;

	try { exp.m1(0,1); exp.m1(1,0); exp.m1(1,1); 
	      exp.m2(1,1); 
	      exp.m3(0,1); exp.m1(1,0); exp.m1(1,3); 
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(0,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(1,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(0,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(1,1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(bitwise_exp.java)");
	}
    }
}
