import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class conditional_and_exp {

    //@ requires true && x > 0;
    void m1(int x) {}

    //@ requires false && x > 0;
    void m2(int x) {}

    //@ requires x > 0 && true;
    void m3(int x) {}

    //@ requires x > 0 && x > 10;
    void m4(int x) {}

    public static void main(String args[]) {
	conditional_and_exp exp = new conditional_and_exp();
	int fcnt = 0;

	try { exp.m1(10); exp.m3(10); exp.m4(11); }
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(-10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(conditional_and_exp.java)");
	}
    }
}
