import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class constructor_spec {
    int x;

    //@ requires x == 0;
    //@ ensures x == 10;
    constructor_spec() {
	x = 10;
    }

    //@ requires x > 0;
    //@ ensures this.x > 10;
    constructor_spec(int x) {
	this();
	this.x = x;
    }

    //@ requires b;
    constructor_spec(boolean b) {
	super();
	x = 10;
    }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    new constructor_spec();
	    new constructor_spec(20); new constructor_spec(true);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { new constructor_spec(0); } catch (JMLAssertionError e) {}
	try { new constructor_spec(10); } catch (JMLAssertionError e) {}
	try { new constructor_spec(false); } catch (JMLAssertionError e) {}
	try { new constructor_spec(); } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(constructor_spec.java)");
    }
}
