import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class desugar_normal_behavior {

    // exceptional postcondition violation!
    //@ normal_behavior requires x > 0;
    /*@ pure @*/ void m1(int x) {
	throw new RuntimeException();
    }

    // postcondition violation!
    //@ exceptional_behavior requires x > 0;
    /*@ pure @*/ void m2(int x) {
    }

    public static void main(String args[]) {
	desugar_normal_behavior exp = new desugar_normal_behavior();
	int fcnt = 0;

	try { exp.m1(10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(desugar_normal_behavior.java)");
    }
}
