import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class equality_exp {

    //@ requires x == y;
    void m1(int x, int y) {}

    //@ requires x != y;
    void m2(int x, int y) {}

    //@ requires x > 0 == y > 0;
    void m3(int x, int y) {}

    //@ requires x > 0 != y > 0;
    void m4(int x, int y) {}

    public static void main(String args[]) {
	equality_exp exp = new equality_exp();
	int fcnt = 0;

	try { exp.m1(1,1); exp.m2(0,1);
	      exp.m3(1,3); exp.m4(1,-1); 
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(0,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(1,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(1,1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(equality_exp.java)");
	}
    }
}
