import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class equivalence_exp {

    //@ requires x >= 0 <==> y >= 0;
    void m1(int x, int y) {}

    //@ requires x >= 0 <=!=> y >= 0;
    void m2(int x, int y) {}

    //@ requires x >= 0 ==> y >= 0;
    void m3(int x, int y) {}

    //@ requires x >= 0 <== y >= 0;
    void m4(int x, int y) {}

    public static void main(String args[]) {
	equivalence_exp exp = new equivalence_exp();
	int fcnt = 0;

	try {
	    exp.m1(1,1);
	    exp.m2(1,-1);
	    exp.m3(1,1);
	    exp.m4(1,1);
	}
	catch (JMLAssertionError e) {
	    fcnt++;
	}

	try {
	    exp.m1(1,-1);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	try {
	    exp.m2(1,1);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	try {
	    exp.m3(1,-1);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	try {
	    exp.m4(-1,1);
	    fcnt++;
	}
	catch (JMLAssertionError e) {
	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(equivalence_exp.java)");
	}
    }
}
