import org.jmlspecs.jmlrac.runtime.JMLAssertionError;


public class final_var_in_const_precond {
    /*@ spec_public @*/ private final int v;

    //@ requires x > 0 && v >= 0; // should be legal to refer final var v?
    //@ ensures v == x;
    public final_var_in_const_precond(int x) { v = x;}

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    new final_var_in_const_precond(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(final_var_in_const_precond");
	}
    }
}
