import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

class inherit_post_super {
    //@ ensures x > 10;
    void m1(int x) {}

    //@ ensures x > 0;
    void m2(int x) {}

    void m3(int x) {}

    //@ ensures x > 10;
    void m4(int x) {}
}

public class inherit_post extends inherit_post_super {

    //+@ also
    //@    ensures x > 0;
    void m1(int x) {}

    //+@ also
    //@   ensures x > 10;
    void m2(int x) {}

    //+@ also
    //@    ensures x > 10;
    void m3(int x) {}

    void m4(int x) {}

    void m5(int x) {}

    public static void main(String args[]) {
	inherit_post exp = new inherit_post();
	int fcnt = 0;

	try {
	    exp.m1(20); exp.m2(20); exp.m5(10);
	    exp.m3(20); exp.m4(20);
	}
	catch (Throwable e) { fcnt++; }

	try { exp.m1(-10); fcnt++; }
        catch (JMLAssertionError e) {}
	catch (Throwable e) { fcnt++; }

	try { exp.m1(5); fcnt++; }
        catch (JMLAssertionError e) {}
	catch (Throwable e) { fcnt++; }

	try { exp.m2(-10); fcnt++; }
        catch (JMLAssertionError e) {}
	catch (Throwable e) { fcnt++; }

	try { exp.m2(5); fcnt++; }
        catch (JMLAssertionError e) {}
       	catch (Throwable e) { fcnt++; }

	try { exp.m3(10); fcnt++; }
        catch (JMLAssertionError e) {}
       	catch (Throwable e) { fcnt++; }

	try { exp.m4(10); fcnt++; }
        catch (JMLAssertionError e) {}
	catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(inherit_post.java)");
    }
}
