import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

class inherit_post_static_super {
    //@ ensures x > 10;
    static void m1(int x) {}

    //@ ensures x > 0;
    static void m2(int x) {}

    static void m3(int x) {}

    //@ ensures x > 10;
    static void m4(int x) {}
}

public class inherit_post_static extends inherit_post_static_super {

    //@ ensures x > 0;
    static void m1(int x) {}

    //@ ensures x > 10;
    static void m2(int x) {}

    //@ ensures x > 10;
    static void m3(int x) {}

    static void m4(int x) {}

    static void m5(int x) {}

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    inherit_post_static.m1(20); inherit_post_static.m1(5);
	    inherit_post_static.m2(20); inherit_post_static.m5(10);
	    inherit_post_static.m3(20); inherit_post_static.m4(20);
	    inherit_post_static.m4(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { inherit_post_static.m1(-10); fcnt++; }
        catch (JMLAssertionError e) {}

	try { inherit_post_static.m2(-10); fcnt++; }
        catch (JMLAssertionError e) {}

	try { inherit_post_static.m2(5); fcnt++; }
        catch (JMLAssertionError e) {}

	try { inherit_post_static.m3(10); fcnt++; }
        catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(inherit_post_static.java)");
    }
}
