import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

class inherit_pre_constructor_super {
    //@ requires x > 0;
    inherit_pre_constructor_super(int x) {}
}

public class inherit_pre_constructor extends inherit_pre_constructor_super {

    //@ requires x > 10;
    inherit_pre_constructor(int x) { super(x); }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    new inherit_pre_constructor(20);
	}
	catch (Throwable e) { fcnt++; }
	
	// constructor's spec is not inherited
	try { new inherit_pre_constructor(5); fcnt++; }
        catch (JMLAssertionError e) {}
        catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(inherit_pre_constructor.java)");
    }
}

// @(#)$Id: inherit_pre_constructor.java,v 1.1 2003/01/22 04:20:58 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
