import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class innerclass {
    static class T {
	T(int x, int y) { this.x = x; this.y = y; }
	/*@ pure @*/ int val() { return x * y; }
	int x, y;
	
	static class T1 {
	    T1(int x, int y) {}
	}
    }
    int v1, v2;

    // JNewObjectExpression
    //@ requires o != new T.T1(10,20);
    void m1(Object o) {}

    // JNewArrayExpression
    //@ requires o != new int[] {0, (int)(v1 + v2), (int)(v1 * v2) };
    void m2(Object o) {}

    // JNewAnonymousClassExpression
    //@ requires new T(x,y) { int val() { return (int)(x + y); } }.val() > 10;
    void m3(int x, int y) {}

    public static void main(String args[]) {
	innerclass exp = new innerclass();
	int fcnt = 0;
	Integer i = new Integer(10);

	try { exp.m1(i); exp.m2(i); exp.m3(5, 6);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m3(5, 5); fcnt++; } catch (JMLAssertionError e) {}
	//try { exp.m2(-1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(innerclass.java)");
	}
    }
}
