import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

interface invariant_spec_intf_I {
    /*@ pure @*/ int val();
    //@ public invariant val() > 0;
}

public class invariant_spec_intf implements invariant_spec_intf_I {

    public /*@ pure @*/ int val() { return val; }
    
    void m() {}
    public int val = 10;

    public static void main(String args[]) {
	invariant_spec_intf o = new invariant_spec_intf();
	int fcnt = 0;

	try { o.val = 10; o.m(); }
	catch (Throwable e) { fcnt++; }

	try { o.val = -10; o.m(); fcnt++; }
	catch (JMLAssertionError e) {}
	catch (Throwable e) { fcnt++; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(invariant_spec_intf.java)");
    }
}
