import org.jmlspecs.jmlrac.runtime.*;

public class model_field_intf5 implements model_field_intf5_intf {
    public void m1(int x) {}

    public static void main(String args[]) {
	model_field_intf5 exp = new model_field_intf5();
	int fcnt = 0;

        // no assertion violation
	try { exp.m1(20); }
	catch (Throwable e) { fcnt++; }

        // postcondition violation
	try { exp.m1(5); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (Throwable e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(model_field_intf5.java)");
        }
    }    
}

interface model_field_intf5_intf extends model_field_intf5_intf1 {
    //@ public represents val <- 10;

    //@ requires x > val;
    void m1(int x);
}

interface model_field_intf5_intf1 {
    //@ public model instance int val;
}

// @(#)$Id: model_field_intf5.java,v 1.1 2003/01/22 04:20:58 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
