import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class negation_exp {

    //@ requires isPositive(x);
    void m1(int x) {}

    //@ requires !isPositive(x);
    void m2(int x) {}

    //@ requires !(!isPositive(x));
    void m3(int x) {}

    /*@ pure @*/ boolean isPositive(int x) {
	if (x < 0)
	    throw new RuntimeException();
	return true;
    }

    public static void main(String args[]) {
	negation_exp exp = new negation_exp();
	int fcnt = 0;

	try { exp.m1(1); exp.m3(1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(-1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(negation_exp.java)");
	}
    }
}
