import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class non_null_field3 {
    static /*@ non_null @*/ Object obj1 = new Object();
    static /*@ non_null @*/ Object obj2 = new Object();

    non_null_field3(boolean b1, boolean b2) {
	obj1 = b1 ? new Object() : null;
	obj2 = b2 ? new Object() : null;
    }

    void m1() {}

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    non_null_field3 f = new non_null_field3(true, true);
	    f.m1();
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { new non_null_field3(true, false); fcnt++; } 
	catch (JMLAssertionError e) {}

	try { new non_null_field3(false, true); fcnt++; } 
	catch (JMLAssertionError e) {}

	try { new non_null_field3(false, false); fcnt++; } 
	catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(non_null_field3.java)");

	obj1 = new Object();
	obj2 = new Object();
    }
}
