import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class non_null_field4 {
    //@ invariant x > 0;
    static int x;

    static /*@ non_null @*/ Object obj1 = new Object();
    static /*@ non_null @*/ Object obj2 = new Object();

    non_null_field4(boolean b1, boolean b2) {
	obj1 = b1 ? new Object() : null;
	obj2 = b2 ? new Object() : null;
	x = 10;
    }

    void m1(int x) { this.x = x; }

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    non_null_field4 f = new non_null_field4(true, true);
	    f.m1(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { 
	    non_null_field4 f = new non_null_field4(true, true);
	    f.m1(-10);
	    fcnt++;
	}
	catch (JMLAssertionError e) {}

	try { new non_null_field4(true, false); fcnt++; } 
	catch (JMLAssertionError e) {}

	try { new non_null_field4(false, true); fcnt++; } 
	catch (JMLAssertionError e) {}

	try { new non_null_field4(false, false); fcnt++; } 
	catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(non_null_field4.java)");

	obj1 = new Object();
	obj2 = new Object();
    }
}
