import org.jmlspecs.jmlrac.runtime.*;

public class nonnullelements_exp {

    //@ requires \nonnullelements(x);
    void doIt1(Integer[] x) {}

    //@ requires \nonnullelements(x);
    void doIt2(Object[] x) {}

    public static void main(String args[]) {
	nonnullelements_exp exp = new nonnullelements_exp();
	int fcnt = 0;

	try {
	    Integer ia[] = null;
	    exp.doIt1(ia);
	    fcnt += 1;
	}
	catch (JMLAssertionError e) {}

	try {
	    Object  oa[] = null;
	    exp.doIt2(oa);
	    fcnt += 10;
	}
	catch (JMLAssertionError e) {}

	try {
	    Integer a[] = { new Integer(10) };
	    exp.doIt1(a);
	}
	catch (JMLAssertionError e) { fcnt += 100; }

	try {
	    Object x[] = { new Object() };
	    exp.doIt2(x);
	}
	catch (JMLAssertionError e) { fcnt += 1000; }

	try {
	    Object y[] = { new Object(), null };
	    exp.doIt2(y);
	    fcnt += 10000;
	} catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(nonnullelements_exp.java)");
    }
}
