import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class null_exp {

    //@ requires null == o;
    void m1(/*@ nullable @*/ Object o) {}

    //@ requires o == null;
    void m2(/*@ nullable @*/ Object o) {}

   //@ requires null == null;
    void m3() {}

    //@ requires null instanceof String;
    void m4() {}

    //@ requires isNull(o);
    void m5(/*@ nullable @*/ Object o) {}

    //@ requires new T(null, o).val();
    void m6(Object o) {}


    //@ requires isNull(null);
    void m7() {}

    /*@ pure @*/ boolean isNull(Object o) {
	return o == null;
    }

    class T {
	T(/*@ nullable @*/ Object o1, Object o2) {}
	/*@ pure @*/ boolean val() { return true; }
    }

    public static void main(String args[]) {
	null_exp exp = new null_exp();
	int fcnt = 0;

	try { 
	    exp.m1(null); exp.m2(null); exp.m3(); exp.m5(null);
	    exp.m6(new Integer(0)); exp.m7();
	}
	catch (JMLAssertionError e) { fcnt++; }

	try {
            exp.m1(new Integer(0)); fcnt++;
        } catch (JMLAssertionError e) {}
	try {
            exp.m2(new Integer(0)); fcnt++;
        } catch (JMLAssertionError e) {}
	try {
            exp.m4(); fcnt++;
        } catch (JMLAssertionError e) {}
	try {
            exp.m5(new Integer(0)); fcnt++;
        } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(null_exp.java)");
	}
    }
}
