import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class old_exp_sub {

    class data {
	public data(int val) { this.val = val; }
	public int val;
    }

    data d = new data(0);

    //@ requires d != null;
    //@ ensures d.val == \old(d).val + x;
    void m1(int x) {
	d = new data(x + d.val);
    }

    //@ requires d != null;
    //@ ensures d.val == \old(d).val + x;
    void m2(int x) {
	d = new data(x + d.val + 1);
    }

    public static void main(String args[]) {
	old_exp_sub exp = new old_exp_sub();
	int fcnt = 0;

	try {
	    exp.m1(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(old_exp_sub.java)");
    }
}
