import org.jmlspecs.jmlrac.runtime.*;

public class postcond_exception {
    public int m1(int x) {
        return m2(x);
    }

    //@ ensures \result > 0;
    public int m2(int x) {
        return x;
    }

    public static void main(String args[]) {
	postcond_exception exp = new postcond_exception();
	int fcnt = 0;

        // internal postcondition violation
	try { exp.m1(-10); fcnt++; } 
        catch (JMLPostconditionError e) {}

        // exit precondition violation
	try { exp.m2(-10); fcnt++; } 
        catch (JMLPostconditionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(postcond_exception.java)");
    }
}
