import org.jmlspecs.jmlrac.runtime.*;

public class precond_exception {
    public int m1(int x) {
        return m2(x);
    }

    //@ requires x > 0;
    public int m2(int x) {
        return x;
    }

    public static void main(String args[]) {
	precond_exception exp = new precond_exception();
	int fcnt = 0;

        // internal precondition violation
	try { exp.m1(-10); fcnt++; } 
        catch (JMLInternalPreconditionError e) {}

        // entry precondition violation
	try { exp.m2(-10); fcnt++; } 
        catch (JMLEntryPreconditionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(precond_exception.java)");
    }
}
