import org.jmlspecs.jmlrac.runtime.*;

public class rac_sideeffect {

    //@ requires (\sum byte y; 0 < y && y <= x; y) == sum;
    void m1(byte x, byte sum) {}
    
    //@ requires (\sum int y; 0 < y && y <= x; y) == sum;
    void m2(int x, int sum) {}

    public static void main(String args[]) {
	rac_sideeffect exp = new rac_sideeffect();
	int fcnt = 0;

	if(JMLRacUtil.oldSem()){
		
		try { exp.m1((byte)2,(byte)0); fcnt++; } catch (JMLAssertionError e) {}
		try { exp.m2(2,0); fcnt++; } catch (JMLAssertionError e) {}

	} else {

		try { exp.m1((byte)2,(byte)0); } catch (JMLAssertionError e) { fcnt++; }
		try { exp.m2(2,0); } catch (JMLAssertionError e) { fcnt++; }

	}
	
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(rac_sideeffect.java)");
	}
    }
}
