import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class relational_exp {

    //@ requires x > y;
    void m1(int x, int y) {}

    //@ requires x >= y;
    void m2(int x, int y) {}

    //@ requires x < y;
    void m3(int x, int y) {}

    //@ requires (x <= y) && (x <= y);
    void m4(int x, int y) {}

    public static void main(String args[]) {
	relational_exp exp = new relational_exp();
	int fcnt = 0;

	try { exp.m1(2,1); exp.m2(0,0);
	      exp.m3(1,2); exp.m4(0,0); 
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(0,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(0,1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(1,0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(1,0); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(relational_exp.java)");
	}
    }
}
