import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_case {

    //@  requires x == 0; ensures \result == 0;
    //@ also 
    //@   requires x < 0; ensures \result == -1;
    //@ also 
    //@   requires x > 0; ensures \result == 1;
    int m1(int x) {
	if (x == 0)
	    return 0;
	else if (x > 0)
	    return 1;
	else
	    return -1;
    }

    //@ ensures x > 0; also ensures x > 10;
    int m2(int x) { return x; }

    public static void main(String args[]) {
	spec_case exp = new spec_case();
	int fcnt = 0;

	try {
	    exp.m1(0); exp.m1(1); exp.m1(-1); exp.m2(11);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_case.java)");
    }
}
