import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_protected extends spec_protected_super {
    //@ ensures val > 0;
    void m1(int x) { setVal(x); }

    public static void main(String args[]) {
	spec_protected exp = new spec_protected();
	int fcnt = 0;

	try {
	    exp.m1(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_protected.java)");
    }    
}

class spec_protected_super {
    // should be private, but to get around the JML type checker
    private /*@ spec_protected @*/ int val = 10;
    protected void setVal(int x) { val = x; }
}
