import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_public4 extends spec_public4_super {
    protected /*@ spec_public @*/ int val = 0;

    //@ ensures val > 0;
    void m1(int x) { val = x; }

    //@ ensures this.val > 0;
    void m2(int x) { val = x; }

    //@ ensures super.val > 0;
    void m3(int x) { setVal(x); }

    public static void main(String[] args) {
	spec_public4 exp = new spec_public4();
	int fcnt = 0;

	try {
	    exp.m1(10);
	    exp.m2(10);
	    //exp.m3(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(-10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_public4.java)");
    }    
}

class spec_public4_super {
    protected /*@ spec_public @*/ int val;
    protected void setVal(int x) { val = x; }
}
