import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class spec_var_decls {

    //@ old int v1 = 10;
    //@ requires x > v1;
    void m1(int x) {}

    //@ old int v2 = 10;
    //@ requires x > v2;
    void m2(int x) {}

    // Okay, not executable!
    //@ forall int v3;
    //@ requires v3 > 10;
    void m3() {}

    //@ old int v4 = 10;
    //@ requires v4 == 10;
    //@ ensures x > v4;
    void m4(int x) {}

    public static void main(String args[]) {
	spec_var_decls exp = new spec_var_decls();
	int fcnt = 0;

	try {
	    exp.m1(20); exp.m2(20); exp.m3(); exp.m1(20);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_var_decls.java)");
    }
}
