import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class static_invariant_spec {

    //@ static invariant val > 0;
    static int val = 10;
    
    //@ invariant val_i > 0;
    int val_i = -10;

    static void m1(int x) { val = x; }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    static_invariant_spec.m1(1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { static_invariant_spec.m1(0); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(static_invariant_spec.java)");

	val = 100;
    }
}
