import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class static_meth {
    static int x = 10;
    
    //@ ensures x == \old(x) + 10;
    static void m1() { x = x + 10; }

    //@ ensures x != \old(x + 10);
    static void m2() { x = x + 10; }

    //@ old int oldX = x;
    //@ requires x > 0;
    //@ ensures x > oldX;
    static void m3() { x = x + 10; }

    //@ old int v = (int)(x + 10);
    //@ ensures x == \old(x + v);
    static void m4() { x = x + x + 10; }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    static_meth.m1(); static_meth.m3(); static_meth.m4();
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { static_meth.m2(); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(static_meth.java)");
    }
}
