import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class unary_exp {

    //@ requires +x  > 0;
    void m1(int x) {}

    //@ requires -x > 0;
    void m2(int x) {}

    //@ requires (~x & 1) > 0;
    void m3(int x) {}

    //@ requires !(x > 0);
    void m4(int x) {}

    public static void main(String args[]) {
	unary_exp exp = new unary_exp();
	int fcnt = 0;

	try { exp.m1(1); exp.m2(-1); exp.m3(0); 
	      exp.m4(-1);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(1); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(unary_exp.java)");
	}
    }
}
