/* 
 * Copyright (C) 2000-2004 Iowa State University
 * This file is part of mjc, the MultiJava Compiler
 * 
 * based in part on work:
 * Copyright (C) 1990-2001 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: SignatureParser.java,v 1.2 2004/04/12 21:00:43 tongjie Exp $
 */

package org.multijava.mjc;

public interface SignatureParser {
    
    ClassSignature parseClassSignature(String signature);
    
    class ClassSignature {
	public ClassSignature(CClassType st, CClassType[] ifes, CTypeVariable[] tv) {
	    superType = st;
	    interfaces = ifes;
	    typeVariables = tv;
	}
	
	public final CClassType             superType;
	public final CClassType[]           interfaces;
	public final CTypeVariable[]        typeVariables;
    }
    
}
