#!/bin/sh
	
# Tests various combinations of naming, not naming, and reordering of
# files of command line.

#echo ... Testing BytecodeAttr1.sh

# compiled together we should detect ambiguity
rm -f BytecodeAttr1A.class BytecodeAttr1C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr1A.java BytecodeAttr1C.java

rm -f BytecodeAttr1A.class BytecodeAttr1C.class
# should get an error
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr1C.java BytecodeAttr1A.java

# compiled separately we should detect ambiguity
rm -f BytecodeAttr1A.class BytecodeAttr1C.class
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr1A.java
java org.multijava.mjc.Main $USERMJCFLAGS BytecodeAttr1C.java # should get an error
