class CallFromInit1A { 
	static { 
		new CallFromInit1C();
	}
} 

void CallFromInit1A.callFromInit1() {
	System.out.println("A"); 
} 

class CallFromInit1B extends CallFromInit1A {
	static { // something to test code gen
		int x = 0;
		x++;
		System.out.println(x);
	}

	void callFromInit1() {
		System.out.println("B");
	} 

	public static void main(String[] args) { new CallFromInit1C(); }
}

class CallFromInit1C  { 
	// Should print B, but prints A when instance is constructed by
	// the static initializer of A (since B's static initialization has not yet
	// set up the chain of responsibility).
	CallFromInit1C() { 
		CallFromInit1B b = new CallFromInit1B();
		b.callFromInit1();
	}
}

