public class LocalSub1 {
    public static void main (final String[] args) {
	class Sup {
	    public String toString() {
		return "Sup: " +  (args.length > 0 ? args[0] : "no args");
	    }
	};

	class Sub1 extends Sup {
	    public String toString() {
		return "Sub1: " +  super.toString();
	    }
	};

	class Sub2 extends Sup {
	    public String toString() {
		return "Sub2: " + (args.length > 0 ? args[0] : "no args") + 
		    super.toString();
	    }
	};

	System.out.println(new Sup());
	System.out.println(new Sub1());
	System.out.println(new Sub2());
    }
}
