public class LocalSub2 {
    public static void main (final String[] args) {
	class Sup {
	    private int x;
	    public Sup() { }

	    public Sup(int x) {
		this();
		this.x = x;
	    }

	    public String toString() {
		return "Sup-" + x + ": " +  
		    (args.length > 0 ? args[0] : "no args");
	    }
	};

	class Sub1 extends Sup {
	    private int x;
	    public Sub1() { }

	    public Sub1(int x) {
		this();
		this.x = x;
	    }

	    public String toString() {
		return "Sub1-" + x + ": " +  super.toString();
	    }
	};

	class Sub2 extends Sup {
	    private int x;
	    public Sub2() { }

	    public Sub2(int x) {
		this();
		this.x = x;
	    }

	    public String toString() {
		return "Sub2-" + x + ": " + 
		    (args.length > 0 ? args[0] : "no args") + super.toString();
	    }
	};

	System.out.println(new Sup(1));
	System.out.println(new Sub1(1));
	System.out.println(new Sub2(1));
    }
}
