package org.multijava.mjc.testcase.java5.generics;

/*
 * Make sure capture conversion is only applied to the toplevel wildcard type
 * arguments thereby allowing the below assignments.
 */
public class WildcardCapture3OK<T> {

    T t;

    WildcardCapture3OK<WildcardCapture3OK<?>> b1;

    WildcardCapture3OK<WildcardCapture3OK<? extends Integer>> b2;

    WildcardCapture3OK<WildcardCapture3OK<? super Integer>> b3;

    WildcardCapture3OK<WildcardCapture3OK<? extends Number>> b4;

    WildcardCapture3OK<WildcardCapture3OK<? super Number>> b5;

    public void foo() {
        b1.t = b2.t;
        b1.t = b3.t;
        b1.t = b4.t;
        b1.t = b5.t;

        b3.t = b5.t;

        b4.t = b2.t;
    }
}
