package org.multijava.mjc.testcase.java5.generics;

/*
 * Make sure capture conversion is only applied to the toplevel wildcard type
 * arguments thereby allowing the below assignments.
 */
public class WildcardCapture4OK<T> {

    T t;

    WildcardCapture4OK<WildcardCapture4OK<?>> b1;

    WildcardCapture4OK<WildcardCapture4OK<? extends Integer>> b2;

    WildcardCapture4OK<WildcardCapture4OK<? super Integer>> b3;

    WildcardCapture4OK<WildcardCapture4OK<? extends Number>> b4;

    WildcardCapture4OK<WildcardCapture4OK<? super Number>> b5;

    public void foo() {
        b1.t = new WildcardCapture4OK<Number>();
        b1.t = new WildcardCapture4OK<Integer>();

        b2.t = new WildcardCapture4OK<Integer>();

        b3.t = new WildcardCapture4OK<Number>();
        b3.t = new WildcardCapture4OK<Integer>();

        b4.t = new WildcardCapture4OK<Number>();
        b4.t = new WildcardCapture4OK<Integer>();

        b5.t = new WildcardCapture4OK<Number>();
    }
}
