package org.multijava.mjc.testcase.java5.generics;

import java.math.BigInteger;
import java.util.Collection;

public class WildcardTypeArguments2OK<T extends Number & Collection> {

    public void foo() {
        WildcardTypeArguments2OK<?> b1;

        // Neither Number nor BigInteger actually implement the interface
        // Collection but none of them is final meaning that there may be
        // subtypes of each of them which actually do implement Collection.
        // Therefore, wildcards having an upper bound of Number or BigInteger
        // are both fine.

        WildcardTypeArguments2OK<? extends Number> b2;

        WildcardTypeArguments2OK<? extends BigInteger> b3;
    }
}
