package org.multijava.mjc.testcase.java5.generics;

import java.io.Serializable;

/*
 * Check invocations with wildcards having an array in its bound.
 * We check for all supertypes of an array: Object, Cloneable, Serializable.
 */
public class WildcardTypeArguments4OK<T,
                                      U extends Cloneable,
                                      V extends Serializable> {

    public void foo() {
        WildcardTypeArguments4OK<? super String[],
                                 ? extends Integer[][],
                                 ? super Cloneable[][]> w1;
    }
}
