package org.multijava.mjc.testcase.runtime;

class CallFromInit1A { 
	static { 
		new CallFromInit1C();
	}
} 

void CallFromInit1A.callFromInit1() {
	System.out.println("A"); 
} 

public class CallFromInit1/*B*/ extends CallFromInit1A {
	void callFromInit1() {
		System.out.println("B");
	} 

	public static void main(String[] args) { new CallFromInit1C(); }
}

class CallFromInit1C  { 
	// Should print B, but prints A when instance is constructed by
	// the static initializer of A (since B's static initialization has not yet
	// set up the chain of responsibility).
	CallFromInit1C() { 
		CallFromInit1A cfi = new CallFromInit1A();
		cfi.callFromInit1();
		cfi = new CallFromInit1();
		cfi.callFromInit1();
	}
}

