#!/bin/sh
	
# Tests various permutations on upcalls, from Clifton-01, Figures 24 and 25

echo ... Testing Upcalls.sh

# Clean up 
rm -f Upcalls*.class
rm -f extGF3*.class

# Compile, suppressing cautions
${JAVA} org.multijava.mjc.Main -w0 $USERMJCFLAGS Upcalls*.java || exit

# Execute (skipping tests that do not yet pass)
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_i1
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_i2
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_i3
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_i3b

${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_e1
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_e2
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_e3
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_e3b
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_s_e4


${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_o_i1
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_o_i2

${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_o_e1
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_o_e2
${JAVA} org.multijava.mjc.testcase.runtime.Upcalls_o_e3
