// external generic function extGF3 adapted from Clifton-01, Figures 24 and 25

package org.multijava.mjc.testcase.runtime;

import org.multijava.mjc.testcase.runtime.upcalls.A;
import org.multijava.mjc.testcase.runtime.upcalls.B;

void A.extGF3() {
    System.out.println("In A::extGF3()");
}

void B.extGF3() {
    System.out.println("In B::extGF3()");
    super.extGF3();
}

public class Upcalls_s_e4 {
    public static void main (String[] args) {
	new A().extGF3();
	new B().extGF3();
    }
}
