// Local variables can be ghost or model? What about other
// JML-specific modifiers such as pure, non-null, spec_public,
// spec_protected, etc? Nothing is checked by JML type checker now.

package org.multijava.mjc.testcase.typecheck;

public class LocalVariablesAndModifiers {
    void m1() {
        int x0;
        final int x1;

        synchronized int x2;
        native int x3;

        public int x4;
        protected int x5;
        private int x6;

        volatile int x7;
        transient int x8;

        static int x9;
        abstract int x10;

        final static int x11;

    }
}

// @(#)$Id: LocalVariablesAndModifiers.java,v 1.5 2004/01/16 23:21:16 cclifton Exp $
//
// Copyright (C) 2004 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
