// resend from static methods

package org.multijava.mjc.testcase.typecheck;

class Resend7A { 
    static void m1() { }
}

public class Resend7 extends Resend7A {
    static void m2( Object o ) {
	System.out.println("Object: " + o.toString());
    }
    
    static void m2( final Object@Number n ) {
	System.out.print("Number: ");
	resend(n);		// OK
    }
    
    static void m2( final Object@Integer i ) {
	System.out.print("Integer: ");
	resend(i);		// OK
    }

    static void m2( final Object@String s ) {
	Resend7.resend(s);	// error, no prefix allowed for static resend
    }


    static void m1() {
	resend();		// error, hides, but does not
				// override, Resend7A::m1()
    }
}
