#! /bin/sh

# This tests recovery from various errors - exercising the task catching-up mechanism
# when parsing errors occur - DRCok

# IF YOU MODIFY THIS FILE, YOU SHOULD MAKE THE CORRESPONDING CHANGES TO 
# testsTestCase.java

# cannot use $USERMJCFLAGS argument to mjc.Main, since this file is processed
# by some JUnit harnesses that don't know about it
	
for a in 	"OK.java OK2.java" \
		"OK.java BadParse.java BadParse2.java OK2.java" \
		"NoSuper.java OK.java" \
		"OKSuper.java OK.java" \
		"BadSuper.java OK.java" \
		"OKSuperSuper.java OK.java" \
		"BadSuperSuper.java OK.java" \
		"BadBody.java" \
	; do

	echo TESTING $a
	java org.multijava.mjc.Main -classpath . -M -W $argv $a
done
