#!/bin/sh
	
# tests the sourcecode transformations applied to cast
# for normal references (arrays are tested in )

echo ... Testing array_cast.sh

rm -f array_cast*.class external.class functions.class

# compile this one *without* universe support
# it gets called later and simulates external non-universe aware libs
${JAVA} org.multijava.mjc.Main $USERMJCFLAGS external.java

# helper functions
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS functions.java

# cast peer
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_peer_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_peer_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_peer_fail1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_peer_fail1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_peer_fail2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_peer_fail2

# cast rep
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_rep_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_rep_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_rep_fail.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_rep_fail

# cast readonly (upcasts)
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_readonly_success1.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_readonly_success1

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_readonly_success2.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_readonly_success2

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS array_cast_readonly_success3.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.array_cast_readonly_success3
