#!/bin/sh
	
# tests if threads are handled well

# threads are special because their HashtableEntries
# store additional information

echo ... Testing thread.sh

rm -f thread*.class external.class

# compile this one *without* universe support
# it gets called later and simulates external non-universe aware libs
${JAVA} org.multijava.mjc.Main $USERMJCFLAGS external.java

# helper file
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS functions.java

# tests
${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS thread_universe_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.thread_universe_success

${JAVA} org.multijava.mjc.Main -universes $USERMJCFLAGS thread_native_success.java
${JAVA} org.multijava.mjc.testcase.universes.runtime.thread_native_success
