import base.*;

public class main extends Test
{
    static public void main(String args[])
    {	
	A a = new A();
	A b = new B();

	M m = new M();
	M n = new N();

	expect("A.X(M)");
	try {
	    check(a.X(m));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("B.X(M)");
	try {
	    check(b.X(m));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("A.X(M@N)");
	try {
	    check(a.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect_error("invoking method on ambiguously defined arguments");
	try {
	    check(b.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect("A.X(M,M)");
	try {
	    check(a.X(m, m));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("A.X(M@N,M)");
	try {
	    check(a.X(n, m));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("A.X(M,M@N)");
	try {
	    check(a.X(m, n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect_error("invoking method on ambiguously defined arguments");
	try {
	    check(a.X(n, n));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	C d = new D();
	expect("D.X()");
	try {
	    check(d.X());
	} catch (Exception ex) {
	    check_exn(ex);
	}

	C e = new E();
	expect("E.X()");
	try {
	    check(e.X());
	} catch (Exception ex) {
	    check_exn(ex);
	}

	C f = new F();
	expect("F.X()");
	try {
	    check(f.X());
	} catch (Exception ex) {
	    check_exn(ex);
	}

	C g = new G();
	expect_error("invoking abstract top-level method");
	try {
	    check(g.X());
	} catch (Exception ex) {
	    check_exn(ex);
	}

	test_exit();
    }
}
