public class main extends Test
{
    static public void main(String args[])
    {
	M n = new N();
	M o = new O();

	A b = new B();
	expect("B.X(M@N)");
	try {
	    check(b.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("B.X(M)");
	try {
	    check(b.X(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A d = new D();
	expect("D.X(M)");
	try {
	    check(d.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("D.X(M)");
	try {
	    check(d.X(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

        System.out.println("CODE COMMENTED OUT: " +
			   "broken abstract internal methods");
/*
	A c = new C();
	expect("C.X(M@N)");
	try {
	    check(c.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("C.X(M@O)");
	try {
	    check(c.X(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A e = new E();
	expect_error("invoking abstract top-level method");
	try {
	    check(e.X(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect_error("invoking abstract top-level method");
	try {
	    check(e.X(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A f = new F();
	expect("F.Y(M@N)");
	try {
	    check(f.Y(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("F.Y(M@O)");
	try {
	    check(f.Y(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A g = new G();
	expect("G.Z(M@N)");
	try {
	    check(g.Z(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("G.Z(M@O)");
	try {
	    check(g.Z(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A h = new H();
	expect("H.W(M@N)");
	try {
	    check(h.W(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("H.W(M@O)");
	try {
	    check(h.W(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A r = new R();
	expect("R.U(Object@N)");
	try {
	    check(r.U(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("R.U(Object)");
	try {
	    check(r.U(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A s = new S();
	expect_error("invoking abstract top-level method");
	try {
	    check(s.V(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect_error("invoking abstract top-level method");
	try {
	    check(s.V(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	A t = new T();
	expect("T.V(M@N)");
	try {
	    check(t.V(n));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("T.V(M@O)");
	try {
	    check(t.V(o));
	} catch (Exception ex) {
	    check_exn(ex);
	}
*/

	// should cause a load-time warning...
	M p = new P();
	expect("B.X(M)");
	try {
	    check(b.X(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}
	expect("D.X(M)");
	try {
	    check(d.X(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

        System.out.println("CODE COMMENTED OUT: " +
			   "broken abstract internal methods");
/*
	expect_error("invoking abstract top-level method");
	try {
	    check(c.X(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(e.X(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(f.Y(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(g.Z(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(h.W(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(s.V(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}

	expect_error("invoking abstract top-level method");
	try {
	    check(t.V(p));
	} catch (Exception ex) {
	    check_exn(ex);
	}
*/

	test_exit();
    }
}
