package org.multijava.relaxed.util;

import java.util.HashSet;
import java.util.StringTokenizer;
import java.io.PrintStream;

public class RMJOptions
{
    // FLAGS
 
    // nocheck means we should not do any completeness or ambiguity
    // checking, but just load dispatchers when they become reachable
    static public boolean nocheck = false;
	// nonothing means we should emulate Java's class loader, with
	// no additional stuff
    static public boolean nonothing = false;

   // PRIVATE DATA

    static {
	String str = System.getProperty("RMJ_OPTION");
	if (str != null) {
	    if (str.equals("NOCHECK")) {
		nocheck = true;
	    } else if (str.equals("NONOTHING")) {
		nonothing = true;
	    } else {
		System.out.println("unexpected RMJ_OPTION flag " + str);
	    }
	}
    }
}
