package org.multijava.samples.basic;

/**
 * This class uses value dispatching to implement a simple state machine.
 */
public class EndsWithAA extends EndsWithA {
    public static void main (String[] args) {
	if (args.length != 1) {
	    System.err.println(USE);
	} else {
	    new EndsWithAA(args[0]).run();
	}
    }
    

    /**
     * Instantiates a state machine for processing the given input.
     */
    EndsWithAA(String input) {
	super(input);
    }

    boolean accepts(int@@1 finalState) {
	return false;
    }

    boolean accepts(int@@2 finalState) {
	return true;
    }

    int transition(int@@1 st, char@@'a' ch) { return 2; }
    int transition(int@@2 st, char@@'a' ch) { return 2; }
    int transition(int@@2 st, char@@'b' ch) { return 0; }
}
