package org.multijava.samples.cmb.query;

public OccuranceList ParseNode.processQueryOn(Index idx, Matcher catMatcher) {
    throw new UnsupportedOperationException( "query processing not " + 
					     "implemented for " + 
					     getClass() );
}

public OccuranceList BinOp.processQueryOn(Index idx, Matcher catMatcher) {
    OccuranceList leftResult = left.processQueryOn(idx,catMatcher);
    OccuranceList rightResult = right.processQueryOn(idx,catMatcher);
    return this.combineLR(leftResult,rightResult);
}

public OccuranceList QueryTerm.processQueryOn(Index idx, Matcher catMatcher) {
    return idx.find(term,catMatcher);
}

private OccuranceList BinOp.combineLR(OccuranceList leftResult, 
				      OccuranceList rightResult) {
    throw new UnsupportedOperationException();
}

private OccuranceList AndOp.combineLR(OccuranceList leftResult, 
				     OccuranceList rightResult) {
    return leftResult.intersect(rightResult);
}

private OccuranceList OrOp.combineLR(OccuranceList leftResult, 
				    OccuranceList rightResult) {
    return leftResult.union(rightResult);
}

private OccuranceList ButNotOp.combineLR(OccuranceList leftResult, 
					OccuranceList rightResult) {
    return leftResult.minus(rightResult);
}

